'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    raised: {
      boxShadow: 'none',
      backgroundColor: '#F4F2F1'
    },
    label: {
      justifyContent: 'space-between',
      alignItems: 'baseline',
      textTransform: 'none'
    },
    caption: {
      textTransform: 'none',
      fontWeight: 'bold'
    },
    value: {
      color: theme.palette.text.primary,
      whiteSpace: 'nowrap',
      textOverflow: 'ellipses',
      marginLeft: '10px'
    }
  };
};

/**
 * This button class displays a label and value
 */
/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
function ActionButton(_ref) {
  var label = _ref.label,
      value = _ref.value,
      children = _ref.children,
      classes = _ref.classes,
      props = (0, _objectWithoutProperties3.default)(_ref, ['label', 'value', 'children', 'classes']);
  var captionClass = classes.caption,
      valueClass = classes.value,
      otherClasses = (0, _objectWithoutProperties3.default)(classes, ['caption', 'value']);


  return _react2.default.createElement(
    _Button2.default,
    (0, _extends3.default)({ variant: 'raised', classes: otherClasses }, props),
    _react2.default.createElement(
      _Typography2.default,
      { variant: 'button', className: captionClass },
      label
    ),
    _react2.default.createElement(
      _Typography2.default,
      { variant: 'caption', className: valueClass },
      value
    )
  );
}

ActionButton.propTypes = {
  /**
   * The label to display on the left side of the button
   */
  label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  /**
   * The value to display on the right side of the button
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element])
};

exports.default = (0, _withStyles2.default)(styles)(ActionButton);
//# sourceMappingURL=ActionButton.js.map