'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Snackbar = require('@material-ui/core/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Close = require('@material-ui/icons/Close');

var _Close2 = _interopRequireDefault(_Close);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A button that when clicked adds the specified product to the cart
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {},
    docked: {
      fontSize: theme.typography.subheading.fontSize,
      padding: theme.margins.container + 'px',
      position: 'fixed',
      left: 0,
      bottom: 0,
      width: '100%',
      zIndex: 1,
      borderRadius: '0'
    },
    close: {
      width: theme.spacing.unit * 4,
      height: theme.spacing.unit * 4
    },
    confirmation: {
      padding: '2px 0'
    }
  };
};

var AddToCartButton = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFAddToCartButton' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      ampFormId = _ref.ampFormId;
  return { cart: app.cart, ampFormId: ampFormId };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(AddToCartButton, _Component);

  function AddToCartButton() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AddToCartButton);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = AddToCartButton.__proto__ || Object.getPrototypeOf(AddToCartButton)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      messageOpen: false
    }, _this.handleClose = function (event, reason) {
      if (reason === 'clickaway') return;
      _this.setState({ messageOpen: false });
    }, _this.onClick = function (e) {
      var onClick = _this.props.onClick;


      if (onClick) {
        onClick(e);
      }

      if (!e.defaultPrevented) {
        if (_this.props.confirmation) {
          _this.setState({ messageOpen: true });
        }
        _this.props.cart.add(_this.props.product);
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AddToCartButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          product = _props.product,
          ampFormId = _props.ampFormId,
          children = _props.children,
          classes = _props.classes,
          className = _props.className,
          cart = _props.cart,
          docked = _props.docked,
          confirmation = _props.confirmation,
          snackbarProps = _props.snackbarProps,
          other = (0, _objectWithoutProperties3.default)(_props, ['product', 'ampFormId', 'children', 'classes', 'className', 'cart', 'docked', 'confirmation', 'snackbarProps']);


      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          _Track2.default,
          { event: 'addedToCart', product: product },
          _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({
              key: 'button',
              variant: 'raised',
              color: 'secondary',
              size: 'large'
            }, other, {
              on: 'tap:' + ampFormId + '.submit',
              onClick: this.onClick,
              classes: { root: classes.root },
              className: (0, _classnames3.default)(className, (0, _defineProperty3.default)({}, classes.docked, docked))
            }),
            children || "Add to Cart"
          )
        ),
        _react2.default.createElement(_Snackbar2.default, (0, _extends3.default)({
          key: 'confirmation',
          open: this.state.messageOpen,
          autoHideDuration: 3000,
          onClose: this.handleClose,
          message: _react2.default.createElement(
            'div',
            { className: classes.confirmation },
            confirmation
          ),
          action: [_react2.default.createElement(
            _IconButton2.default,
            {
              key: 'close',
              'aria-label': 'Close',
              color: 'inherit',
              className: classes.close,
              onClick: this.handleClose
            },
            _react2.default.createElement(_Close2.default, null)
          )]
        }, snackbarProps))
      );
    }
  }]);
  return AddToCartButton;
}(_react.Component), _class2.propTypes = {
  /**
   * The product to add to the cart
   */
  product: _propTypes2.default.object,

  /**
   * Set to true to dock the button at the bottom of the viewport so that it is always visible
   */
  docked: _propTypes2.default.bool,

  /**
   * A message to display when an item is added to the cart.
   * Could be a string or react component
   */
  confirmation: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),

  /**
   * Props to be applied to the Snackbar element in which the confirmation message is displayed.
   */
  snackbarProps: _propTypes2.default.object
}, _class2.defaultProps = {
  docked: false,
  snackbarProps: {}
}, _temp2)) || _class) || _class) || _class);
exports.default = AddToCartButton;
//# sourceMappingURL=AddToCartButton.js.map