'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _lodash = require('lodash');

var _Toolbar = require('@material-ui/core/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _SvgIcon = require('@material-ui/core/SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _mobxReact = require('mobx-react');

var _Hidden = require('@material-ui/core/Hidden');

var _Hidden2 = _interopRequireDefault(_Hidden);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Box = require('./Box');

var _ToolbarButton = require('./ToolbarButton');

var _ToolbarButton2 = _interopRequireDefault(_ToolbarButton);

var _menu = require('./assets/menu.svg');

var _menu2 = _interopRequireDefault(_menu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      boxSizing: 'content-box',
      position: 'relative',
      zIndex: theme.zIndex.modal + 10
    },

    withAmp: {
      zIndex: theme.zIndex.amp.modal + 1
    },

    icon: {
      color: theme.palette.action.active
    },

    toolBar: {
      height: theme.headerHeight || '64px',
      padding: '0 7px',
      maxWidth: theme.maxWidth,
      flex: 1
    },

    wrap: {
      borderBottom: '1px solid ' + theme.palette.divider,
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      backgroundColor: theme.palette.background.paper,
      zIndex: theme.zIndex.modal + 10,
      display: 'flex',
      justifyContent: 'center'
    },

    stuck: {
      transform: 'translateY(0)'
    },

    unstuck: {
      transform: 'translateY(-100%)'
    },

    animate: {
      transition: 'transform .15s ease-in'
    },

    hidden: {
      position: 'fixed',
      zIndex: theme.zIndex.modal + 10,
      boxShadow: theme.shadows[2],
      top: 0,
      left: 0,
      right: 0
    },

    menuOpen: {
      boxShadow: 'none'
    },

    link: {
      textDecoration: 'none'
    }
  };
};

/**
 * A header that auto hides when the user scrolls down and auto shows when the user 
 * scrolls up. A hamburger button that controls the menu is automatically displayed on
 * the left side of the header.  Children are placed directly to the right of the menu
 * button.
 */
var Header = (_dec = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { menu: app.menu, amp: app.amp };
}), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFAppBar' }), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Header, _Component);

  function Header() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Header);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Header.__proto__ || Object.getPrototypeOf(Header)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      stuck: false,
      hidden: false,
      animate: false
    }, _this.onScroll = function () {
      var height = 64,
          _window = window,
          scrollY = _window.scrollY,
          _this2 = _this,
          lastScrollY = _this2.lastScrollY;var menu = _this.props.menu;


      if (_this.state.hidden) {
        if (scrollY <= 0) {
          _this.setState({ hidden: false, stuck: false, animate: false });
        }
      } else {
        if (scrollY > height && !menu.open) {
          _this.setState({ hidden: true });
        }
      }

      var unstickBufferZone = 15;

      if (_this.throttledScrollY > scrollY + unstickBufferZone && !_this.state.stuck) {
        _this.unstickAt = scrollY + unstickBufferZone;
        _this.setState({ stuck: true });
      } else if (scrollY > _this.unstickAt && _this.state.stuck && !menu.open) {
        _this.setState({ stuck: false });
        delete _this.unstickAt;
      }

      if (_this.lastScrollY > scrollY && _this.state.stuck) {
        _this.unstickAt = scrollY + unstickBufferZone;
      }

      _this.lastScrollY = scrollY;
      _this.sampleScrollSpeed();
    }, _this.sampleScrollSpeed = (0, _lodash.throttle)(function () {
      return _this.throttledScrollY = window.scrollY;
    }, 100), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Header, [{
    key: 'render',
    value: function render() {
      var _classnames, _classnames2;

      var _props = this.props,
          MenuIcon = _props.MenuIcon,
          classes = _props.classes,
          children = _props.children,
          fixed = _props.fixed,
          menu = _props.menu,
          responsive = _props.responsive,
          width = _props.width,
          amp = _props.amp,
          showLabels = _props.showLabels;


      var menuIcon = _react2.default.createElement(
        _SvgIcon2.default,
        { className: classes.icon },
        _react2.default.createElement(MenuIcon, null)
      );

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.root, true), (0, _defineProperty3.default)(_classnames, classes.withAmp, amp), _classnames)) },
        _react2.default.createElement(
          'div',
          { className: (0, _classnames4.default)((_classnames2 = {}, (0, _defineProperty3.default)(_classnames2, classes.wrap, true), (0, _defineProperty3.default)(_classnames2, classes.fixed, fixed), (0, _defineProperty3.default)(_classnames2, classes.hidden, this.state.hidden || menu.open), (0, _defineProperty3.default)(_classnames2, classes.stuck, this.state.hidden && this.state.stuck || menu.open), (0, _defineProperty3.default)(_classnames2, classes.unstuck, this.state.hidden && !this.state.stuck), (0, _defineProperty3.default)(_classnames2, classes.animate, this.state.animate), (0, _defineProperty3.default)(_classnames2, classes.menuOpen, menu.open), _classnames2)) },
          _react2.default.createElement(
            _Toolbar2.default,
            { disableGutters: true, classes: { root: classes.toolBar } },
            _react2.default.createElement(
              _Hidden2.default,
              { mdUp: responsive, implementation: 'css' },
              _react2.default.createElement(
                'a',
                { on: 'tap:moov_menu.toggle', className: classes.link },
                _react2.default.createElement(_ToolbarButton2.default, {
                  'aria-label': 'Menu',
                  color: 'inherit',
                  onClick: menu.toggle,
                  icon: menuIcon
                })
              )
            ),
            children
          )
        )
      );
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('scroll', this.onScroll, { passive: true });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.onScroll, { passive: true });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _this3 = this;

      if (!prevState.hidden && this.state.hidden) {
        setTimeout(function () {
          return _this3.setState({ animate: true });
        }, 100);
      }
    }
  }]);
  return Header;
}(_react.Component), _class2.propTypes = {
  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * Set to true to show the hamburger button only on mobile devices. Defaults to false.
   */
  responsive: _propTypes2.default.bool,

  /**
   * A component for the menu icon.
   */
  MenuIcon: _propTypes2.default.func
}, _class2.defaultProps = {
  responsive: false,
  MenuIcon: _menu2.default
}, _temp2)) || _class) || _class) || _class);
exports.default = Header;
//# sourceMappingURL=AppBar.js.map