'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _KeyboardArrowLeft = require('@material-ui/icons/KeyboardArrowLeft');

var _KeyboardArrowLeft2 = _interopRequireDefault(_KeyboardArrowLeft);

var _ViewAgenda = require('@material-ui/icons/ViewAgenda');

var _ViewAgenda2 = _interopRequireDefault(_ViewAgenda);

var _BorderAll = require('@material-ui/icons/BorderAll');

var _BorderAll2 = _interopRequireDefault(_BorderAll);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _analytics = require('./analytics');

var _analytics2 = _interopRequireDefault(_analytics);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _SearchResultsModelBase = require('./model/SearchResultsModelBase');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A header that allows the user to navigate back.  When a searchResults prop is provided, 
 * this component also allows the user to switch between grid and list views.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      padding: '12px',
      position: 'relative',
      display: 'flex',
      height: '48px',
      justifyContent: 'center',
      alignItems: 'center',
      borderTop: '1px solid ' + theme.palette.divider,
      zIndex: theme.zIndex.appBar - 1,

      '& a': {
        color: theme.palette.text.primary,
        textDecoration: 'none'
      }
    },
    label: {
      fontWeight: 'bold',
      fontSize: '18px',
      display: 'block',
      textAlign: 'center',
      textTransform: 'uppercase'
    },
    backButtonWrapper: {
      position: 'absolute',
      top: 0,
      left: '5px',
      bottom: 0,
      display: 'flex',
      alignItems: 'center'
    },
    switchButtonsWrapper: {
      position: 'absolute',
      display: 'flex',
      alignItems: 'center',
      top: 0,
      bottom: 0,
      right: '10px'
    },
    switchButton: {
      marginLeft: '5px',
      alignItems: 'center',
      display: 'flex',
      padding: '3px',
      borderRadius: '50%'
    },
    selectedSwitchButton: {
      backgroundColor: '#F4F2F1'
    }
  };
};

var BackNav = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFBackNav' }), _dec2 = (0, _mobxReact.inject)('history'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(BackNav, _Component);

  function BackNav() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, BackNav);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = BackNav.__proto__ || Object.getPrototypeOf(BackNav)).call.apply(_ref, [this].concat(args))), _this), _this.switchLayout = function (layout) {
      var searchResults = _this.props.searchResults;

      searchResults.switchLayout(layout);
    }, _this.onBack = function () {
      var _this$props = _this.props,
          history = _this$props.history,
          url = _this$props.url;


      if (url) {
        history.push(url);
      } else {
        history.goBack();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(BackNav, [{
    key: 'renderViewToggle',
    value: function renderViewToggle() {
      var _this2 = this;

      var _props = this.props,
          classes = _props.classes,
          searchResults = _props.searchResults;

      var layout = (0, _lodash.get)(searchResults, 'layout', _SearchResultsModelBase.LAYOUT_GRID);

      return searchResults ? _react2.default.createElement(
        'span',
        { className: classes.switchButtonsWrapper },
        _react2.default.createElement(
          'span',
          { className: (0, _classnames4.default)(classes.switchButton, (0, _defineProperty3.default)({}, classes.selectedSwitchButton, layout === _SearchResultsModelBase.LAYOUT_GRID)) },
          _react2.default.createElement(_BorderAll2.default, {
            color: layout === _SearchResultsModelBase.LAYOUT_GRID ? 'secondary' : 'primary',
            onClick: function onClick() {
              return _this2.switchLayout(_SearchResultsModelBase.LAYOUT_GRID);
            }
          })
        ),
        _react2.default.createElement(
          'span',
          { className: (0, _classnames4.default)(classes.switchButton, (0, _defineProperty3.default)({}, classes.selectedSwitchButton, layout === _SearchResultsModelBase.LAYOUT_LIST)) },
          _react2.default.createElement(_ViewAgenda2.default, {
            color: layout === _SearchResultsModelBase.LAYOUT_LIST ? 'secondary' : 'primary',
            onClick: function onClick() {
              return _this2.switchLayout(_SearchResultsModelBase.LAYOUT_LIST);
            }
          })
        )
      ) : null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          text = _props2.text,
          classes = _props2.classes;


      return _react2.default.createElement(
        _Paper2.default,
        { className: classes.root },
        _react2.default.createElement(
          _Typography2.default,
          { variant: 'caption' },
          _react2.default.createElement(
            'span',
            { onClick: function onClick() {
                _this3.onBack();
              }, className: classes.backButtonWrapper },
            _react2.default.createElement(_KeyboardArrowLeft2.default, null)
          ),
          _react2.default.createElement(
            'span',
            { className: classes.label },
            text
          ),
          this.renderViewToggle()
        )
      );
    }
  }]);
  return BackNav;
}(_react.Component), _class2.propTypes = {
  /**
   * The text to display representing the previous location.
   */
  text: _propTypes2.default.string.isRequired,

  /**
   * The url to navigate to when clicked.  If omitted, this component will navigate back in the history when clicked.
   */
  url: _propTypes2.default.string,

  /**
   * When displaying this component on a search results page (such as a subcategory), you can supply the SearchResultsModelBase instance here
   * and this component will allow you to switch between grid and list views.
   */
  searchResults: _propTypes2.default.shape({
    layout: _propTypes2.default.string.isRequired
  })
}, _temp2)) || _class) || _class) || _class);
exports.default = BackNav;
//# sourceMappingURL=BackNav.js.map