'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


exports.Hbox = Hbox;
exports.Vbox = Vbox;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A flex container.  All additional props are spread to the style of the underlying div.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      display: 'flex'
    },
    split: {
      justifyContent: 'space-between',
      alignItems: 'center'
    }
  };
};

var Box = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFBox' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Box, _Component);

  function Box() {
    (0, _classCallCheck3.default)(this, Box);
    return (0, _possibleConstructorReturn3.default)(this, (Box.__proto__ || Object.getPrototypeOf(Box)).apply(this, arguments));
  }

  (0, _createClass3.default)(Box, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          classes = _props.classes,
          _props$split = _props.split,
          split = _props$split === undefined ? false : _props$split,
          children = _props.children,
          style = _props.style,
          other = (0, _objectWithoutProperties3.default)(_props, ['className', 'classes', 'split', 'children', 'style']);


      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames3.default)(classes.root, className, (0, _defineProperty3.default)({}, classes.split, split)),
          style: (0, _extends3.default)({}, other, style)
        },
        children
      );
    }
  }]);
  return Box;
}(_react.Component), _class2.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: _propTypes2.default.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: _propTypes2.default.bool
}, _temp)) || _class);

/**
 * A flex container with horizontal layout. All additional props are spread to the style 
 * of the underlying div.
 */

exports.default = Box;
function Hbox(props) {
  props = (0, _extends3.default)({}, props, { flexDirection: 'row' });
  return _react2.default.createElement(Box, (0, _extends3.default)({ alignItems: 'center' }, props));
}

Hbox.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: _propTypes2.default.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: _propTypes2.default.bool

  /**
   * A flex container with vertical layout. All additional props are spread to 
   * the style of the underlying div.
   */
};function Vbox(props) {
  props = (0, _extends3.default)({}, props, { flexDirection: 'column' });
  return _react2.default.createElement(Box, props);
}

Vbox.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: _propTypes2.default.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: _propTypes2.default.bool
};
//# sourceMappingURL=Box.js.map