'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _KeyboardArrowRight = require('@material-ui/icons/KeyboardArrowRight');

var _KeyboardArrowRight2 = _interopRequireDefault(_KeyboardArrowRight);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _mobxReact = require('mobx-react');

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _Container = require('./Container');

var _Container2 = _interopRequireDefault(_Container);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    breadcrumbs: {
      margin: '0',
      backgroundColor: '#F4F2F1',
      padding: '12px 0',

      '& a': {
        color: theme.palette.text.primary,
        textDecoration: 'none'
      }
    },

    separator: {
      height: '12px',
      position: 'relative',
      top: '3px',
      width: '16px'
    },

    current: {
      fontWeight: 'bold',
      color: theme.palette.text.primary
    }
  };
};

/**
 * Renders a list of breadcrumbs from AppModelBase.breadcrumbs.  When a breadcrumb is clicked, the breadcrumb_clicked
 * analytics event is automatically fired.
 */
var Breadcrumbs = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFBreadcrumbs' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Breadcrumbs, _Component);

  function Breadcrumbs() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Breadcrumbs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Breadcrumbs.__proto__ || Object.getPrototypeOf(Breadcrumbs)).call.apply(_ref, [this].concat(args))), _this), _this.renderBreadcrumb = function (item, i) {
      var classes = _this.props.classes;


      if (item.url) {
        return _react2.default.createElement(
          'span',
          { key: i },
          _react2.default.createElement(
            _Track2.default,
            { event: 'breadcrumbClicked', breadcrumb: item },
            _react2.default.createElement(
              _Link2.default,
              { to: item.url },
              item.text
            )
          ),
          _react2.default.createElement(_KeyboardArrowRight2.default, { className: classes.separator })
        );
      } else {
        return _react2.default.createElement(
          'span',
          { key: i, className: classes.current },
          item.text
        );
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Breadcrumbs, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          breadcrumbs = _props.app.breadcrumbs,
          items = _props.items,
          classes = _props.classes;


      breadcrumbs = items || breadcrumbs;

      if (!breadcrumbs || !breadcrumbs.length) return null;

      return _react2.default.createElement(
        _Typography2.default,
        { className: classes.breadcrumbs, variant: 'caption' },
        _react2.default.createElement(
          _Container2.default,
          null,
          breadcrumbs.map(this.renderBreadcrumb)
        )
      );
    }
  }]);
  return Breadcrumbs;
}(_react.Component), _class2.propTypes = {
  items: _propTypes2.default.arrayOf(_propTypes2.default.objectOf)
}, _temp2)) || _class) || _class) || _class);
exports.default = Breadcrumbs;
//# sourceMappingURL=Breadcrumbs.js.map