'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    buttons: {
      display: 'flex',
      flexWrap: 'wrap',
      margin: '-4px'
    },
    button: {
      position: 'relative',
      '& button': {
        border: '1px solid ' + theme.palette.divider,
        padding: 0,
        margin: '4px',
        width: '60px',
        minWidth: '60px',
        height: '40px',
        minHeight: '40px',
        boxShadow: 'none'
      }
    },
    buttonWithImage: {
      '& button': {
        width: '50px',
        minWidth: '50px',
        height: '50px',
        minHeight: '50px'
      }
    },
    selectedImage: {
      '& button': {
        borderWidth: '2px',
        borderColor: theme.typography.body1.color
      }
    },
    selected: {
      '& button': {
        borderColor: theme.palette.primary.main,
        backgroundColor: theme.palette.primary.main,
        color: theme.palette.primary.contrastText,
        '&:hover': {
          borderColor: theme.palette.primary.main,
          backgroundColor: theme.palette.primary.main,
          color: theme.palette.primary.contrastText
        }
      }
    },
    imageLabel: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      padding: '5px'
    },
    image: {
      height: '100%',
      width: '100%'
    },
    disabled: {
      backgroundColor: '#f2f2f2',
      color: '#999',
      '& img': {
        opacity: .5
      }
    },
    selectedName: {
      marginTop: '10px'
    },
    strikeThrough: {
      height: '7px',
      borderWidth: '2px 0',
      borderStyle: 'solid',
      borderColor: '#f2f2f2',
      backgroundColor: '#666',
      position: 'absolute',
      width: '100%',
      top: 'calc(50% - 3px)',
      borderRadius: '10px'
    }
  };
};

/**
 * A selector for product options rendered as a set of buttons. Buttons can either have 
 * text or an image. The text for the selected option can optionally be displayed below
 * the buttons.
 * 
 * This component supports AMP.
 */
var ButtonSelector = (_dec = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return { amp: app.amp, ampStateId: ampStateId };
}), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFButtonSelector' }), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(ButtonSelector, _Component);

  function ButtonSelector() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ButtonSelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = ButtonSelector.__proto__ || Object.getPrototypeOf(ButtonSelector)).call.apply(_ref2, [this].concat(args))), _this), _this.createButtonClass = function (isSelected, _ref3) {
      var _classnames;

      var image = _ref3.image,
          color = _ref3.color;
      var _this$props$classes = _this.props.classes,
          button = _this$props$classes.button,
          buttonWithImage = _this$props$classes.buttonWithImage,
          selectedImage = _this$props$classes.selectedImage,
          selected = _this$props$classes.selected;

      var swatch = (image || color) != null;

      return (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, button, true), (0, _defineProperty3.default)(_classnames, buttonWithImage, swatch), (0, _defineProperty3.default)(_classnames, selectedImage, isSelected && swatch), (0, _defineProperty3.default)(_classnames, selected, isSelected && !swatch), _classnames));
    }, _this.renderButton = function (option, i) {
      var _this$props = _this.props,
          classes = _this$props.classes,
          strikeThroughDisabled = _this$props.strikeThroughDisabled,
          strikeThroughAngle = _this$props.strikeThroughAngle,
          imageProps = _this$props.imageProps,
          buttonProps = _this$props.buttonProps,
          model = _this$props.model,
          ampStateId = _this$props.ampStateId,
          name = _this$props.name;

      var selected = model.selected && model.selected.id === option.id;

      var children = option.text;

      if (option.image) {
        children = _react2.default.createElement(_Image2.default, (0, _extends3.default)({ src: option.image, className: classes.image, fill: true }, imageProps));
      } else if (option.color) {
        children = _react2.default.createElement('div', { className: classes.image, style: { backgroundColor: option.color } });
      }

      return _react2.default.createElement(
        'div',
        {
          key: option.id,
          className: _this.createButtonClass(selected, option),
          'amp-bind': 'class=>' + ampStateId + '.' + name + '.selected.id=="' + option.id + '" ? "' + _this.createButtonClass(true, option) + '" : "' + _this.createButtonClass(false, option) + '"'
        },
        _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            onClick: function onClick(e) {
              return _this.handleClick(e, option, i);
            },
            href: option.url,
            disabled: option.disabled,
            on: 'tap:AMP.setState({ ' + ampStateId + ': { ' + name + ': { selected: ' + JSON.stringify(option.toJSON()) + ' }}})',
            classes: {
              label: option.image || option.color ? classes.imageLabel : null,
              disabled: classes.disabled
            }
          }, buttonProps),
          children
        ),
        option.disabled && strikeThroughDisabled && _react2.default.createElement('div', { className: classes.strikeThrough, style: { transform: 'rotate(' + strikeThroughAngle + 'deg)' } })
      );
    }, _this.handleClick = function (e, item, index) {
      var _this$props2 = _this.props,
          onSelectionChange = _this$props2.onSelectionChange,
          model = _this$props2.model;


      if (onSelectionChange) {
        onSelectionChange(e, item, index);

        if (e.isDefaultPrevented()) {
          return;
        }
      }

      model.setSelected(item);
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ButtonSelector, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          amp = _props.amp,
          model = _props.model,
          ampStateId = _props.ampStateId,
          name = _props.name,
          showSelectedText = _props.showSelectedText,
          classes = _props.classes;


      if (!model) return null;

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        amp && _react2.default.createElement('input', {
          type: 'hidden',
          name: name,
          value: model.selected ? model.selected.id : '',
          'amp-bind': 'value=>' + ampStateId + '.' + name + '.selected.id'
        }),
        _react2.default.createElement(
          'div',
          { className: classes.buttons },
          model.options.map(this.renderButton)
        ),
        showSelectedText && _react2.default.createElement(
          _Typography2.default,
          {
            variant: 'caption',
            component: 'div',
            className: classes.selectedName,
            'amp-bind': 'text=>' + ampStateId + '.' + name + '.selected.text'
          },
          model.selected && model.selected.text
        )
      );
    }
  }]);
  return ButtonSelector;
}(_react.Component), _class2.propTypes = {
  /**
   * The instance of SelectionModelBase to bind to
   */
  model: _mobxReact.PropTypes.objectOrObservableObject.isRequired,

  /**
   * Callback function for tab change
   * Args: event, selectedItem, index
   */
  onSelectionChange: _propTypes2.default.func,

  /**
   * Overridable classes object to allow customization of component
   */
  classes: _propTypes2.default.objectOf(_propTypes2.default.string),

  /**
   * Props for displayed images. See <Image /> component for details
   */
  imageProps: _propTypes2.default.object,

  /**
   * Props for button. See <Button /> component for details
   */
  buttonProps: _propTypes2.default.object,

  /**
   * Set to true to show the name of the selected option in a caption below the buttons
   */
  showSelectedText: _propTypes2.default.bool,

  /**
   * The name of property in amp state to bind to
   */
  name: _propTypes2.default.string,

  /**
   * Set to `true` to show a slash through the item when disabled.  Defaults to `false`
   */
  strikeThroughDisabled: _propTypes2.default.bool,

  /**
   * The angle in degress for the disabled indicator.  Defaults to `45`.
   */
  strikeThroughAngle: _propTypes2.default.number
}, _class2.defaultProps = {
  items: [],
  buttonProps: {},
  imageProps: {},
  showSelectedText: false,
  strikeThroughDisabled: false,
  strikeThroughAngle: 45
}, _temp2)) || _class) || _class) || _class);
exports.default = ButtonSelector;
//# sourceMappingURL=ButtonSelector.js.map