'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _ShoppingCart = require('@material-ui/icons/ShoppingCart');

var _ShoppingCart2 = _interopRequireDefault(_ShoppingCart);

var _ToolbarButton = require('./ToolbarButton');

var _ToolbarButton2 = _interopRequireDefault(_ToolbarButton);

var _mobxReact = require('mobx-react');

var _core = require('@material-ui/core/');

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    cartQuantity: {
      color: '#fff',
      backgroundColor: theme.palette.primary.main,
      height: '20px',
      width: '20px',
      lineHeight: '20px',
      fontSize: '14px',
      borderRadius: '50%',
      position: 'absolute',
      top: '3px',
      right: '5px'
    },
    icon: {}
  };
};

var CartButton = (_dec = (0, _core.withStyles)(styles, { name: 'RSFCartButton' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { cart: app.cart };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(CartButton, _Component);

  function CartButton() {
    (0, _classCallCheck3.default)(this, CartButton);
    return (0, _possibleConstructorReturn3.default)(this, (CartButton.__proto__ || Object.getPrototypeOf(CartButton)).apply(this, arguments));
  }

  (0, _createClass3.default)(CartButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          cart = _props.cart,
          path = _props.path,
          server = _props.server,
          onClick = _props.onClick,
          icon = _props.icon,
          buttonProps = (0, _objectWithoutProperties3.default)(_props, ['classes', 'cart', 'path', 'server', 'onClick', 'icon']);

      var cartIcon = icon ? icon : _react2.default.createElement(_ShoppingCart2.default, { className: classes.icon });

      return _react2.default.createElement(
        _Track2.default,
        { event: 'cartClicked' },
        _react2.default.createElement(
          _Link2.default,
          { to: path, server: server, onClick: onClick },
          _react2.default.createElement(
            _ToolbarButton2.default,
            (0, _extends3.default)({
              'aria-label': 'Cart',
              color: 'inherit',
              icon: cartIcon
            }, buttonProps),
            cart && cart.quantity > 0 && _react2.default.createElement(
              'div',
              { className: classes.cartQuantity },
              cart.quantity
            )
          )
        )
      );
    }
  }]);
  return CartButton;
}(_react.Component), _class2.propTypes = {
  /**
   * The url path to cart.  Defaults to "/cart"
   */
  path: _propTypes2.default.string,

  /**
   * Set to true to force server side navigation.  Defaults to false
   */
  server: _propTypes2.default.bool,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * Optional Custom cart icon
   */
  icon: _propTypes2.default.element
}, _class2.defaultProps = {
  path: '/cart'
}, _temp)) || _class) || _class) || _class);
exports.default = CartButton;
//# sourceMappingURL=CartButton.js.map