'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _core = require('@material-ui/core/');

var _mobxReact = require('mobx-react');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A button that links to Checkout, to be displayed on the Cart page.  The style matches
 * AddToCartButton by default.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      fontSize: theme.typography.subheading.fontSize,
      padding: theme.margins.container + 'px'
    },
    docked: {
      position: 'fixed',
      left: 0,
      bottom: 0,
      width: '100%',
      zIndex: 1,
      borderRadius: '0'
    }
  };
};

var CheckoutButton = (_dec = (0, _core.withStyles)(styles, { name: 'RSFCheckoutButton' }), _dec2 = (0, _mobxReact.inject)('history'), _dec(_class = _dec2(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(CheckoutButton, _Component);

  function CheckoutButton() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, CheckoutButton);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = CheckoutButton.__proto__ || Object.getPrototypeOf(CheckoutButton)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
      var _this$props = _this.props,
          history = _this$props.history,
          url = _this$props.url;


      if (url.match(/^(https?:)?\/\//)) {
        window.location.href = url;
      } else {
        history.push(url);
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(CheckoutButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          className = _props.className,
          url = _props.url,
          children = _props.children,
          docked = _props.docked,
          others = (0, _objectWithoutProperties3.default)(_props, ['classes', 'className', 'url', 'children', 'docked']);


      return _react2.default.createElement(
        _Button2.default,
        (0, _extends3.default)({
          size: 'large',
          color: 'secondary',
          onClick: this.onClick,
          variant: 'raised'
        }, others, {
          classes: { root: classes.root },
          className: (0, _classnames3.default)(className, (0, _defineProperty3.default)({}, classes.docked, docked))
        }),
        children || "Checkout"
      );
    }
  }]);
  return CheckoutButton;
}(_react.Component), _class2.propTypes = {
  /**
   * The URL for checkout.  Defaults to "/checkout"
   */
  url: _propTypes2.default.string,

  /**
   * Set to true to dock the button at the bottom of the viewport so that it is always visible
   */
  docked: _propTypes2.default.bool
}, _class2.defaultProps = {
  url: '/checkout',
  docked: false
}, _temp2)) || _class) || _class);
exports.default = CheckoutButton;
//# sourceMappingURL=CheckoutButton.js.map