'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
/**
 * Provides access to values set in the blob in Moov Console.
 */
var Config = function () {
  function Config() {
    (0, _classCallCheck3.default)(this, Config);
    this.values = {};
  }

  (0, _createClass3.default)(Config, [{
    key: 'get',


    /**
     * Gets a config value
     * @param {String} key 
     * @return {Object}
     */
    value: function get(key) {
      return this.values[key];
    }

    /**
     * Loads values from a JSON blob
     * @param {String/Object} blob A json blob
     */

  }, {
    key: 'load',
    value: function load(blob) {
      if (!blob) return;

      if (typeof blob === 'string') {
        blob = JSON.parse(blob);
      }

      this.values = blob;
    }
  }]);
  return Config;
}();

var config = new Config();

exports.default = config;
//# sourceMappingURL=Config.js.map