'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _Drawer = require('@material-ui/core/Drawer');

var _Drawer2 = _interopRequireDefault(_Drawer);

var _styles = require('@material-ui/core/styles');

var _Close = require('@material-ui/icons/Close');

var _Close2 = _interopRequireDefault(_Close);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _mobxReact = require('mobx-react');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A slide-in drawer with fab close button.
 */
var styles = exports.styles = function styles(theme) {
  return {
    closeButton: {
      position: 'absolute',
      right: '10px',
      top: '-28px',
      zIndex: 1
    },

    paper: {
      overflowY: 'visible'
    },

    title: {
      textAlign: 'center',
      padding: '20px',
      fontSize: '18px',
      borderBottom: '1px solid ' + theme.palette.divider
    },

    ampClosed: {
      display: 'none'
    }
  };
};

var Drawer = (_dec = (0, _styles.withStyles)(styles, { name: 'RSFDrawer' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return { amp: app && app.amp, ampStateId: ampStateId };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Drawer, _Component);

  function Drawer() {
    (0, _classCallCheck3.default)(this, Drawer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Drawer.__proto__ || Object.getPrototypeOf(Drawer)).call(this));

    _this.closeDrawer = function () {
      var onRequestClose = _this.props.onRequestClose;

      onRequestClose();
      document.body.style.paddingBottom = 0;
    };

    _this.drawer = _react2.default.createRef();
    return _this;
  }

  (0, _createClass3.default)(Drawer, [{
    key: 'render',
    value: function render() {
      var _classnames;

      var _props = this.props,
          amp = _props.amp,
          ampStateId = _props.ampStateId,
          ampBindClosed = _props.ampBindClosed,
          variant = _props.variant,
          closeButtonProps = _props.closeButtonProps,
          showCloseButton = _props.showCloseButton,
          open = _props.open,
          onRequestClose = _props.onRequestClose,
          title = _props.title,
          children = _props.children,
          classes = _props.classes,
          autoAdjustBodyPadding = _props.autoAdjustBodyPadding,
          rest = (0, _objectWithoutProperties3.default)(_props, ['amp', 'ampStateId', 'ampBindClosed', 'variant', 'closeButtonProps', 'showCloseButton', 'open', 'onRequestClose', 'title', 'children', 'classes', 'autoAdjustBodyPadding']);


      return _react2.default.createElement(
        _Drawer2.default,
        (0, _extends3.default)({
          anchor: 'bottom',
          classes: {
            paper: (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.paper, true), (0, _defineProperty3.default)(_classnames, classes.ampClosed, amp && !open), _classnames))
          },
          'amp-bind': ampBindClosed ? 'class=>' + ampStateId + '.' + ampBindClosed + ' ? \'' + classes.ampClosed + '\' : null' : null,
          open: amp && variant === "temporary" || open,
          variant: variant
        }, rest),
        _react2.default.createElement(
          'div',
          { ref: this.drawer },
          title && _react2.default.createElement(
            'div',
            { className: classes.title },
            _react2.default.createElement(
              _Typography2.default,
              { variant: 'title', component: 'div' },
              title
            )
          ),
          showCloseButton && _react2.default.createElement(
            _Button2.default,
            (0, _extends3.default)({
              variant: 'fab',
              color: 'primary',
              className: classes.closeButton,
              onClick: this.closeDrawer,
              style: { display: open ? '' : 'none' },
              on: ampBindClosed ? 'tap:AMP.setState({ ' + ampStateId + ': { ' + ampBindClosed + ': true }})' : null
            }, closeButtonProps),
            _react2.default.createElement(_Close2.default, null)
          ),
          children
        )
      );
    }

    // add body padding equal to drawer height

  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setPadding();
      var el = this.drawer.current;

      if (this.props.autoAdjustBodyPadding && el) {
        this.drawerResize = new _resizeObserverPolyfill2.default(function () {
          document.body.style.paddingBottom = el && el.clientHeight + 'px';
        });

        this.drawerResize.observe(el);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var el = this.drawer.current;

      if (this.drawerResize && el) {
        this.drawerResize.unobserve(el);
      }
    }

    // if value of open property changes, recalcuate drawer height/body padding

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.open && !this.props.open) {
        this.setPadding();
      } else if (this.props.open && !nextProps.open) {
        this.closeDrawer();
      }
    }
  }, {
    key: 'setPadding',
    value: function setPadding() {
      var _this2 = this;

      if (this.props.autoAdjustBodyPadding) {
        requestAnimationFrame(function () {
          var el = _this2.drawer.current;
          document.body.style.paddingBottom = el && el.clientHeight + 'px';
        });
      }
    }
  }]);
  return Drawer;
}(_react.Component), _class2.propTypes = {
  /**
   * Set to false to hide the close button. Defaults to true
   */
  showCloseButton: _propTypes2.default.bool,

  /**
   * Called when the user closes the drawer
   */
  onRequestClose: _propTypes2.default.func.isRequired,

  /**
   * The title to display at the top of the drawer
   */
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  /**
   * Set to true to automatically add padding to the body when the drawer
   * is open so that the user is able to scroll and see all of the body content.
   * Defaults to false.
   */
  autoAdjustBodyPadding: _propTypes2.default.bool,

  /**
   * Props to apply to the closeButton
   */
  closeButtonProps: _propTypes2.default.object,

  /**
   * The name of a property the amp-state to bind to the closed state of the drawer.
   */
  ampBindClosed: _propTypes2.default.string
}, _class2.defaultProps = {
  showCloseButton: true,
  autoAdjustBodyPadding: false,
  closeButtonProps: {}
}, _temp)) || _class) || _class);
exports.default = Drawer;
//# sourceMappingURL=Drawer.js.map