'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps; /**
                                                                   * @license
                                                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _ExpansionPanel = require('@material-ui/core/ExpansionPanel');

var _ExpansionPanel2 = _interopRequireDefault(_ExpansionPanel);

var _ExpansionPanelDetails = require('@material-ui/core/ExpansionPanelDetails');

var _ExpansionPanelDetails2 = _interopRequireDefault(_ExpansionPanelDetails);

var _ExpansionPanelSummary = require('@material-ui/core/ExpansionPanelSummary');

var _ExpansionPanelSummary2 = _interopRequireDefault(_ExpansionPanelSummary);

var _ExpandMore = require('@material-ui/icons/ExpandMore');

var _ExpandMore2 = _interopRequireDefault(_ExpandMore);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _AmpExpandableSection = require('./amp/AmpExpandableSection');

var _AmpExpandableSection2 = _interopRequireDefault(_AmpExpandableSection);

var _mobxReact = require('mobx-react');

var _withTheme = require('@material-ui/core/styles/withTheme');

var _withTheme2 = _interopRequireDefault(_withTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      boxShadow: 'none',
      borderBottom: '1px solid ' + theme.palette.divider,
      margin: 0,
      paddingLeft: '20px',

      '&::before': {
        display: 'none'
      },

      '& > *:first-child': {
        padding: '0',
        minHeight: '0'
      }
    },

    caption: {
      transition: 'opacity .2s linear'
    },

    expandedCaption: {
      opacity: 0
    },

    largeTitle: {
      fontSize: '18px',
      fontWeight: 'bold',
      color: '#444'
    },

    details: {
      paddingLeft: '0',
      paddingRight: '0'
    },

    summary: {
      display: 'flex',
      justifyContent: 'space-between',
      alignItems: 'center',
      marginRight: '25px !important'
    },

    withCollapseIcon: {
      transform: 'translateY(-50%) rotate(0deg) !important'
    },

    expandIcon: {},
    collapseIcon: {}
  };
};

var ExpandableSection = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFExpandableSection' }), _dec2 = (0, _withTheme2.default)(), _dec3 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { amp: app.amp };
}), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(ExpandableSection, _Component);
  (0, _createClass3.default)(ExpandableSection, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(_ref2) {
      var expanded = _ref2.expanded;

      if (typeof expanded !== 'undefined') {
        return { expanded: expanded };
      } else {
        return {};
      }
    }
  }]);

  function ExpandableSection(_ref3) {
    var expanded = _ref3.expanded,
        ExpandIcon = _ref3.ExpandIcon,
        CollapseIcon = _ref3.CollapseIcon,
        theme = _ref3.theme;
    (0, _classCallCheck3.default)(this, ExpandableSection);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ExpandableSection.__proto__ || Object.getPrototypeOf(ExpandableSection)).call(this));

    _initialiseProps.call(_this);

    _this.ExpandIcon = ExpandIcon || theme.ExpandIcon || _ExpandMore2.default;
    _this.CollapseIcon = CollapseIcon || theme.CollapseIcon || _this.ExpandIcon;

    _this.state = {
      expanded: expanded
    };
    return _this;
  }

  (0, _createClass3.default)(ExpandableSection, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          amp = _props.amp,
          classes = _props.classes,
          theme = _props.theme,
          _props$children = _props.children,
          children = _props$children === undefined ? [] : _props$children,
          title = _props.title,
          caption = _props.caption,
          expanded = _props.expanded,
          ei = _props.ExpandIcon,
          ci = _props.CollapseIcon,
          others = (0, _objectWithoutProperties3.default)(_props, ['amp', 'classes', 'theme', 'children', 'title', 'caption', 'expanded', 'ExpandIcon', 'CollapseIcon']);
      var ExpandIcon = this.ExpandIcon,
          CollapseIcon = this.CollapseIcon;


      if (amp) {
        return _react2.default.createElement(
          _AmpExpandableSection2.default,
          { ExpandIcon: ExpandIcon, CollapseIcon: CollapseIcon, title: title },
          children
        );
      } else {
        var _classnames;

        return _react2.default.createElement(
          _ExpansionPanel2.default,
          (0, _extends3.default)({ classes: { root: classes.root }, expanded: expanded }, others, { onChange: this.onChange }),
          _react2.default.createElement(
            _ExpansionPanelSummary2.default,
            {
              expandIcon: this.state.expanded ? _react2.default.createElement(CollapseIcon, { className: classes.collapseIcon }) : _react2.default.createElement(ExpandIcon, { className: classes.expandIcon }),
              classes: this.getSummaryClasses()
            },
            _react2.default.createElement(
              _Typography2.default,
              { variant: 'subheading' },
              title
            ),
            caption && _react2.default.createElement(
              _Typography2.default,
              {
                variant: 'caption',
                className: (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.caption, true), (0, _defineProperty3.default)(_classnames, classes.expandedCaption, expanded), _classnames))
              },
              caption
            )
          ),
          _react2.default.createElement(
            _ExpansionPanelDetails2.default,
            { classes: { root: classes.details } },
            children
          )
        );
      }
    }

    /**
     * Gets the classes for the ExpansionPanelSummary
     * Here we add a class to remove the rotate transform if we're using a 
     * separate icon for the collapse state.
     */

  }, {
    key: 'getSummaryClasses',
    value: function getSummaryClasses() {
      var classes = this.props.classes;


      var result = {
        content: classes.summary
      };

      if (this.CollapseIcon !== this.ExpandIcon) {
        result.expandIcon = classes.withCollapseIcon;
      }

      return result;
    }
  }]);
  return ExpandableSection;
}(_react.Component), _class2.propTypes = {
  /**
   * The title for the header of the expandable section
   */
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  /**
   * Text to display to the right of the heading
   */
  caption: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  /**
   * The icon to use for collapsed groups
   */
  ExpandIcon: _propTypes2.default.func,

  /**
   * The icon to use for expanded groups
   */
  CollapseIcon: _propTypes2.default.func,

  /**
   * Controls the expanded state.  Defaults to false
   */
  expanded: _propTypes2.default.bool
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.onChange = function (e, expanded) {
    if (_this2.props.onChange) {
      _this2.props.onChange(e, expanded);
    }
    _this2.setState({ expanded: expanded });
  };
}, _temp)) || _class) || _class) || _class);
exports.default = ExpandableSection;
//# sourceMappingURL=ExpandableSection.js.map