'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _lodash = require('lodash');

var _mobxReact = require('mobx-react');

var _ExpandableSection = require('./ExpandableSection');

var _ExpandableSection2 = _interopRequireDefault(_ExpandableSection);

var _Checkbox = require('@material-ui/core/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxStateTree = require('mobx-state-tree');

var _Box = require('./Box');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * UI for filtering an instance of SearchResultModelBase.  This component can be used on its own, or you can use
 * FilterButton to automatically display this component in a drawer that slides up from the bottom of the viewport.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      height: '50vh',
      overflowY: 'auto',
      paddingBottom: '64px'
    },
    matches: {
      marginLeft: '5px',
      display: 'inline'
    },
    footer: {
      backgroundColor: theme.palette.secondary.main,
      padding: '12px 20px',
      color: 'white',
      position: 'absolute',
      bottom: 0,
      left: 0,
      right: 0,
      justifyContent: 'space-between',
      alignItems: 'center',
      transform: 'translate3d(0,0,0)'
    },
    itemsFound: {
      color: theme.palette.secondary.contrastText
    }
  };
};

var Filter = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFFilter' }), _dec2 = (0, _mobxReact.inject)('router'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Filter, _Component);

  function Filter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Filter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Filter.__proto__ || Object.getPrototypeOf(Filter)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      expanded: {}
    }, _this.onToggleFilter = function (facet) {
      _this.props.model.toggleFilter(facet);
    }, _this.onViewResultsClick = function (e) {
      var _this$props = _this.props,
          router = _this$props.router,
          model = _this$props.model;


      _this.props.onViewResultsClick(e);

      if (!e.isDefaultPrevented()) {
        _this.props.model.setFiltersChanged(false);
        router.applySearch((0, _defineProperty3.default)({}, _this.props.queryParam, model.filters.toJSON()));
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Filter, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          model = _props.model,
          classes = _props.classes;


      return _react2.default.createElement(
        'div',
        { className: classes.root },
        (0, _lodash.get)(model, 'facetGroups', []).map(function (facetGroup, i) {
          return _this2.renderFacetGroup(facetGroup, i);
        }),
        model.filtersChanged && _react2.default.createElement(
          _Box.Hbox,
          { className: classes.footer, split: true },
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'subheading', className: classes.itemsFound },
            model.filters.length || 'No',
            ' filter',
            model.filters.length === 1 ? '' : 's',
            ' selected'
          ),
          _react2.default.createElement(
            _Button2.default,
            { variant: 'raised', size: 'large', color: 'default', onClick: this.onViewResultsClick },
            'View Results'
          )
        )
      );
    }
  }, {
    key: 'renderFacetGroup',
    value: function renderFacetGroup(group, key) {
      var _this3 = this;

      var _props2 = this.props,
          app = _props2.app,
          model = _props2.model,
          classes = _props2.classes;
      var expanded = this.state.expanded;

      var selection = [];

      var formGroup = _react2.default.createElement(
        _FormGroup2.default,
        { key: key },
        group.facets.map(function (facet, i) {
          var checked = false;

          if ((0, _lodash.get)(model, 'filters', []).indexOf(facet.code) !== -1) {
            selection.push(facet);
            checked = true;
          }

          return _react2.default.createElement(_FormControlLabel2.default, {
            key: i,
            label: _react2.default.createElement(
              'span',
              null,
              _react2.default.createElement(
                'span',
                null,
                facet.name
              ),
              _react2.default.createElement(
                _Typography2.default,
                { variable: 'caption', className: classes.matches, component: 'span' },
                '(',
                facet.matches,
                ')'
              )
            ),
            control: _react2.default.createElement(_Checkbox2.default, {
              checked: checked,
              color: 'primary',
              onChange: _this3.onToggleFilter.bind(_this3, facet)
            })
          });
        })
      );

      var caption = null;

      if (selection.length === 1) {
        caption = selection[0].name;
      } else if (selection.length > 0) {
        caption = selection.length + ' selected';
      }

      return _react2.default.createElement(
        _ExpandableSection2.default,
        {
          key: key,
          title: group.name,
          caption: caption,
          expanded: expanded[group.name],
          onChange: function onChange(e, expanded) {
            return _this3.setState({ expanded: (0, _extends4.default)({}, expanded, (0, _defineProperty3.default)({}, group.name, expanded)) });
          }
        },
        formGroup
      );
    }
  }]);
  return Filter;
}(_react.Component), _class2.propTypes = {
  /**
   * An instance of `SearchResultModelBase`
   */
  model: _propTypes2.default.object,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * A function to call when the user clicks the button to view updated results.  The default behavior can be
   * canceled by calling `preventDefault` on the passed in event.  The event is passed as the only argument.
   */
  onViewResultsClick: _propTypes2.default.func,

  /**
   * The query string parameter that should be updated when filters are changed.  The value will be an array
   * of codes for each selected facet.  Defaults to "filters"
   */
  queryParam: _propTypes2.default.string
}, _class2.defaultProps = {
  onViewResultsClick: Function.prototype,
  queryParam: 'filters'
}, _temp2)) || _class) || _class) || _class);
exports.default = Filter;
//# sourceMappingURL=Filter.js.map