'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _ActionButton = require('./ActionButton');

var _ActionButton2 = _interopRequireDefault(_ActionButton);

var _Filter = require('./Filter');

var _Filter2 = _interopRequireDefault(_Filter);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Drawer = require('./Drawer');

var _Drawer2 = _interopRequireDefault(_Drawer);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Box = require('./Box');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    clear: (0, _extends3.default)({
      marginLeft: '10px'
    }, theme.typography.caption)
  };
};

/**
 * A button that when clicked, opens a drawer containing the `Filter` view. Current filters
 * are displayed in the button text.
 */
var FilterButton = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFFilterButton' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(FilterButton, _Component);

  function FilterButton(_ref) {
    var app = _ref.app;
    (0, _classCallCheck3.default)(this, FilterButton);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FilterButton.__proto__ || Object.getPrototypeOf(FilterButton)).call(this));

    _this.onClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }

      if (!e.defaultPrevented) {
        _this.toggleOpen(true);
      }
    };

    _this.toggleOpen = function (open) {
      _this.setState({ open: open });

      if (open) {
        _this.setState({ mountDrawer: true, open: true });
      } else {
        _this.setState({ open: false });
      }
    };

    _this.onViewResultsClick = function () {
      _this.toggleOpen(false);
    };

    _this.getFilterList = function () {
      var _this$props$model = _this.props.model,
          filters = _this$props$model.filters,
          facetGroups = _this$props$model.facetGroups;


      if (!filters || !facetGroups) return null;
      if (filters.length > 1) return filters.length + ' selected';

      var names = [];
      var selection = {};

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = filters[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var facet = _step.value;

          selection[facet] = true;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = facetGroups[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var group = _step2.value;
          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = undefined;

          try {
            for (var _iterator3 = group.facets[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var _facet = _step3.value;

              if (selection[_facet.code]) {
                names.push(_facet.name);
              }
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return names.length ? names.join(', ') : null;
    };

    _this.state = {
      open: app.location.search.indexOf('openFilter') !== -1,
      mountDrawer: false
    };
    return _this;
  }

  (0, _createClass3.default)(FilterButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          app = _props.app,
          model = _props.model,
          title = _props.title,
          drawerProps = _props.drawerProps,
          hideClearLink = _props.hideClearLink,
          clearLinkText = _props.clearLinkText,
          props = (0, _objectWithoutProperties3.default)(_props, ['classes', 'app', 'model', 'title', 'drawerProps', 'hideClearLink', 'clearLinkText']);
      var _state = this.state,
          open = _state.open,
          mountDrawer = _state.mountDrawer;
      var clear = classes.clear,
          buttonClasses = (0, _objectWithoutProperties3.default)(classes, ['clear']);


      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(_ActionButton2.default, (0, _extends3.default)({
          label: title,
          href: app.amp ? app.location.pathname.replace(/\.amp/, '') + '?openFilter' : null,
          value: this.getFilterList(),
          classes: buttonClasses
        }, props, {
          onClick: this.onClick
        })),
        !app.amp && _react2.default.createElement(
          _Drawer2.default,
          {
            ModalProps: {
              keepMounted: true
            },
            anchor: 'bottom',
            title: _react2.default.createElement(
              _Box.Hbox,
              { justifyContent: 'center' },
              _react2.default.createElement(
                'div',
                null,
                title
              ),
              hideClearLink || model.filters.length === 0 ? null : _react2.default.createElement(
                'a',
                { className: clear, onClick: model.clearAllFilters },
                clearLinkText
              )
            ),
            open: open,
            onRequestClose: this.toggleOpen.bind(this, false)
          },
          mountDrawer && _react2.default.createElement(_Filter2.default, (0, _extends3.default)({ model: model, onViewResultsClick: this.onViewResultsClick }, drawerProps))
        )
      );
    }
  }]);
  return FilterButton;
}(_react.Component), _class2.propTypes = {
  /**
   * An instance of `SearchResultModelBase`
   */
  model: _propTypes2.default.object,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * Props for the underlying `Filter` component
   */
  drawerProps: _propTypes2.default.object,

  /**
   * The label for the button and the drawer header.  Defaults to "Filter".
   */
  title: _propTypes2.default.string,

  /**
   * Set to true to hide the clear link that is shown by default when one or more filters 
   * is selected.  Defaults to false.
   */
  hideClearLink: _propTypes2.default.bool,

  /**
   * Text for the clear link.  Defaults to "clear all".
   */
  clearLinkText: _propTypes2.default.string
}, _class2.defaultProps = {
  title: 'Filter',
  drawerProps: {},
  hideClearLink: false,
  clearLinkText: "clear all"
}, _temp)) || _class) || _class) || _class);
exports.default = FilterButton;
//# sourceMappingURL=FilterButton.js.map