'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _core = require('@material-ui/core/');

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    logoWrap: (0, _defineProperty3.default)({
      position: 'absolute',
      left: '50%',
      width: '120px',
      marginLeft: 'calc(-120px/2)',
      height: '100%',
      display: 'flex',
      alignItems: 'center',

      '& svg': {
        width: '100%',
        height: '100%'
      }

    }, theme.breakpoints.up('md'), {
      position: 'relative',
      left: 0,
      marginLeft: 10
    }),

    altText: {
      visibility: 'collapse',
      position: 'absolute'
    }
  };
};

/**
 * A wrapper for the logo in the app header which automatically links to the home page and fires
 * the logo_clicked analytics event
 * 
 * Usage:
 * 
 *  import MyLogo from '/path/to/logo.svg'
 * 
 *  <HeaderLogo>
 *    <MyLogo/>
 *  </HeaderLogo>
 * 
 */
var HeaderLogo = (_dec = (0, _core.withStyles)(styles, { name: 'RSFHeaderLogo' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(HeaderLogo, _Component);

  function HeaderLogo() {
    (0, _classCallCheck3.default)(this, HeaderLogo);
    return (0, _possibleConstructorReturn3.default)(this, (HeaderLogo.__proto__ || Object.getPrototypeOf(HeaderLogo)).apply(this, arguments));
  }

  (0, _createClass3.default)(HeaderLogo, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          children = _props.children,
          alt = _props.alt;


      return _react2.default.createElement(
        _Track2.default,
        { event: 'logoClicked' },
        _react2.default.createElement(
          _Link2.default,
          { to: '/', className: (0, _classnames2.default)(classes.logoWrap) },
          _react2.default.createElement(
            'span',
            { className: classes.altText },
            alt
          ),
          children
        )
      );
    }
  }]);
  return HeaderLogo;
}(_react.Component), _class2.propTypes = {
  /**
   * The alt text to use for accessibility.  Defaults to "brand logo"
   */
  alt: _propTypes2.default.string
}, _class2.defaultProps = {
  alt: 'brand logo'
}, _temp)) || _class);
exports.default = HeaderLogo;
//# sourceMappingURL=HeaderLogo.js.map