'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _reactVisibilitySensor = require('react-visibility-sensor');

var _reactVisibilitySensor2 = _interopRequireDefault(_reactVisibilitySensor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    fit: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      display: 'block',
      width: '100%',
      height: '100%'
    },
    contain: {
      '& img': {
        objectFit: 'contain',
        maxHeight: '100%',
        maxWidth: '100%'
      }
    },
    fill: {
      '& img': {
        display: 'block',
        objectFit: 'contain',
        maxHeight: '100%',
        maxWidth: '100%',
        width: '100%',
        height: '100%'
      }
    }
  };
};

/**
 * Provide amp-compatible mobile-optimized images that can be made to auto-scale to fit the parent element 
 * by setting the `fill` prop, or grow/shrink while maintaining a given aspect ratio
 * by setting the `aspectRatio` prop.
 */
var Image = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFImage' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { amp: app.amp };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Image, _Component);

  function Image(_ref2) {
    var lazy = _ref2.lazy,
        amp = _ref2.amp;
    (0, _classCallCheck3.default)(this, Image);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Image.__proto__ || Object.getPrototypeOf(Image)).call(this));

    _this.lazyLoad = function (visible) {
      if (!_this.state.loaded && visible) {
        _this.setState({ loaded: true });
      }
    };

    _this.state = {
      loaded: !lazy || amp
    };
    return _this;
  }

  (0, _createClass3.default)(Image, [{
    key: 'render',
    value: function render() {
      var _assignedAttributes, _classnames2;

      var _props = this.props,
          lazy = _props.lazy,
          lazyOffset = _props.lazyOffset,
          height = _props.height,
          width = _props.width,
          quality = _props.quality,
          amp = _props.amp,
          fill = _props.fill,
          contain = _props.contain,
          classes = _props.classes,
          className = _props.className,
          aspectRatio = _props.aspectRatio,
          alt = _props.alt,
          src = _props.src,
          imgAttributes = (0, _objectWithoutProperties3.default)(_props, ['lazy', 'lazyOffset', 'height', 'width', 'quality', 'amp', 'fill', 'contain', 'classes', 'className', 'aspectRatio', 'alt', 'src']);
      var loaded = this.state.loaded;


      contain = contain || aspectRatio;

      // Overiding `src` prop if `quality` was set
      src = this.getOptimizedSrc();

      var assignedAttributes = (_assignedAttributes = {
        src: src,
        key: src
      }, (0, _defineProperty3.default)(_assignedAttributes, amp ? 'class' : 'className', (0, _classnames4.default)((0, _defineProperty3.default)({}, classes.fit, aspectRatio != null))), (0, _defineProperty3.default)(_assignedAttributes, 'layout', amp ? contain ? 'fill' : 'intrinsic' : null), (0, _defineProperty3.default)(_assignedAttributes, 'height', height), (0, _defineProperty3.default)(_assignedAttributes, 'width', width), (0, _defineProperty3.default)(_assignedAttributes, 'alt', alt), _assignedAttributes);

      var result = _react2.default.createElement(
        'div',
        {
          className: (0, _classnames4.default)(className, (_classnames2 = {}, (0, _defineProperty3.default)(_classnames2, classes.root, true), (0, _defineProperty3.default)(_classnames2, classes.contain, contain), (0, _defineProperty3.default)(_classnames2, classes.fill, fill), _classnames2)) },
        aspectRatio && _react2.default.createElement('div', { style: { paddingTop: aspectRatio + '%' } }),
        amp ? _react2.default.createElement('amp-img', assignedAttributes) : loaded && _react2.default.createElement('img', (0, _extends3.default)({}, assignedAttributes, imgAttributes))
      );

      if (!amp && lazy) {
        result = _react2.default.createElement(
          _reactVisibilitySensor2.default,
          {
            active: !loaded,
            onChange: this.lazyLoad,
            partialVisibility: true,
            offset: { top: -lazyOffset, bottom: -lazyOffset }
          },
          result
        );
      }

      return result;
    }
  }, {
    key: 'getOptimizedSrc',
    value: function getOptimizedSrc() {
      var _props2 = this.props,
          src = _props2.src,
          quality = _props2.quality;


      if (quality) {
        return 'https://opt.moovweb.net/?quality=' + encodeURIComponent(quality) + '&img=' + encodeURIComponent(src);
      } else {
        return src;
      }
    }
  }]);
  return Image;
}(_react.Component), _class2.propTypes = {
  /**
   * The URL for the image
   */
  src: _propTypes2.default.string,

  /**
   * The ratio of height/width as a float.  For example: 1 when the height and width match, 
   * 0.5 when height is half of the width.
   */
  aspectRatio: _propTypes2.default.number,

  /**
   * The quality of image to retreive from 0 to 100
   */
  quality: _propTypes2.default.number,

  /**
   * Set to true to apply object-fit:contain to the image so that it automatically
   * fits within the element's height and width.
   */
  contain: _propTypes2.default.bool,

  /**
   * The same as contain, except images are stretched to fill the element's height and width.
   */
  fill: _propTypes2.default.bool,

  /**
   * Set to true to wait until the image enters the viewport before loading it.
   */
  lazy: _propTypes2.default.bool,

  /**
   * Sets the minimum amount of pixels the image can be scrolled out of view before it
   * is lazy loaded.  Defaults to 100.  You must set `lazy` in order for this setting to take effect.
   */
  lazyOffset: _propTypes2.default.number
}, _class2.defaultProps = {
  quality: null,
  contain: false,
  fill: false,
  lazy: false,
  lazyOffset: 100
}, _temp)) || _class) || _class);
exports.default = Image;
//# sourceMappingURL=Image.js.map