'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSwipeableViews = require('react-swipeable-views');

var _reactSwipeableViews2 = _interopRequireDefault(_reactSwipeableViews);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _ChevronLeft = require('@material-ui/icons/ChevronLeft');

var _ChevronLeft2 = _interopRequireDefault(_ChevronLeft);

var _ChevronRight = require('@material-ui/icons/ChevronRight');

var _ChevronRight2 = _interopRequireDefault(_ChevronRight);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Portal = require('@material-ui/core/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _colorManipulator = require('@material-ui/core/styles/colorManipulator');

var _classnames5 = require('classnames');

var _classnames6 = _interopRequireDefault(_classnames5);

var _reactPinchZoomPan = require('react-pinch-zoom-pan');

var _TabsRow = require('./TabsRow');

var _TabsRow2 = _interopRequireDefault(_TabsRow);

var _analytics = require('./analytics');

var _analytics2 = _interopRequireDefault(_analytics);

var _mobxReact = require('mobx-react');

var _AmpImageSwitcher = require('./amp/AmpImageSwitcher');

var _AmpImageSwitcher2 = _interopRequireDefault(_AmpImageSwitcher);

var _LoadMask = require('./LoadMask');

var _LoadMask2 = _interopRequireDefault(_LoadMask);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var paletteIconTextColor = '#77726D';

var imagePropType = _propTypes2.default.shape({
  src: _propTypes2.default.string.isRequired,
  alt: _propTypes2.default.string
});

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      position: 'relative',

      '& img': {
        display: 'block'
      }
    },

    swipeWrap: {
      position: 'relative',
      overflow: 'hidden',
      flex: 1,
      '& .react-swipeable-view-container, & > div:first-child': {
        height: '100%'
      }
    },

    imageWrap: {
      height: '100%',
      width: '100%',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      '& img': {
        maxHeight: '100%',
        maxWidth: '100%',
        objectFit: 'contain'
      }
    },

    thumbsTitle: {
      textTransform: 'uppercase'
    },

    productThumb: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0
    },

    thumbs: {
      marginTop: theme.margins.container + 'px'
    },

    thumbnail: {
      paddingBottom: '8px',
      margin: '0 2px',
      boxSizing: 'content-box',
      height: '50px',
      width: '50px'
    },

    activeThumbs: {
      position: 'absolute',
      width: '100%',
      bottom: '20px'
    },

    selected: {
      borderColor: '#D0D0D0'
    },

    arrow: {
      position: 'absolute',
      top: '50%',
      marginTop: '-24px'
    },

    leftArrow: {
      left: 0
    },

    rightArrow: {
      right: 0
    },

    icon: {
      height: '30px',
      width: '30px'
    },

    dot: {
      backgroundColor: (0, _colorManipulator.fade)(theme.palette.text.primary, 0.25),
      width: 8,
      height: 8,
      borderWidth: '1px',
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderRadius: '50%',
      display: 'inline-block',
      margin: '0 2px',
      // Same duration as SwipeableViews animation
      transitionDuration: '0.35s'
    },

    dotSelected: {
      backgroundColor: theme.palette.text.primary
    },

    dots: {
      position: 'absolute',
      bottom: '5px',
      textAlign: 'center',
      width: '100%'
    },

    viewerToggle: {
      transform: 'scale(0.4)',
      position: 'absolute',
      top: 0,
      right: 0,
      background: (0, _colorManipulator.fade)(theme.palette.text.icon || paletteIconTextColor, 0.4),
      borderRadius: '50%',
      width: '100px',
      height: '100px',
      transitionDuration: '0.5s',
      '-webkit-tap-highlight-color': 'rgba(0, 0, 0, 0)'
    },

    viewerActive: {
      transform: 'scale(0.4) rotateZ(45deg)'
    },

    viewerOverlay: {
      position: 'fixed',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      background: theme.palette.background.paper,
      zIndex: 9999,
      transitionDuration: '0.5s',
      transform: 'translateY(100%)',
      visibility: 'hidden', // prevents lightbox from showing near the bottom of screen when browser controls hide on ios
      '& img': {
        margin: 'auto',
        maxHeight: '100%',
        maxWidth: '100%'
      },
      // Hack to fix root div height of pan/zoom/pinch container
      '& > div:first-child': {
        height: '100%'
      }
    },

    viewerOverlayActive: {
      transform: 'translateY(0%)',
      visibility: 'visible'
    },

    tabsRowRoot: {
      boxShadow: 'none'
    },

    tabScroller: (0, _defineProperty3.default)({}, theme.breakpoints.down('xs'), {
      padding: '0 ' + theme.margins.container + 'px'
    }),

    indicator: {
      display: 'none'
    },

    mask: {
      opacity: '0.8'
    }

  };
};

/** 
 * A swipeable image selector suitable for PDPs
 */
var ImageSwitcher = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFImageSwitcher' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(ImageSwitcher, _Component);

  function ImageSwitcher() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ImageSwitcher);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ImageSwitcher.__proto__ || Object.getPrototypeOf(ImageSwitcher)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      selectedIndex: 0,
      viewerActive: false
    }, _this.clearLoadingProduct = function () {
      _this.props.app.applyState({ loadingProduct: null });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ImageSwitcher, [{
    key: 'renderViewerToggle',
    value: function renderViewerToggle(withClose) {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          onClick: function onClick() {
            return _this2.toggleViewer();
          },
          className: (0, _classnames6.default)(this.props.classes.viewerToggle, (0, _defineProperty3.default)({}, this.props.classes.viewerActive, this.state.viewerActive))
        },
        _react2.default.createElement(
          'svg',
          { width: '100', height: '100', viewBox: '0 0 100 100' },
          _react2.default.createElement('line', { x1: '50', y1: '25', x2: '50', y2: '75', strokeWidth: '4', stroke: 'white' }),
          _react2.default.createElement('line', { x1: '25', y1: '50', x2: '75', y2: '50', strokeWidth: '4', stroke: 'white' })
        )
      );
    }
  }, {
    key: 'toggleViewer',
    value: function toggleViewer() {
      if (this.state.viewerActive) {
        document.body.classList.remove('moov-modal');
      } else {
        document.body.classList.add('moov-modal');
      }

      this.setState({ viewerActive: !this.state.viewerActive });
    }
  }, {
    key: 'renderDot',
    value: function renderDot(index) {
      var classes = (0, _classnames6.default)(this.props.classes.dot, (0, _defineProperty3.default)({}, this.props.classes.dotSelected, index === this.state.selectedIndex));
      return _react2.default.createElement('div', { key: index, className: classes });
    }
  }, {
    key: 'renderThumbnails',
    value: function renderThumbnails() {
      var _this3 = this;

      var _props = this.props,
          classes = _props.classes,
          thumbnailsTitle = _props.thumbnailsTitle;
      var thumbnails = this.thumbnails;

      var modifiedThumbs = thumbnails && thumbnails.map(function (_ref2) {
        var src = _ref2.src,
            alt = _ref2.alt;
        return { imageUrl: src, alt: alt };
      });
      var _state = this.state,
          viewerActive = _state.viewerActive,
          selectedIndex = _state.selectedIndex;


      return thumbnails && thumbnails.length > 0 && _react2.default.createElement(
        'div',
        { className: (0, _classnames6.default)(classes.thumbs, (0, _defineProperty3.default)({}, classes.activeThumbs, viewerActive)) },
        _react2.default.createElement(
          'div',
          { className: 'field' },
          _react2.default.createElement(
            'label',
            { className: classes.thumbsTitle },
            thumbnailsTitle
          )
        ),
        _react2.default.createElement(_TabsRow2.default, {
          classes: {
            scroller: classes.tabScroller,
            root: classes.tabsRowRoot
          },
          imageProps: {
            className: classes.thumbnail,
            fill: true
          },
          centered: true,
          initialSelectedIdx: selectedIndex,
          onTabChange: function onTabChange(e, selectedIndex) {
            return _this3.setState({ selectedIndex: selectedIndex });
          },
          items: modifiedThumbs
        })
      );
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState && prevState.selectedIndex && prevState.selectedIndex !== this.state.selectedIndex && this.props.product) {
        _analytics2.default.imageSwitched({ product: this.props.product, imageUrl: this.props.images[this.state.selectedIndex] });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props2 = this.props,
          app = _props2.app,
          product = _props2.product,
          classes = _props2.classes,
          className = _props2.className,
          arrows = _props2.arrows,
          indicators = _props2.indicators,
          style = _props2.style,
          reactPinchZoomPanOptions = _props2.reactPinchZoomPanOptions,
          loadingThumbnailProps = _props2.loadingThumbnailProps,
          viewerThumbnailsOnly = _props2.viewerThumbnailsOnly;
      var images = this.images,
          thumbnails = this.thumbnails;


      if (app.amp) return _react2.default.createElement(_AmpImageSwitcher2.default, (0, _defineProperty3.default)({
        images: images,
        thumbnails: thumbnails,
        className: className,
        classes: { root: classes.root, dot: classes.dot, dots: classes.dots, dotSelected: classes.dotSelected },
        arrows: arrows,
        indicators: indicators
      }, 'thumbnails', viewerThumbnailsOnly ? null : this.thumbnails));

      var _state2 = this.state,
          selectedIndex = _state2.selectedIndex,
          viewerActive = _state2.viewerActive;

      var selectedImage = images[selectedIndex];

      return _react2.default.createElement(
        'div',
        { className: (0, _classnames6.default)(className, classes.root), style: style },
        _react2.default.createElement(
          'div',
          { className: classes.swipeWrap },
          _react2.default.createElement(
            _reactSwipeableViews2.default,
            { index: selectedIndex, onChangeIndex: function onChangeIndex(i) {
                return _this4.setState({ selectedIndex: i });
              } },
            images.map(function (_ref3, i) {
              var src = _ref3.src,
                  alt = _ref3.alt;
              return _react2.default.createElement(
                'div',
                { key: i, className: classes.imageWrap },
                app.amp ? _react2.default.createElement('amp-img', {
                  src: src,
                  alt: 'product',
                  layout: 'fill'
                }) : _react2.default.createElement('img', {
                  key: src,
                  src: i === 0 && app.loading ? null : src // need to clear src when app.loading is true so that the onLoad event will fire and the loading thumbnail will be removed
                  , alt: alt || "product",
                  onLoad: i === 0 ? _this4.clearLoadingProduct : null
                })
              );
            })
          ),
          arrows && _react2.default.createElement(
            'div',
            { className: classes.arrows },
            selectedIndex !== 0 && _react2.default.createElement(
              _IconButton2.default,
              { className: (0, _classnames6.default)(classes.arrow, classes.leftArrow), onClick: function onClick() {
                  return _this4.setState({ selectedIndex: selectedIndex - 1 });
                } },
              _react2.default.createElement(_ChevronLeft2.default, { classes: { root: classes.icon } })
            ),
            selectedIndex !== images.length - 1 && _react2.default.createElement(
              _IconButton2.default,
              { className: (0, _classnames6.default)(classes.arrow, classes.rightArrow), onClick: function onClick() {
                  return _this4.setState({ selectedIndex: selectedIndex + 1 });
                } },
              _react2.default.createElement(_ChevronRight2.default, { classes: { root: classes.icon } })
            )
          ),
          indicators && _react2.default.createElement(
            'div',
            { className: classes.dots },
            images.map(function (_, index) {
              return _this4.renderDot(index);
            })
          ),
          product && _react2.default.createElement(_LoadMask2.default, { show: product.loadingImages, className: classes.mask }),
          product && app.loadingProduct && app.loadingProduct.thumbnail && _react2.default.createElement(_Image2.default, (0, _extends3.default)({ src: app.loadingProduct.thumbnail, className: classes.productThumb }, loadingThumbnailProps, { fill: true })),
          _react2.default.createElement(
            _Portal2.default,
            null,
            _react2.default.createElement(
              'div',
              { className: (0, _classnames6.default)(classes.viewerOverlay, (0, _defineProperty3.default)({}, classes.viewerOverlayActive, viewerActive)) },
              _react2.default.createElement(_reactPinchZoomPan.ReactPinchZoomPan, (0, _extends3.default)({}, reactPinchZoomPanOptions, { render: function render(obj) {
                  return _react2.default.createElement(
                    'div',
                    { style: {
                        overflow: 'hidden',
                        position: 'relative',
                        height: '100%'
                      } },
                    _react2.default.createElement(
                      'div',
                      { style: {
                          display: 'flex',
                          height: '100%'
                        } },
                      selectedImage && _react2.default.createElement('img', {
                        src: selectedImage.src,
                        alt: selectedImage.alt,
                        style: {
                          width: '100%',
                          height: 'auto',
                          transform: 'scale(' + obj.scale + ') translateY(' + obj.y + 'px) translateX(' + obj.x + 'px)'
                        }
                      })
                    )
                  );
                } })),
              viewerActive && this.renderViewerToggle(),
              viewerActive && this.renderThumbnails()
            )
          ),
          !viewerActive && this.renderViewerToggle()
        ),
        !viewerActive && !viewerThumbnailsOnly && this.renderThumbnails()
      );
    }
  }, {
    key: 'thumbnails',
    get: function get() {
      var _props3 = this.props,
          thumbnails = _props3.thumbnails,
          product = _props3.product;

      if (thumbnails === false) return [];
      var _thumbnails = thumbnails && thumbnails.length ? thumbnails : product && product.thumbnails || [];
      return _thumbnails.map(function (e) {
        return typeof e === 'string' ? { src: e, alt: 'thumbnail' } : e;
      });
    }
  }, {
    key: 'images',
    get: function get() {
      var _props4 = this.props,
          images = _props4.images,
          product = _props4.product;

      var _images = images && images.length ? images : product && product.images || [];
      return _images.map(function (e) {
        return typeof e === 'string' ? { src: e, alt: 'product' } : e;
      });
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (typeof nextProps.selectedIndex === 'number' && nextProps.selectedIndex !== prevState.selectedIndex) {
        return { selectedIndex: nextProps.selectedIndex };
      }
      return null;
    }
  }]);
  return ImageSwitcher;
}(_react.Component), _class2.propTypes = {

  /**
   * If specified, then the image_switched analytics event will be
   * fired when an image is selected and the product's images and thumbnails will
   * automatically be displayed.
   */
  product: _propTypes2.default.object,

  /**
   * An array of (URL or image object) for the full size images
   */
  images: _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, imagePropType])).isRequired,

  /**
   * An array of thumbnails to display below the main image
   */
  thumbnails: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.arrayOf(_propTypes2.default.oneOfType([_propTypes2.default.string, imagePropType]))]),

  /**
   * Display left/right arrows for navigating through images
   */
  arrows: _propTypes2.default.bool,

  /**
   * Display indicator dots at the bottom of the component
   */
  indicators: _propTypes2.default.bool,

  /**
   * Optional title for thumbnails block
   */
  thumbnailsTitle: _propTypes2.default.string,

  /*
   * Option to show thumbnails only when zoomed view is active
   */
  viewerThumbnailsOnly: _propTypes2.default.bool,

  /**
   * Props to apply to the Image component used to display the product thumbnail while
   * the product data is loading
   */
  loadingThumbnailProps: _propTypes2.default.object,

  /*
   * Option to manually set the selected index
   */
  selectedIndex: _propTypes2.default.number,

  /**
   * Config options for the image viewer
   */
  reactPinchZoomPanOptions: _propTypes2.default.shape({
    onPinchStart: _propTypes2.default.func,
    onPinchStop: _propTypes2.default.func,
    initialScale: _propTypes2.default.number,
    maxScale: _propTypes2.default.number
  })
}, _class2.defaultProps = {
  images: [],
  thumbnails: [],
  viewerThumbnailsOnly: false,
  arrows: false,
  indicators: false,
  loadingThumbnailProps: {},
  reactPinchZoomPanOptions: {
    maxScale: 3
  }
}, _temp2)) || _class) || _class) || _class);
exports.default = ImageSwitcher;
//# sourceMappingURL=ImageSwitcher.js.map