'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _url = require('./utils/url');

var _serviceWorker = require('./router/serviceWorker');

var _reactVisibilitySensor = require('react-visibility-sensor');

var _reactVisibilitySensor2 = _interopRequireDefault(_reactVisibilitySensor);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dataProps = require('./utils/dataProps');

var _dataProps2 = _interopRequireDefault(_dataProps);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = {
  root: {}
};

var Link = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFLink' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var history = _ref.history,
      router = _ref.router,
      app = _ref.app;
  return { history: history, router: router, location: app.location };
}), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Link, _Component);

  function Link() {
    (0, _classCallCheck3.default)(this, Link);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Link.__proto__ || Object.getPrototypeOf(Link)).call(this));

    _this.prefetched = false;

    _this.onVisibleChange = function (visible) {
      if (visible) {
        var el = _this.el.current;

        // Will get here if the link is on a hidden page
        // for some reason the visibility sensor fires for all links on a page right after 
        // that page has been hidden.  We check el.offsetParent to make sure the link is truly visible
        // see https://stackoverflow.com/questions/19669786/check-if-element-is-visible-in-dom for more info on this method
        if (el.offsetParent != null) {
          _this.prefetch();
        }
      }
    };

    _this.onClick = function (e) {
      var _this$props = _this.props,
          server = _this$props.server,
          onClick = _this$props.onClick,
          to = _this$props.to,
          state = _this$props.state;


      if (onClick) {
        onClick(e);
      }

      if (typeof state === 'function') {
        state = state();
      }

      var url = (0, _url.relativeURL)(to);

      if (!e.isDefaultPrevented() && !server && (0, _url.canUseClientSideNavigation)(url)) {
        e.preventDefault();

        if (_this.props.history) {
          _this.props.history.push(url, state && state.toJSON ? state.toJSON() : state);
        } else {
          // Fallback to redirect
          window.location.href = url;
        }
      }
    };

    _this.el = _react2.default.createRef();
    return _this;
  }

  (0, _createClass3.default)(Link, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.prefetch === 'always') {
        this.prefetch();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.prefetched !== this.urlToPrefetch()) {
        // reset prefetched state if the prefetch url changes
        this.prefetched = null;
      }
    }
  }, {
    key: 'prefetch',
    value: function prefetch() {
      var url = this.urlToPrefetch();

      if (this.prefetched !== url) {
        (0, _serviceWorker.prefetchJsonFor)(url);
        this.prefetched = url;
      }
    }
  }, {
    key: 'urlToPrefetch',
    value: function urlToPrefetch() {
      return this.props.prefetchURL || this.props.to;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          anchorProps = _props.anchorProps,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          prefetch = _props.prefetch,
          to = _props.to,
          location = _props.location,
          others = (0, _objectWithoutProperties3.default)(_props, ['anchorProps', 'className', 'style', 'children', 'prefetch', 'to', 'location']);


      var props = (0, _extends3.default)({}, anchorProps, (0, _dataProps2.default)(others), {
        'data-moov-link': 'on',
        className: (0, _classnames2.default)(this.props.classes.root, className),
        ref: this.el,
        style: style,
        onClick: this.onClick,
        href: (0, _url.absoluteURL)(to, location) // we always render absolute URLs for SEO purposes
      });

      if (prefetch) {
        props['data-moov-rel'] = 'prefetch';
      }

      var link = _react2.default.createElement(
        'a',
        props,
        children
      );

      if (prefetch === 'visible') {
        return _react2.default.createElement(
          _reactVisibilitySensor2.default,
          { onChange: this.onVisibleChange, partialVisibility: true },
          link
        );
      } else {
        return link;
      }
    }
  }]);
  return Link;
}(_react.Component), _class2.propTypes = {
  /**
   * The path to navigate to when the link is clicked
   */
  to: _propTypes2.default.string,

  /**
   * Data to assign to the history state
   */
  state: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]),

  /**
   * Set to true to force server side navigation.  Defaults to false
   */
  server: _propTypes2.default.bool,

  /**
   * Set to "visible" to prefetch linked page data when the link is scrolled into view.  
   * Set to "always" to prefetch even when the link is hidden.
   */
  prefetch: _propTypes2.default.oneOf(['always', 'visible']),

  /**
   * Set this prop to prefetch a URL other than the one specified in the to prop
   */
  prefetchURL: _propTypes2.default.string,

  /**
   * A function to call when the link is clicked.
   */
  onClick: _propTypes2.default.func,

  /**
   * Props to apply to the underlying html anchor element
   */
  anchorProps: _propTypes2.default.object
}, _class2.defaultProps = {
  anchorProps: {}
}, _temp)) || _class) || _class);
exports.default = Link;
//# sourceMappingURL=Link.js.map