'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _styles = require('@material-ui/core/styles');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      display: 'none',
      justifyContent: 'center',
      alignItems: 'center',
      background: theme.palette.background.default,
      zIndex: 1
    },
    fullscreen: {
      marginTop: '-' + theme.headerHeight + 'px',
      height: '100vh',
      bottom: 'initial',
      zIndex: theme.zIndex.appBar - 10,
      'body.moov-amp &': {
        position: 'fixed',
        marginTop: 0,
        opacity: 0.8
      }
    },
    show: {
      display: 'flex'
    }
  };
};

/**
 * The load mask displays when fetching data from the server.
 */
var LoadMask = (_dec = (0, _styles.withStyles)(styles, { name: 'RSFLoadMask' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(LoadMask, _Component);

  function LoadMask() {
    (0, _classCallCheck3.default)(this, LoadMask);
    return (0, _possibleConstructorReturn3.default)(this, (LoadMask.__proto__ || Object.getPrototypeOf(LoadMask)).apply(this, arguments));
  }

  (0, _createClass3.default)(LoadMask, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.toggleOverflow();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.toggleOverflow();
    }
  }, {
    key: 'toggleOverflow',
    value: function toggleOverflow() {
      if (this.props.fullscreen) {
        if (this.props.show) {
          document.body.style.overflow = 'hidden';
        } else {
          document.body.style.overflow = 'visible';
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _classnames;

      var _props = this.props,
          classes = _props.classes,
          show = _props.show,
          style = _props.style,
          className = _props.className,
          children = _props.children,
          fullscreen = _props.fullscreen;


      return _react2.default.createElement(
        'div',
        { style: style,
          className: (0, _classnames3.default)(classes.root, className, (_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.show, show), (0, _defineProperty3.default)(_classnames, classes.fullscreen, fullscreen), _classnames)) },
        children || _react2.default.createElement(_CircularProgress2.default, { className: classes.progress, color: 'secondary' })
      );
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.body.style.overflow = 'visible';
    }
  }]);
  return LoadMask;
}(_react.Component), _class2.propTypes = {
  /**
   * Set to true to display the load mask, otherwise it will be hidden.
   * Defaults to false.
   */
  show: _propTypes2.default.bool,

  /**
   * Set to true to toggle the overflow style on the body when showing.
   * Defaults to false
   */
  fullscreen: _propTypes2.default.bool
}, _class2.defaultProps = {
  show: false,
  fullscreen: false
}, _temp)) || _class);
exports.default = LoadMask;
//# sourceMappingURL=LoadMask.js.map