"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = exports.MenuModel = exports.MenuItemModel = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _dec, _dec2, _dec3, _class, _class2, _temp2; /**
                                                  * @license
                                                  * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                                  */


var _mobxStateTree = require("mobx-state-tree");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require("mobx-react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Drawer = require("@material-ui/core/Drawer");

var _Drawer2 = _interopRequireDefault(_Drawer);

var _ListItemText = require("@material-ui/core/ListItemText");

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _MenuList = require("@material-ui/core/MenuList");

var _MenuList2 = _interopRequireDefault(_MenuList);

var _MenuItem = require("@material-ui/core/MenuItem");

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _ChevronLeft = require("@material-ui/icons/ChevronLeft");

var _ChevronLeft2 = _interopRequireDefault(_ChevronLeft);

var _ChevronRight = require("@material-ui/icons/ChevronRight");

var _ChevronRight2 = _interopRequireDefault(_ChevronRight);

var _ListItemIcon = require("@material-ui/core/ListItemIcon");

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _withStyles = require("@material-ui/core/styles/withStyles");

var _withStyles2 = _interopRequireDefault(_withStyles);

var _ExpandLess = require("@material-ui/icons/ExpandLess");

var _ExpandLess2 = _interopRequireDefault(_ExpandLess);

var _ExpandMore = require("@material-ui/icons/ExpandMore");

var _ExpandMore2 = _interopRequireDefault(_ExpandMore);

var _Collapse = require("@material-ui/core/Collapse");

var _Collapse2 = _interopRequireDefault(_Collapse);

var _Link = require("./Link");

var _Link2 = _interopRequireDefault(_Link);

var _classnames3 = require("classnames");

var _classnames4 = _interopRequireDefault(_classnames3);

var _AmpMenu = require("./amp/AmpMenu");

var _AmpMenu2 = _interopRequireDefault(_AmpMenu);

var _withTheme = require("@material-ui/core/styles/withTheme");

var _withTheme2 = _interopRequireDefault(_withTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MenuItemModel = exports.MenuItemModel = _mobxStateTree.types.model("MenuItemModel", {
  text: _mobxStateTree.types.optional(_mobxStateTree.types.string, ''),
  url: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  state: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  image: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  items: _mobxStateTree.types.maybe(_mobxStateTree.types.array(_mobxStateTree.types.late(function () {
    return MenuItemModel;
  }))),
  root: _mobxStateTree.types.optional(_mobxStateTree.types.boolean, false),
  server: _mobxStateTree.types.optional(_mobxStateTree.types.boolean, false),
  prefetch: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  expanded: false
}).actions(function (self) {
  return {
    toggle: function toggle() {
      self.expanded = !self.expanded;
    },
    collapse: function collapse() {
      self.expanded = false;
    }
  };
});

var MenuModel = exports.MenuModel = _mobxStateTree.types.model("MenuModel", {
  open: false,
  levels: _mobxStateTree.types.optional(_mobxStateTree.types.array(MenuItemModel), []),
  level: _mobxStateTree.types.optional(_mobxStateTree.types.number, 0)
}).actions(function (self) {
  return {

    /**
     * Closes the menu
     */
    close: function close() {
      self.open = false;
    },


    /**
     * Toggles the open state of the menu
     */
    toggle: function toggle() {
      self.open = !self.open;
    },


    /**
     * Updates the root node
     * @param {Object} root 
     */
    setRoot: function setRoot(root) {
      self.levels[0] = MenuItemModel.create(root);
    },


    /**
     * Selects an item in the menu
     * @param {MenuItem} item
     * @param {Object} options
     */
    setSelected: function setSelected(item) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      item = MenuItemModel.create(item.toJSON());

      self.level++;
      if (self.levels.length <= self.level) {
        self.levels.push(item);
      } else {
        self.levels[self.level] = item;
      }

      if (options.expandFirstItem && item.items.every(function (itm) {
        return itm.expanded === false;
      })) {
        item.items[0].expanded = true;
      }
    },


    /**
     * Goes back one level
     */
    goBack: function goBack() {
      self.level = Math.max(0, self.level - 1);
      self.collapseAll();
    },


    /**
     * Closes all expandable sections
     */
    collapseAll: function collapseAll() {
      setTimeout(function () {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = self.levels[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var level = _step.value;
            var _iteratorNormalCompletion2 = true;
            var _didIteratorError2 = false;
            var _iteratorError2 = undefined;

            try {
              for (var _iterator2 = level.items[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                var item = _step2.value;

                item.collapse();
              }
            } catch (err) {
              _didIteratorError2 = true;
              _iteratorError2 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }
              } finally {
                if (_didIteratorError2) {
                  throw _iteratorError2;
                }
              }
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }, 200);
    }
  };
});

var styles = exports.styles = function styles(theme) {
  return {
    drawer: {
      zIndex: theme.zIndex.modal + 20,
      display: 'flex',
      flexDirection: 'column',
      borderTop: theme.headerHeight + "px solid transparent",
      'body.moov-safari &': {
        // Turning off momentum scrolling on iOS here to fix frozen body issue
        // Source: https://moovweb.atlassian.net/browse/PRPL-342
        '-webkit-overflow-scrolling': 'auto'
      }
    },

    list: {
      flex: 'none',
      overflowY: 'auto',
      overflowX: 'hidden',
      padding: 0
    },

    listPadding: {
      padding: 0
    },

    header: {
      position: 'absolute',
      left: '10px',
      top: '12px'
    },

    icon: {
      marginRight: '0'
    },

    headerText: {
      textAlign: 'center',
      fontWeight: '600',
      textTransform: 'uppercase',
      fontSize: theme.typography.body1.fontSize
    },

    hbox: {
      display: 'flex',
      flexDirection: 'row',
      transition: 'all ease-out .2s'
    },

    listItem: {
      textTransform: 'uppercase',
      lineHeight: 'initial',
      fontSize: theme.typography.body1.fontSize
    },

    link: {
      textDecoration: 'none',
      color: 'inherit'
    },

    listItemImage: {
      width: '40px',
      height: '40px',
      marginRight: 0
    },

    expander: {
      backgroundColor: theme.palette.primary.paper + " !important"
    },

    leaf: (0, _extends3.default)({
      textTransform: 'none'
    }, theme.typography.body1),

    expanded: {
      backgroundColor: theme.palette.secondary.main + " !important",
      color: theme.palette.secondary.contrastText,
      '& svg': {
        color: theme.palette.secondary.contrastText
      }
    },

    drawerFixed: {
      top: 0,
      height: '100vh',
      borderTop: 'none'
    }
  };
};

/**
 * The main app menu that slides in from the left when the AppHeader's menu button is clicked.
 */
var Menu = (_dec = (0, _withTheme2.default)(), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFMenu' }), _dec3 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = _dec3(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Menu, _Component);

  function Menu() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Menu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Menu.__proto__ || Object.getPrototypeOf(Menu)).call.apply(_ref, [this].concat(args))), _this), _this.slideToItem = function (item, menu) {
      var expandFirstItem = _this.props.expandFirstItem;

      menu.setSelected(item, { expandFirstItem: expandFirstItem });
    }, _this.goBack = function () {
      _this.props.app.menu.goBack();
    }, _this.toggleItemExpaned = function (item) {
      item.toggle();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Menu, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          app = _props.app,
          classes = _props.classes,
          rootHeader = _props.rootHeader,
          rootFooter = _props.rootFooter,
          drawerWidth = _props.drawerWidth,
          simple = _props.simple,
          persistent = _props.persistent;
      var amp = app.amp,
          menu = app.menu;
      var levels = menu.levels,
          level = menu.level;

      var position = -drawerWidth * level;

      if (!menu) {
        return null;
      } else if (amp) {
        return _react2.default.createElement(_AmpMenu2.default, this.props);
      }

      return _react2.default.createElement(
        _Drawer2.default,
        {
          variant: persistent ? 'persistent' : 'temporary',
          open: menu.open || persistent,
          onClose: menu.close,
          ModalProps: {
            keepMounted: true
          },
          PaperProps: {
            style: { width: drawerWidth + "px" }
          },
          classes: {
            paper: (0, _classnames4.default)(classes.drawer, (0, _defineProperty3.default)({}, classes.drawerFixed, persistent))
          }
        },
        simple ? this.renderSimple() : _react2.default.createElement(
          "div",
          { className: classes.hbox, style: { transform: "translateX(" + position + "px)", flex: 1 } },
          levels.map(function (list, depth) {
            return _react2.default.createElement(
              _MenuList2.default,
              { style: { width: drawerWidth + "px" }, classes: { root: classes.list, padding: classes.padding }, key: depth },
              list.root && rootHeader,
              !list.root && _react2.default.createElement(
                _MenuItem2.default,
                { divider: true, button: true, onClick: _this2.goBack },
                _react2.default.createElement(
                  _ListItemIcon2.default,
                  { classes: { root: classes.header } },
                  _react2.default.createElement(_ChevronLeft2.default, { className: classes.icon })
                ),
                _react2.default.createElement(_ListItemText2.default, {
                  classes: { root: classes.headerText },
                  primary: _react2.default.createElement(
                    "div",
                    { className: classes.headerText },
                    list.text,
                    " "
                  )
                })
              ),
              list.items && list.items.map(function (item, key) {
                return _this2.renderItem(depth, item, key);
              }),
              list.root && rootFooter
            );
          })
        ),
        this.renderLinksForSEO()
      );
    }

    /**
     * @private
     * Renders simple anchor tags for all links in a collapsed div so that
     * search engine bots can crawl them.
     */

  }, {
    key: "renderLinksForSEO",
    value: function renderLinksForSEO() {
      var root = this.props.app.menu.levels[0];

      if (!root) return null;

      var links = [],
          key = 0;

      var findLinks = function findLinks(_ref2) {
        var items = _ref2.items;

        for (var i = 0; i < items.length; i++) {
          var item = items[i];

          if (item.url) {
            links.push(_react2.default.createElement(
              "li",
              { key: key++ },
              _react2.default.createElement(
                _Link2.default,
                { to: item.url },
                item.text
              )
            ));
          }

          if (item.items) {
            findLinks(item);
          }
        }
      };

      findLinks(root);

      return _react2.default.createElement(
        "noscript",
        null,
        _react2.default.createElement(
          "ul",
          null,
          links
        )
      );
    }

    /**
     * Renders the menu as a simple list of expandable sections
     * @return {MenuList}
     */

  }, {
    key: "renderSimple",
    value: function renderSimple() {
      var _this3 = this;

      var _props2 = this.props,
          rootHeader = _props2.rootHeader,
          rootFooter = _props2.rootFooter,
          menu = _props2.app.menu,
          classes = _props2.classes;

      var root = menu && menu.levels && menu.levels[0];

      if (!root) return null;

      return _react2.default.createElement(
        _MenuList2.default,
        { classes: { padding: classes.list } },
        rootHeader,
        root.items.map(function (item, i) {
          return _this3.renderItem(1, item, i);
        }),
        rootFooter
      );
    }

    /**
     * Renders a menu item
     * @param {Numbere} depth The depth of the item in the menu
     * @param {MenuItem} item The menu item
     * @param {String} key a key for the react element
     * @return {React.Element}
     */

  }, {
    key: "renderItem",
    value: function renderItem(depth, item, key) {
      if (item.items) {
        return this.renderGroup(depth, item, key);
      }
      return this.renderLeaf(item, key);
    }
  }, {
    key: "renderGroup",
    value: function renderGroup(depth, item, key) {
      var _classnames2;

      var _props3 = this.props,
          menu = _props3.app.menu,
          classes = _props3.classes,
          useExpanders = _props3.useExpanders,
          simple = _props3.simple,
          ExpandIcon = _props3.ExpandIcon,
          CollapseIcon = _props3.CollapseIcon,
          theme = _props3.theme;

      var showExpander = simple || depth > 0 && useExpanders;

      ExpandIcon = ExpandIcon || theme.ExpandIcon || _ExpandMore2.default;
      CollapseIcon = CollapseIcon || theme.CollapseIcon || _ExpandLess2.default;

      var elements = [_react2.default.createElement(
        _MenuItem2.default,
        {
          key: key,
          button: true,
          divider: true,
          onClick: showExpander ? this.toggleItemExpaned.bind(this, item) : this.slideToItem.bind(this, item, menu),
          classes: {
            root: (0, _classnames4.default)(classes.listItem, (_classnames2 = {}, (0, _defineProperty3.default)(_classnames2, classes.expanded, item.expanded), (0, _defineProperty3.default)(_classnames2, classes.expander, showExpander), _classnames2))
          }
        },
        item.image && _react2.default.createElement(
          _ListItemIcon2.default,
          null,
          _react2.default.createElement("img", { className: classes.listItemImage, alt: item.text, src: item.image })
        ),
        _react2.default.createElement(_ListItemText2.default, {
          primary: item.text,
          disableTypography: true
        }),
        _react2.default.createElement(
          _ListItemIcon2.default,
          null,
          showExpander ? item.expanded ? _react2.default.createElement(CollapseIcon, { className: classes.icon }) : _react2.default.createElement(ExpandIcon, { className: classes.icon }) : _react2.default.createElement(_ChevronRight2.default, { className: classes.icon })
        )
      )];

      if (showExpander) {
        elements.push(_react2.default.createElement(
          _Collapse2.default,
          { "in": item.expanded, timeout: "auto", key: key + "-collapse" },
          _react2.default.createElement(
            _MenuList2.default,
            { component: "div", classes: { root: classes.list } },
            item.items && item.items.map(this.renderItem.bind(this, depth + 1))
          )
        ));
      }

      return elements;
    }
  }, {
    key: "renderLeaf",
    value: function renderLeaf(item, key) {
      var _props4 = this.props,
          classes = _props4.classes,
          location = _props4.app.location;


      return _react2.default.createElement(
        _Link2.default,
        { key: key, to: item.url, className: classes.link, server: item.server, state: item.state ? function () {
            return JSON.parse(item.state);
          } : null },
        _react2.default.createElement(
          _MenuItem2.default,
          {
            button: true,
            divider: true,
            selected: location.pathname === item.url.replace(/\?.*/, ''),
            classes: {
              root: (0, _classnames4.default)(classes.listItem, classes.leaf)
            }
          },
          item.image && _react2.default.createElement(
            _ListItemIcon2.default,
            null,
            _react2.default.createElement("img", { className: classes.listItemImage, alt: item.text, src: item.image })
          ),
          _react2.default.createElement(_ListItemText2.default, {
            primary: item.text,
            disableTypography: true
          })
        )
      );
    }
  }]);
  return Menu;
}(_react.Component), _class2.propTypes = {
  menu: _propTypes2.default.object,

  /**
   * The width of the drawer in pixels
   */
  drawerWidth: _propTypes2.default.number,

  /**
   * An element to display at the top of the root of the menu
   */
  rootHeader: _propTypes2.default.element,

  /**
   * An element to display at the bottom of the root of the menu
   */
  rootFooter: _propTypes2.default.element,

  /**
   * Set to true to use expandable menu items below depth 1
   */
  useExpanders: _propTypes2.default.bool,

  /**
   * Set to true to expand first item for not root items
   */
  expandFirstItem: _propTypes2.default.bool,

  /**
   * Set to true to display the menu
   */
  open: _propTypes2.default.bool,

  /**
   * Set to true to dock the menu so that it's always open and not modal
   */
  persistent: _propTypes2.default.bool,

  /**
   * CSS classes for this component
   */
  classes: _propTypes2.default.objectOf(_propTypes2.default.string),

  /**
   * Called when the menu is closed
   */
  onClose: _propTypes2.default.func,

  /**
   * Set to true to render a simple set of expanders rather than a multi-level drill down.
   * Defaults to false.
   */
  simple: _propTypes2.default.bool,

  /**
   * The icon to use for collapsed groups
   */
  ExpandIcon: _propTypes2.default.func,

  /**
   * The icon to use for expanded groups
   */
  CollapseIcon: _propTypes2.default.func
}, _class2.defaultProps = {
  drawerWidth: 330,
  simple: false,
  expandFirstItem: false
}, _temp2)) || _class) || _class) || _class) || _class);
exports.default = Menu;
//# sourceMappingURL=Menu.js.map