'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2; /**
                                    * @license
                                    * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                    */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SvgIcon = require('@material-ui/core/SvgIcon');

var _SvgIcon2 = _interopRequireDefault(_SvgIcon);

var _OpenWithLabel = require('./icons/OpenWithLabel');

var _OpenWithLabel2 = _interopRequireDefault(_OpenWithLabel);

var _Menu = require('@material-ui/icons/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _Close = require('@material-ui/icons/Close');

var _Close2 = _interopRequireDefault(_Close);

var _reactTransitionGroup = require('react-transition-group');

var _core = require('@material-ui/core');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      height: '24px',
      width: '24px',
      boxSizing: 'border-box',

      '& .rsf-menu-icon-enter': {
        opacity: 0.01,
        transform: 'scale(0) rotate(45deg)'
      },

      '& .rsf-menu-icon-enter.rsf-menu-icon-enter-active': {
        opacity: 1,
        transform: 'scale(1) rotate(0deg)',
        transition: 'all 250ms ease-out'
      },

      '& .rsf-menu-icon-exit': {
        opacity: 1,
        transform: 'scale(1) rotate(0deg)'
      },

      '& .rsf-menu-icon-exit.rsf-menu-icon-exit-active': {
        opacity: 0.01,
        transform: 'scale(0) rotate(45deg)',
        transition: 'all 250ms ease-in'
      }
    },

    icon: {
      color: theme.palette.action.active,
      position: 'absolute',
      top: 0,
      left: 0
    }
  };
};

/**
 * A menu icon that animates transitions between open and closed states.
 */
var MenuIcon = (_dec = (0, _core.withStyles)(styles, { name: 'RSFMenuIcon' }), _dec(_class = (_temp2 = _class2 = function (_PureComponent) {
  (0, _inherits3.default)(MenuIcon, _PureComponent);

  function MenuIcon() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, MenuIcon);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = MenuIcon.__proto__ || Object.getPrototypeOf(MenuIcon)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      OpenIcon: null,
      CloseIcon: null
    }, _this.cssProps = { classNames: 'rsf-menu-icon', timeout: 300 }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(MenuIcon, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          open = _props.open,
          classes = _props.classes;
      var _state = this.state,
          OpenIcon = _state.OpenIcon,
          CloseIcon = _state.CloseIcon;


      return _react2.default.createElement(
        'div',
        { className: classes.root },
        _react2.default.createElement(
          _reactTransitionGroup.TransitionGroup,
          null,
          !open ? _react2.default.createElement(
            _reactTransitionGroup.CSSTransition,
            (0, _extends3.default)({}, this.cssProps, { key: 'open' }),
            _react2.default.createElement(
              _SvgIcon2.default,
              { className: classes.icon },
              _react2.default.createElement(OpenIcon, null)
            )
          ) : _react2.default.createElement(
            _reactTransitionGroup.CSSTransition,
            (0, _extends3.default)({}, this.cssProps, { key: 'close' }),
            _react2.default.createElement(
              _SvgIcon2.default,
              { className: classes.icon },
              _react2.default.createElement(CloseIcon, null)
            )
          )
        )
      );
    }
  }]);
  return MenuIcon;
}(_react.PureComponent), _class2.propTypes = {
  /**
   * Set to true when the menu is open, otherwise false
   */
  open: _propTypes2.default.bool,

  /**
   * Set to `false` to hide the text "menu" underneath the button when the menu is closed.
   */
  label: _propTypes2.default.bool,

  /**
   * The icon to display when the menu is closed
   */
  OpenIcon: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),

  /**
   * The icon to display when the menu is open
   */
  CloseIcon: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func])
}, _class2.defaultProps = {
  open: false,
  label: true,
  CloseIcon: _Close2.default
}, _class2.getDerivedStateFromProps = function (props) {
  return {
    OpenIcon: props.OpenIcon || (props.label ? _OpenWithLabel2.default : _Menu2.default),
    CloseIcon: props.CloseIcon
  };
}, _temp2)) || _class);
exports.default = MenuIcon;
//# sourceMappingURL=MenuIcon.js.map