'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _dec, _class; /**
                   * @license
                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _Tab = require('@material-ui/core/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _mobxReact = require('mobx-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: (0, _defineProperty3.default)({
      height: '56px'
    }, theme.breakpoints.up('md'), {
      minWidth: '130px'
    }),
    clickEl: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 1
    },
    label: {
      whiteSpace: 'nowrap'
    },
    link: {
      display: 'block',
      height: '100%',
      fontSize: theme.typography.body1.fontSize
    },
    menu: {
      padding: theme.margins.container + 'px'
    },
    menuItem: {
      padding: '1em ' + theme.margins.container + 'px'
    }
  };
};

var NavTab = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFNavTab' }), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3.default)(NavTab, _Component);

  function NavTab() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, NavTab);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = NavTab.__proto__ || Object.getPrototypeOf(NavTab)).call.apply(_ref, [this].concat(args))), _this), _this.onMouseEnter = function (e) {
      _this.props.onMouseEnter({
        target: e.currentTarget,
        menu: _this.getMenu()
      });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(NavTab, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          _state = _props.state,
          url = _props.url,
          prefetch = _props.prefetch,
          text = _props.text,
          item = _props.item;


      return _react2.default.createElement(
        _Track2.default,
        { event: 'topNavClicked', item: item },
        _react2.default.createElement(
          _Link2.default,
          {
            state: function state() {
              return JSON.parse(_state);
            },
            className: classes.link,
            to: url,
            prefetch: prefetch,
            onClick: this.props.onClick,
            anchorProps: {
              onMouseEnter: this.onMouseEnter,
              onMouseLeave: this.props.onMouseLeave,
              "data-th": "topNavClicked"
            }
          },
          _react2.default.createElement(_Tab2.default, {
            className: classes.root,
            label: text,
            classes: {
              label: classes.label
            }
          })
        )
      );
    }
  }, {
    key: 'getMenu',
    value: function getMenu() {
      var _props2 = this.props,
          children = _props2.children,
          item = _props2.item,
          classes = _props2.classes,
          onItemClick = _props2.onItemClick;


      if (children) {
        return children;
      } else if (item.items.length) {
        return _react2.default.createElement(
          'div',
          { className: classes.menu },
          item.items ? item.items.map(function (item, i) {
            return _react2.default.createElement(
              'div',
              { key: i, className: classes.menuItem },
              _react2.default.createElement(
                _Link2.default,
                { to: item.url, onClick: onItemClick },
                item.text
              )
            );
          }) : null
        );
      } else {
        return null;
      }
    }
  }]);
  return NavTab;
}(_react.Component)) || _class) || _class);
exports.default = NavTab;
//# sourceMappingURL=NavTab.js.map