'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabsModel = exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxStateTree = require('mobx-state-tree');

var _Menu = require('./Menu');

var _TabsRow = require('./TabsRow');

var _TabsRow2 = _interopRequireDefault(_TabsRow);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _url = require('./utils/url');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Scrollable navigation tabs for the top of the app. All extra props are spread to the 
 * underlying Material UI Tabs element.  When a tab is clicked, the "top_nav_clicked" analytics
 * event is fired.
 */
var styles = exports.styles = function styles(theme) {
  return {
    tab: {
      height: '56px'
    },
    tabs: {
      maxWidth: theme.maxWidth,
      flex: 1
    },
    link: {
      display: 'block',
      height: '100%',
      fontSize: theme.typography.body1.fontSize
    },
    clickEl: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 1
    },
    root: {
      zIndex: theme.zIndex.appBar - 1,
      display: 'flex',
      justifyContent: 'center',
      position: 'relative',
      borderRadius: 0,
      '&::before': {
        content: "''",
        top: 0,
        left: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to right, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      },
      '&::after': {
        content: "''",
        top: 0,
        right: 0,
        width: '15px',
        height: 'calc(100% - 3px)',
        position: 'absolute',
        background: 'linear-gradient(to left, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)',
        zIndex: 1
      }
    }
  };
};

var NavTabs = (_dec = (0, _withStyles2.default)(styles), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      history = _ref.history;
  return { tabs: app.tabs, amp: app.amp, history: history };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(NavTabs, _Component);

  function NavTabs() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, NavTabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = NavTabs.__proto__ || Object.getPrototypeOf(NavTabs)).call.apply(_ref2, [this].concat(args))), _this), _this.renderTab = function (item) {
      var _this$props = _this.props,
          classes = _this$props.classes,
          amp = _this$props.amp;


      var link = _react2.default.createElement(
        _Link2.default,
        { state: function state() {
            return item.state && JSON.parse(item.state);
          }, className: classes.link, to: item.url, prefetch: item.prefetch, onClick: _this.onLinkClick },
        item.text
      );

      if (amp) {
        return _react2.default.createElement(
          _Track2.default,
          { event: 'topNavClicked', item: item },
          link
        );
      } else {
        return _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(
            _Track2.default,
            { event: 'topNavClicked', item: item },
            _react2.default.createElement('div', { className: classes.clickEl, 'data-th': 'topNavClicked' })
          ),
          link
        );
      }
    }, _this.handleChange = function (_event, newValue) {
      var _this$props2 = _this.props,
          tabs = _this$props2.tabs,
          history = _this$props2.history;

      var item = tabs.items[newValue];
      var url = (0, _url.relativeURL)(item.url);

      if (history) {
        history.push(url, item.state && JSON.parse(item.state));
      } else {
        window.location.href = url;
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(NavTabs, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          tabs = _props.tabs,
          classes = _props.classes,
          staticContext = _props.staticContext,
          history = _props.history,
          elevation = _props.elevation,
          amp = _props.amp,
          tabsProps = (0, _objectWithoutProperties3.default)(_props, ['tabs', 'classes', 'staticContext', 'history', 'elevation', 'amp']);


      if (!tabs) return null;

      var selected = tabs.selected;


      return _react2.default.createElement(
        _Paper2.default,
        { className: classes.root, elevation: elevation },
        _react2.default.createElement(_TabsRow2.default, (0, _extends3.default)({
          initialSelectedIdx: selected,
          onTabChange: this.handleChange,
          items: tabs.items,
          tabRenderer: this.renderTab,
          centered: true,
          classes: {
            root: classes.tabs,
            tab: classes.tab
          }
        }, tabsProps))
      );
    }
  }]);
  return NavTabs;
}(_react.Component), _class2.propTypes = {
  classes: _propTypes2.default.objectOf(_propTypes2.default.string),

  /**
   * Controls the amount of drop shadow.
   */
  elevation: _propTypes2.default.number
}, _class2.defaultProps = {
  elevation: 2
}, _temp2)) || _class) || _class) || _class);
exports.default = NavTabs;
var TabsModel = exports.TabsModel = _mobxStateTree.types.model("TabsModel", {
  items: _mobxStateTree.types.array(_Menu.MenuItemModel)
}).views(function (self) {
  return {
    get selected() {
      var _getParent = (0, _mobxStateTree.getParent)(self),
          location = _getParent.location;

      var url = location.pathname + location.search;
      var index = self.items.findIndex(function (item) {
        return item.url === url;
      });
      return index === -1 ? null : index;
    }
  };
});
//# sourceMappingURL=NavTabs.js.map