'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _LoadMask = require('./LoadMask');

var _LoadMask2 = _interopRequireDefault(_LoadMask);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _reactUniversalComponent = require('react-universal-component');

var _reactUniversalComponent2 = _interopRequireDefault(_reactUniversalComponent);

var _Container = require('./Container');

var _Container2 = _interopRequireDefault(_Container);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _red = require('@material-ui/core/colors/red');

var _red2 = _interopRequireDefault(_red);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch',
      boxSizing: 'border-box'
    },
    error: {
      background: _red2.default[800],
      color: 'white',
      position: 'fixed',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      zIndex: 999999,
      overflow: 'auto'
    }
  };
};

/**
 * Switches the app's main view based on the value of the `page` in `AppModelBase`.  Props are spread to
 * component that is displayed.
 */
var Pages = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFPages' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      router = _ref.router,
      history = _ref.history;
  return { app: app, page: app.page, loading: app.loading, uri: app.uri, router: router, history: history };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(Pages, _Component);

  function Pages() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Pages);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = Pages.__proto__ || Object.getPrototypeOf(Pages)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      loadingComponent: false
    }, _this.mounted = false, _this.cache = {}, _this.createUniversalComponent = function (comp) {
      return (0, _reactUniversalComponent2.default)(comp, {
        loading: _this.componentLoadMask,
        onLoad: _this.onLoad,
        onError: _this.onError,
        error: _this.errorView
      });
    }, _this.onStartLoadingComponent = function () {
      if (_this.mounted) _this.setState({ loadingComponent: true });
    }, _this.onEndLoadingComponent = function () {
      if (_this.mounted) _this.setState({ loadingComponent: false });
    }, _this.componentLoadMask = function () {
      return null;
    }, _this.isLoading = function () {
      return _this.props.loading || _this.state.loadingComponent;
    }, _this.renderLoadMask = function () {
      var _this$props = _this.props,
          loadMasks = _this$props.loadMasks,
          page = _this$props.page;

      var Mask = loadMasks[page];
      var loading = _this.isLoading();

      if (Mask) {
        return loading ? _react2.default.createElement(Mask, null) : null;
      } else {
        return _react2.default.createElement(_LoadMask2.default, { show: loading, fullscreen: true });
      }
    }, _this.errorView = function (_ref3) {
      var error = _ref3.error;
      var classes = _this.props.classes;


      if (process.env.NODE_ENV === 'production') {
        var message = void 0;

        if (error.message.match(/chunk/i)) {
          message = 'An new version of the app is available.  Reloading...';
        } else {
          message = 'An error occurred while attempting to load the page. Please try again later';
        }

        return _react2.default.createElement(
          _Container2.default,
          null,
          _react2.default.createElement(
            _Row2.default,
            null,
            message
          )
        );
      } else {
        return _react2.default.createElement(
          _Container2.default,
          { className: classes.error },
          _react2.default.createElement(
            'pre',
            null,
            error.stack
          )
        );
      }
    }, _this.onError = function (e) {
      if (e.message.match(/chunk/i)) {
        window.location.reload();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Pages, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          components = _props.components,
          app = _props.app;


      if (typeof components === 'function') {
        this.components = this.props.components(this.createUniversalComponent);
      } else {
        this.components = components;
      }

      this.createAndCachePage(app.page);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps) {
      var page = nextProps.app.page;


      if (page !== this.page) {
        this.createAndCachePage(page);
        this.page = page;
      }
    }

    /**
     * Creates a lazy component that automatically manages the loading spinnner
     * @param {React.Component} comp The component to make lazy
     * @return {React.Component}
     */

  }, {
    key: 'createAndCachePage',
    value: function createAndCachePage(page) {
      if (this.cache[page]) return;

      var Comp = this.components[page];

      if (Comp) {
        this.cache[page] = {
          element: _react2.default.createElement(Comp, { key: page, onBefore: this.onStartLoadingComponent, onAfter: this.onEndLoadingComponent })
        };
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          classes = _props2.classes,
          app = _props2.app;

      var loading = this.isLoading();
      var elements = [];

      for (var page in this.cache) {
        var entry = this.cache[page];

        elements.push(_react2.default.createElement(
          'div',
          { key: page, 'data-page': page, style: { display: page === app.page && !loading ? 'block' : 'none' } },
          entry.element
        ));
      }

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        this.renderLoadMask(),
        elements
      );
    }
  }]);
  return Pages;
}(_react.Component), _class2.propTypes = {
  /**
   * An object which serves as a map of page name to component to display.  When the value of `page`
   * in `AppModelBase` matches a key in this object, the corresponding component will be displayed.
   */
  components: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func]).isRequired,

  /**
   * An object which serves as a map of page name to mask to display when the page is loading.  When the value of `page`
   * in `AppModelBase` matches a key in this object, the corresponding mask will be displayed.
   */
  loadMasks: _propTypes2.default.object
}, _class2.defaultProps = {
  loadMasks: {}
}, _temp2)) || _class) || _class) || _class);
exports.default = Pages;
//# sourceMappingURL=Pages.js.map