'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@material-ui/core/');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _Track = require('./Track');

var _Track2 = _interopRequireDefault(_Track);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A promo banner that automatically fires the promo_banner_clicked analytics event.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      display: 'block',
      zIndex: theme.zIndex.appBar - 1
    },
    img: {
      width: '100%',
      zIndex: theme.zIndex.appBar - 1
    }
  };
};

var PromoBanner = (_dec = (0, _core.withStyles)(styles, { name: 'RSFPromoBanner' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(PromoBanner, _Component);

  function PromoBanner() {
    (0, _classCallCheck3.default)(this, PromoBanner);
    return (0, _possibleConstructorReturn3.default)(this, (PromoBanner.__proto__ || Object.getPrototypeOf(PromoBanner)).apply(this, arguments));
  }

  (0, _createClass3.default)(PromoBanner, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          href = _props.href,
          classes = _props.classes,
          onClick = _props.onClick,
          name = _props.name,
          src = _props.src,
          alt = _props.alt,
          imgProps = _props.imgProps;


      return _react2.default.createElement(
        _Track2.default,
        { event: 'promoBannerClicked', name: name, imageUrl: src },
        _react2.default.createElement(
          _Link2.default,
          { to: href, className: classes.root, onClick: onClick },
          _react2.default.createElement(_Image2.default, (0, _extends3.default)({ className: classes.img, src: src, alt: alt, fill: true }, imgProps))
        )
      );
    }
  }]);
  return PromoBanner;
}(_react.Component), _class2.propTypes = {
  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * An name to idenify the banner with analytics
   */
  name: _propTypes2.default.string,

  /**
   * The url to load for the banner image
   */
  src: _propTypes2.default.string,

  /**
   * The location to navigate to when clicked
   */
  href: _propTypes2.default.string,

  /**
   * An alt value for the img tag
   */
  alt: _propTypes2.default.string,

  /**
   * Additional props for the img tag
   */
  imgProps: _propTypes2.default.object
}, _class2.defaultProps = {
  name: 'promo',
  alt: 'promo',
  imgProps: {}
}, _temp)) || _class);
exports.default = PromoBanner;
//# sourceMappingURL=PromoBanner.js.map