'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Add = require('@material-ui/icons/Add');

var _Add2 = _interopRequireDefault(_Add);

var _Remove = require('@material-ui/icons/Remove');

var _Remove2 = _interopRequireDefault(_Remove);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      backgroundColor: theme.palette.divider,
      border: 'none',
      width: '110px',
      padding: 0
    },
    icon: {
      fontSize: theme.typography.title.fontSize
    },
    button: {
      height: 'auto',
      minHeight: '36px',
      width: '36px'
    },
    input: {
      color: theme.typography.body1.color,
      textAlign: 'center',
      padding: 0
    },
    focused: {
      backgroundColor: theme.palette.divider
    },
    underline: {
      '&::before': {
        display: 'none'
      }
    }
  };
};

/**
 * A quantity selector with plus and minus buttons. Any extra props are spread to the 
 * underlying Material UI input element.
 */
var QuantitySelector = (_dec = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return { app: app, ampStateId: ampStateId };
}), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFQuantitySelector' }), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(QuantitySelector, _Component);

  function QuantitySelector() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, QuantitySelector);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = QuantitySelector.__proto__ || Object.getPrototypeOf(QuantitySelector)).call.apply(_ref2, [this].concat(args))), _this), _this.onChange = function (value) {
      var _this$props = _this.props,
          minValue = _this$props.minValue,
          maxValue = _this$props.maxValue,
          product = _this$props.product;


      if (value >= minValue && value <= maxValue) {
        _this.props.onChange(value);

        if (product) {
          product.setQuantity(value);
        }
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(QuantitySelector, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          app = _props.app,
          classes = _props.classes,
          addIcon = _props.addIcon,
          subtractIcon = _props.subtractIcon,
          value = _props.value,
          minValue = _props.minValue,
          maxValue = _props.maxValue,
          analytics = _props.analytics,
          product = _props.product,
          inputProps = _props.inputProps,
          ampStateId = _props.ampStateId,
          other = (0, _objectWithoutProperties3.default)(_props, ['app', 'classes', 'addIcon', 'subtractIcon', 'value', 'minValue', 'maxValue', 'analytics', 'product', 'inputProps', 'ampStateId']);


      if (product) {
        value = product.quantity;
      }

      var quantitySelector = classes.quantitySelector,
          icon = classes.icon,
          button = classes.button,
          inputClasses = (0, _objectWithoutProperties3.default)(classes, ['quantitySelector', 'icon', 'button']);


      var bindProps = (0, _defineProperty3.default)({
        inputProps: (0, _extends3.default)({}, inputProps, {
          "amp-bind": 'value=>' + ampStateId + '.quantity'
        })
      }, app.amp ? 'readOnly' : 'disabled', true);

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(_Input2.default, (0, _extends3.default)({
          startAdornment: _react2.default.createElement(
            _IconButton2.default,
            {
              size: 'small',
              classes: { root: button },
              onClick: function onClick() {
                return _this2.onChange(value - 1);
              },
              on: 'tap:AMP.setState({ ' + ampStateId + ': { quantity: max(' + minValue + ', (' + ampStateId + '.quantity || ' + value + ') - 1) } })'
            },
            subtractIcon || _react2.default.createElement(_Remove2.default, { classes: { root: icon } })
          ),
          endAdornment: _react2.default.createElement(
            _IconButton2.default,
            {
              size: 'small',
              classes: { root: button },
              onClick: function onClick() {
                return _this2.onChange(value + 1);
              },
              on: 'tap:AMP.setState({ ' + ampStateId + ': { quantity: min(' + maxValue + ', (' + ampStateId + '.quantity || ' + value + ') + 1) } })'
            },
            addIcon || _react2.default.createElement(_Add2.default, { classes: { root: icon } })
          ),
          onChange: this.onChange,
          value: value,
          classes: (0, _extends3.default)({
            underline: classes.underline
          }, inputClasses)
        }, bindProps, other))
      );
    }
  }]);
  return QuantitySelector;
}(_react.Component), _class2.propTypes = {
  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * The plus icon
   */
  addIcon: _propTypes2.default.element,

  /**
   * The minus icon
   */
  subtractIcon: _propTypes2.default.element,

  /**
   * The current value
   */
  value: _propTypes2.default.number,

  /**
   * The minimum value.  Defaults to 1.
   */
  minValue: _propTypes2.default.number,

  /**
   * The maximum value.  Defaults to 100.
   */
  maxValue: _propTypes2.default.number,

  /**
   * Called when the value is changed.  The new value is passed as the only argument
   */
  onChange: _propTypes2.default.func,

  /**
   * If specified, this component will automatically control the price of a product.
   * This should be an instance of ProductModelBase
   */
  product: _propTypes2.default.object
}, _class2.defaultProps = {
  onChange: Function.prototype,
  minValue: 1,
  maxValue: 100,
  value: 1
}, _temp2)) || _class) || _class) || _class);
exports.default = QuantitySelector;
//# sourceMappingURL=QuantitySelector.js.map