'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Star = require('@material-ui/icons/Star');

var _Star2 = _interopRequireDefault(_Star);

var _StarBorder = require('@material-ui/icons/StarBorder');

var _StarBorder2 = _interopRequireDefault(_StarBorder);

var _StarHalf = require('@material-ui/icons/StarHalf');

var _StarHalf2 = _interopRequireDefault(_StarHalf);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Box = require('./Box');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Displays a star rating corresponding to the provided value
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      '& svg': {
        color: theme.palette.rating,
        height: '16px',
        width: '16px',
        marginLeft: '-2px',
        display: 'block'
      }
    },
    blank: {
      '& svg': {
        color: theme.palette.divider
      }
    },
    reviewsLabel: {
      marginLeft: '3px'
    }
  };
};

var Rating = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFRating' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Rating, _Component);

  function Rating() {
    (0, _classCallCheck3.default)(this, Rating);
    return (0, _possibleConstructorReturn3.default)(this, (Rating.__proto__ || Object.getPrototypeOf(Rating)).apply(this, arguments));
  }

  (0, _createClass3.default)(Rating, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          value = _props.value,
          label = _props.label,
          reviewCount = _props.reviewCount,
          className = _props.className,
          product = _props.product;

      var stars = [];

      if (product) {
        reviewCount = product.reviewCount;
        value = product.rating;
      }

      for (var i = 1; i <= 5; i++) {
        if (value == null || value >= i) {
          stars.push(_react2.default.createElement(_Star2.default, { key: i }));
        } else if (value >= i - 0.5) {
          stars.push(_react2.default.createElement(_StarHalf2.default, { key: i }));
        } else {
          stars.push(_react2.default.createElement(_StarBorder2.default, { key: i }));
        }
      }

      return _react2.default.createElement(
        _Box.Hbox,
        null,
        _react2.default.createElement(
          'div',
          { className: (0, _classnames3.default)(classes.root, className, (0, _defineProperty3.default)({}, classes.blank, value == null)) },
          stars
        ),
        reviewCount ? _react2.default.createElement(
          'div',
          { className: classes.reviewsLabel },
          '(',
          reviewCount,
          label(reviewCount),
          ')'
        ) : null
      );
    }
  }]);
  return Rating;
}(_react.Component), _class2.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: _propTypes2.default.object,

  /**
   * The number of stars to display.  Can be an integer or a float
   * ending in .5.
   */
  value: _propTypes2.default.number,

  /**
   * The number of reviews
   */
  reviewCount: _propTypes2.default.number,

  /**
   * A function that returns the label displayed to the right of the review count.
   * For example: `<Rating label={reviewCount => <span> {reviewCount == 1 ? 'review' : 'reviews'}</span>}/>`.  
   * This value used in this example is the default.
   */
  label: _propTypes2.default.func,

  /**
   * An instance of ProductModelBase.  You can set this instead of setting value an reviewCount individually.
   */
  product: _propTypes2.default.object
}, _class2.defaultProps = {
  label: function label(reviewCount) {
    return _react2.default.createElement(
      'span',
      null,
      ' ',
      reviewCount == 1 ? 'review' : 'reviews'
    );
  }
}, _temp)) || _class);
exports.default = Rating;
//# sourceMappingURL=Rating.js.map