'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _dec, _dec2, _class; /**
                          * @license
                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _redboxReact = require('redbox-react');

var _redboxReact2 = _interopRequireDefault(_redboxReact);

var _lodash = require('lodash');

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  var _amp;

  return {
    amp: (_amp = {
      fontWeight: 'bold',
      backgroundColor: 'red',
      color: 'white',
      position: 'fixed',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      overflow: 'auto',
      zIndex: theme.zIndex.amp.modal + 10,
      padding: theme.margins.container + 'px',
      whiteSpace: 'pre-wrap'
    }, (0, _defineProperty3.default)(_amp, 'fontWeight', 'bold'), (0, _defineProperty3.default)(_amp, 'margin', 0), _amp)
  };
};

/**
 * A basic error view for use in development.  Since this shows a low-level error message and stack trace, 
 * you should replace this with something more user-friendly in production.
 */
var Redbox = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFRedbox' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = function (_Component) {
  (0, _inherits3.default)(Redbox, _Component);

  function Redbox() {
    (0, _classCallCheck3.default)(this, Redbox);
    return (0, _possibleConstructorReturn3.default)(this, (Redbox.__proto__ || Object.getPrototypeOf(Redbox)).apply(this, arguments));
  }

  (0, _createClass3.default)(Redbox, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // log original error message to the console
      var _props$app = this.props.app,
          error = _props$app.error,
          stack = _props$app.stack;

      console.error(this.reformat(error));
      console.error(this.createError(error, stack));
    }
  }, {
    key: 'render',
    value: function render() {
      // render improved error message
      var _props = this.props,
          _props$app2 = _props.app,
          error = _props$app2.error,
          stack = _props$app2.stack,
          amp = _props$app2.amp,
          classes = _props.classes;


      if (amp) {
        return _react2.default.createElement(
          'pre',
          { className: classes.amp },
          this.reformat(error),
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          stack
        );
      } else {
        return _react2.default.createElement(_redboxReact2.default, { error: this.createError(this.reformat(error), stack) });
      }
    }

    /**
     * Creates an Error with the specified message and stack
     * @param {String} message 
     * @param {String[]} stack 
     * @return {Error}
     */

  }, {
    key: 'createError',
    value: function createError(message, stack) {
      var error = new Error(this.reformat(message));
      error.stack = stack;
      return error;
    }

    /**
     * Adds additional helpful info to an error message
     * @param {String} message The original error message
     * @return {String} 
     */

  }, {
    key: 'reformat',
    value: function reformat(message) {
      try {
        if (message.includes('[mobx-state-tree] Error while converting')) {
          // mobx-state-tree error
          var filename = (message.match(/"filename":"(\w+)"/) || [])[1];
          var model = message.match(/is not assignable to type: `\((\w+) \|/)[1];
          var paths = message.match(/at path "([^"]*)"/g).map(function (path) {
            return path.match(/at path "([^"]*)"/)[1];
          });

          return 'mobx-state-tree - attempted to assign a value of incorrect type to ' + (0, _lodash.uniq)(paths).join(', ') + (model === 'AnonymousModel' ? '' : ' in ' + model) + (filename ? ' (' + filename + ')' : '') + '.';
        } else {
          return message;
        }
      } catch (e) {
        return message;
      }
    }
  }]);
  return Redbox;
}(_react.Component)) || _class) || _class) || _class);
exports.default = Redbox;
//# sourceMappingURL=Redbox.js.map