'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp; /**
                    * @license
                    * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                    */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _GridListTile = require('@material-ui/core/GridListTile');

var _GridListTile2 = _interopRequireDefault(_GridListTile);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A responsive grid of tiles that changes the number of columns based on the viewport size.
 * This component commonly used in product listings and search results.
 */
var ResponsiveTiles = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(ResponsiveTiles, _Component);

  function ResponsiveTiles(props) {
    (0, _classCallCheck3.default)(this, ResponsiveTiles);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ResponsiveTiles.__proto__ || Object.getPrototypeOf(ResponsiveTiles)).call(this, props));

    _this.Tiles = createInner(props);
    return _this;
  }

  (0, _createClass3.default)(ResponsiveTiles, [{
    key: 'render',
    value: function render() {
      var Tiles = this.Tiles;
      var _props = this.props,
          cols = _props.cols,
          spacing = _props.spacing,
          others = (0, _objectWithoutProperties3.default)(_props, ['cols', 'spacing']);

      return _react2.default.createElement(Tiles, others);
    }
  }]);
  return ResponsiveTiles;
}(_react.Component), _class.propTypes = {
  /**
   * A map of viewport widths to number of columns.  For example:
   * ```
   *  cols={{
   *    xs: 2,
   *    sm: 3,
   *    md: 4,
   *    lg: 5,
   *    xl: 5
   *  }}
   * ```
   * 
   * The amounts shown in the example above are the defaults.
   */
  cols: _propTypes2.default.object,

  /**
   * The spacing between the tiles in pixels. Defaults to 15
   */
  spacing: _propTypes2.default.number
}, _class.defaultProps = {
  cols: {
    xs: 2,
    sm: 3,
    md: 4,
    lg: 5,
    xl: 5
  },
  spacing: 15
}, _temp);
exports.default = ResponsiveTiles;


function createInner(_ref) {
  var spacing = _ref.spacing,
      cols = _ref.cols;

  var styles = function styles(theme) {
    var breakpoints = {};

    // Breakpoints MUST be set in order from smallest to largest
    Object.keys(cols).map(function (width) {
      return {
        key: width,
        value: cols[width],
        width: 100 / cols[width] + '%'
      };
    }).sort(function (a, b) {
      return a.value - b.value;
    }).forEach(function (_ref2) {
      var key = _ref2.key,
          width = _ref2.width;

      breakpoints[theme.breakpoints.up(key)] = { width: width };
    });

    return {
      root: {
        display: 'flex',
        flexWrap: 'wrap',
        overflowY: 'auto',
        listStyle: 'none',
        padding: 0,
        margin: '-' + spacing / 2 + 'px',
        WebkitOverflowScrolling: 'touch' // Add iOS momentum scrolling.
      },
      tile: (0, _extends3.default)({}, breakpoints, {
        padding: spacing / 2 + 'px',
        height: 'auto'
      })
    };
  };

  var ResponsiveTilesInner = function (_Component2) {
    (0, _inherits3.default)(ResponsiveTilesInner, _Component2);

    function ResponsiveTilesInner() {
      (0, _classCallCheck3.default)(this, ResponsiveTilesInner);
      return (0, _possibleConstructorReturn3.default)(this, (ResponsiveTilesInner.__proto__ || Object.getPrototypeOf(ResponsiveTilesInner)).apply(this, arguments));
    }

    (0, _createClass3.default)(ResponsiveTilesInner, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props,
            className = _props2.className,
            classes = _props2.classes,
            children = _props2.children,
            other = (0, _objectWithoutProperties3.default)(_props2, ['className', 'classes', 'children']);


        return _react2.default.createElement(
          'ul',
          (0, _extends3.default)({
            className: (0, _classnames2.default)(classes.root, className)
          }, other),
          _react2.default.Children.map(children, function (child, i) {
            if (!_react2.default.isValidElement(child)) {
              return null;
            }
            return _react2.default.createElement(
              _GridListTile2.default,
              { key: i, classes: { root: classes.tile } },
              child
            );
          })
        );
      }
    }]);
    return ResponsiveTilesInner;
  }(_react.Component);

  return (0, _withStyles2.default)(styles, { name: 'RSFResponsiveTiles' })(ResponsiveTilesInner);
}
//# sourceMappingURL=ResponsiveTiles.js.map