'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Search = require('@material-ui/icons/Search');

var _Search2 = _interopRequireDefault(_Search);

var _Clear = require('@material-ui/icons/Clear');

var _Clear2 = _interopRequireDefault(_Clear);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactHighlighter = require('react-highlighter');

var _reactHighlighter2 = _interopRequireDefault(_reactHighlighter);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _mobxReact = require('mobx-react');

var _mobxStateTree = require('mobx-state-tree');

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

var _Container = require('./Container');

var _Container2 = _interopRequireDefault(_Container);

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _Drawer = require('@material-ui/core/Drawer');

var _Drawer2 = _interopRequireDefault(_Drawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A modal search UI that displays a single text search field and grouped results.  The
 * data for this component is defined in react-storefront/model/SearchModelBase.  In most cases, you can
 * add this component to your PWA simply by adding it to App.js without any props:
 * 
 *  <SearchDrawer/>
 * 
 * When the user enters text in the search field, SearchModelBase calls /search/suggest, which by default is mapped to
 * src/search/suggest-handler.js in the starter app.
 * 
 * See https://github.com/moovweb/react-storefront-boilerplate/tree/master/src/search/suggest-handler.js for
 * the placeholder implementation of the suggestion API.
 * 
 * When the user taps the search icon or types the enter key in the search field, the drawer closes and the url
 * is set to /search?q=(the user's search text).  
 * 
 * See src/routes.js to edit the mappings for /search and /search/suggest.
 */
var styles = exports.styles = function styles(theme) {
  return {
    root: {
      zIndex: 9999
    },
    paper: {
      backgroundColor: 'rgba(255, 255, 255, .7)'
    },
    paperAnchorBottom: {
      top: '0'
    },
    wrap: {
      height: '100vh',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch'
    },
    header: {
      backgroundColor: theme.palette.primary.main,
      padding: theme.margins.container,
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch'
    },
    closeButton: {
      color: theme.palette.primary.contrastText,
      margin: '-10px -10px 10px 0',
      alignSelf: 'flex-end',
      '& span': {
        textTransform: 'uppercase',
        fontWeight: 'bold'
      }
    },
    closeButtonText: {
      border: '1px solid ' + theme.palette.primary.contrastText,
      margin: '0 0 10px 0'
    },
    searchField: {
      flexGrow: 1,
      border: 0,
      borderRadius: '35px',
      backgroundColor: theme.palette.background.paper,
      margin: '10px'
    },
    searchInput: {
      padding: '0 0 0 20px'
    },
    groupCaption: {
      textTransform: 'uppercase',
      margin: '30px 0 10px 0'
    },
    group: {
      listStyle: 'none',
      margin: 0,
      padding: 0,
      '& a strong': {
        fontWeight: 'bold',
        color: theme.palette.text.primary
      }
    },
    thumbnailGroup: {
      display: 'flex',
      listStyle: 'none',
      margin: '0 -15px',
      padding: '0 10px',
      overflowX: 'auto',
      '& > li': {
        margin: '5px'
      },
      '& img': {
        height: '120px'
      }
    },
    thumbnail: {
      marginBottom: '10px'
    },
    results: {
      flex: 1,
      overflowY: 'auto',
      padding: '10px'
    },
    loading: {
      display: 'flex',
      flex: 1,
      alignItems: 'center',
      justifyContent: 'center'
    }
  };
};

var SearchDrawer = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFSearchDrawer' }), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var search = _ref.app.search,
      history = _ref.history,
      theme = _ref.theme;
  return { search: search, history: history, theme: theme };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(SearchDrawer, _Component);

  function SearchDrawer(_ref2) {
    var search = _ref2.search;
    (0, _classCallCheck3.default)(this, SearchDrawer);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SearchDrawer.__proto__ || Object.getPrototypeOf(SearchDrawer)).call(this));

    _this.onSearchPatch = function (_ref3) {
      var path = _ref3.path,
          value = _ref3.value;
      var blurBackground = _this.props.blurBackground;


      if (path === '/show') {
        if (value) {
          setTimeout(function () {
            return _this.input.focus();
          }, 250);
        } else {
          _this.input.blur();
        }
        if (blurBackground) {
          document.body.classList.toggle('moov-blur', value);
        }
      }
    };

    _this.onChangeSearchText = function (text) {
      _this.props.search.setText(text);
    };

    _this.clearSearch = function () {
      _this.onChangeSearchText('');
    };

    _this.hide = function () {
      _this.props.search.toggle(false);
    };

    _this.onSearchSubmit = function () {
      _this.props.history.push('/search?q=' + encodeURIComponent(_this.props.search.text));
      _this.hide();
    };

    _this.onSearchFormSubmit = function (e) {
      e.preventDefault();
      _this.onSearchSubmit();
    };

    _this.onInputFocus = function () {
      var input = _this.input;

      input.setSelectionRange(0, input.value.length);
    };

    _this.inputRef = function (input) {
      return _this.input = input;
    };
    (0, _mobxStateTree.onPatch)(search, _this.onSearchPatch);
    return _this;
  }

  (0, _createClass3.default)(SearchDrawer, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          classes = _props.classes,
          search = _props.search,
          placeholder = _props.placeholder,
          blurBackground = _props.blurBackground;

      var loading = search.loading;
      var contentReady = this.props.search.text && !loading;

      return _react2.default.createElement(
        _Drawer2.default,
        {
          open: search.show,
          anchor: 'bottom',
          className: classes.root,
          classes: {
            paper: blurBackground ? classes.paper : '',
            paperAnchorBottom: classes.paperAnchorBottom
          },
          ModalProps: {
            hideBackdrop: true
          }
        },
        _react2.default.createElement(
          'div',
          { className: classes.wrap },
          _react2.default.createElement(
            'form',
            { className: classes.header, onSubmit: this.onSearchFormSubmit },
            this.renderCloseButton(),
            _react2.default.createElement(_Input2.default, {
              type: 'text',
              value: search.text,
              placeholder: placeholder,
              onChange: function onChange(e) {
                return _this2.onChangeSearchText(e.target.value);
              },
              onFocus: this.onInputFocus,
              disableUnderline: true,
              inputRef: this.inputRef,
              classes: {
                root: classes.searchField,
                input: classes.searchInput
              },
              endAdornment: search.text ? _react2.default.createElement(
                _IconButton2.default,
                {
                  onClick: this.clearSearch,
                  className: classes.searchReset
                },
                _react2.default.createElement(_Clear2.default, null)
              ) : _react2.default.createElement(
                _IconButton2.default,
                {
                  onClick: this.onSearchSubmit,
                  className: classes.searchButton
                },
                _react2.default.createElement(_Search2.default, null)
              )
            })
          ),
          loading && _react2.default.createElement(
            'div',
            { className: classes.loading },
            _react2.default.createElement(_CircularProgress2.default, null)
          ),
          contentReady && _react2.default.createElement(
            'div',
            { className: classes.results },
            this.props.search.groups.map(function (group) {
              return _react2.default.createElement(
                _Container2.default,
                { key: group.caption },
                _react2.default.createElement(
                  _Typography2.default,
                  { className: classes.groupCaption },
                  group.caption
                ),
                _this2.renderGroup(group)
              );
            })
          )
        )
      );
    }
  }, {
    key: 'renderCloseButton',
    value: function renderCloseButton() {
      var _classnames;

      var _props2 = this.props,
          classes = _props2.classes,
          closeButtonText = _props2.closeButtonText,
          CloseButtonIcon = _props2.CloseButtonIcon;

      var ButtonElement = closeButtonText ? _Button2.default : _IconButton2.default;

      return _react2.default.createElement(
        ButtonElement,
        {
          className: (0, _classnames4.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.closeButton, true), (0, _defineProperty3.default)(_classnames, classes.closeButtonText, closeButtonText != null), _classnames)),
          variant: 'raised',
          color: 'primary',
          onClick: this.hide
        },
        closeButtonText || _react2.default.createElement(CloseButtonIcon, null)
      );
    }
  }, {
    key: 'renderGroup',
    value: function renderGroup(group) {
      var _classnames2,
          _this3 = this;

      var classes = this.props.classes;


      return _react2.default.createElement(
        'ul',
        { className: (0, _classnames4.default)((_classnames2 = {}, (0, _defineProperty3.default)(_classnames2, classes.group, !group.thumbnails), (0, _defineProperty3.default)(_classnames2, classes.thumbnailGroup, group.thumbnails), _classnames2)) },
        group.results.map(function (result, i) {
          return _react2.default.createElement(
            'li',
            { key: i },
            _react2.default.createElement(
              _Link2.default,
              { to: result.url, onClick: _this3.hide },
              group.thumbnails ? _this3.renderThumbnail(result) : _this3.renderLinkText(result)
            )
          );
        })
      );
    }
  }, {
    key: 'renderLinkText',
    value: function renderLinkText(result) {
      return _react2.default.createElement(
        _Typography2.default,
        null,
        _react2.default.createElement(
          _reactHighlighter2.default,
          { search: this.props.search.text },
          result.text
        )
      );
    }
  }, {
    key: 'renderThumbnail',
    value: function renderThumbnail(result) {
      var classes = this.props.classes;


      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_Image2.default, { className: classes.thumbnail, src: result.thumbnail, height: result.thumbnailHeight, width: result.thumbnailWidth })
        ),
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            _Typography2.default,
            null,
            result.text
          )
        )
      );
    }

    /**
     * Updates the model when the user enteres search text
     */


    /**
     * Clears the search text
     */


    /**
     * Hides the drawer
     */


    /**
     * Submits the search and hides the drawer
     */


    /**
     * Listener to enable submitting the search by hitting enter
     */


    /**
     * Selects all of the text when the input is focused
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.blurBackground && this.props.search.show) {
        document.body.classList.remove('moov-blur');
      }
    }
  }]);
  return SearchDrawer;
}(_react.Component), _class2.propTypes = {
  /**
   * The placeholder text for the input.  Defaults to "Search..."
   */
  placeholder: _propTypes2.default.string,
  /**
   * Set this prop to use a text button instead of an icon for the close button.  If set, CloseButtonIcon 
   * will be ignored
   */
  closeButtonText: _propTypes2.default.string,
  /**
   * Overrides the default close icon.  Takes a React component.
   */
  CloseButtonIcon: _propTypes2.default.func,
  /**
   * Set to false to disable background blurring.  Defaults to true.
   */
  blurBackground: _propTypes2.default.bool
}, _class2.defaultProps = {
  placeholder: 'Search...',
  CloseButtonIcon: function CloseButtonIcon() {
    return _react2.default.createElement(_Clear2.default, null);
  },
  blurBackground: true
}, _temp)) || _class) || _class) || _class);
exports.default = SearchDrawer;
//# sourceMappingURL=SearchDrawer.js.map