'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SearchPopupModel = exports.ProductSuggestions = exports.CategorySearches = exports.SuggestedSearch = exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Search = require('@material-ui/icons/Search');

var _Search2 = _interopRequireDefault(_Search);

var _Clear = require('@material-ui/icons/Clear');

var _Clear2 = _interopRequireDefault(_Clear);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _mobxStateTree = require('mobx-state-tree');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactHighlighter = require('react-highlighter');

var _reactHighlighter2 = _interopRequireDefault(_reactHighlighter);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _mobxReact = require('mobx-react');

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A search popup with suggestions of search texts, categories, products.
 * can be used like composition
 * <SearchPopup>
 *   <SuggestedSearch />
 *   <CategorySearches />
 *   <ProductSuggestions />
 * </SearchPopup>
 */
var styles = exports.styles = function styles(theme) {
  return {
    searchPopup: {
      position: 'fixed',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: 'rgba(255, 255, 255, .8)',
      zIndex: 9999,
      padding: '20px'
    },
    closeButton: {
      backgroundColor: theme.palette.white,
      border: '1px solid ' + theme.palette.border,
      '& span': {
        textTransform: 'uppercase',
        fontWeight: 'bold'
      }
    },
    searchForm: {
      display: 'flex',
      marginTop: '20px',
      position: 'relative'
    },
    searchReset: {
      position: 'absolute',
      top: 0,
      right: '50px'
    },
    flexInput: {
      flexGrow: 1,
      backgroundColor: theme.palette.secondary.light,
      boxSizing: 'border-box',
      height: 48,
      padding: '8px 12px 8px 12px'
    },
    searchButton: {
      backgroundColor: theme.palette.darkButton,
      borderRadius: 0,
      '& svg': {
        fill: theme.palette.white
      }
    },
    suggestionHeader: {
      textTransform: 'uppercase',
      marginTop: '40px'
    },
    suggestionsList: {
      listStyle: 'none',
      margin: 0,
      padding: 0,
      '& a strong': {
        fontWeight: 'bold',
        color: theme.palette.text.primary
      }
    },
    productImage: {
      height: '120px',
      width: '120px',
      display: 'block',
      marginBottom: '15px'
    },
    productsSuggestions: {
      display: 'flex',
      listStyle: 'none',
      margin: 0,
      padding: 0,
      overflowX: 'auto',
      '& > li': {
        margin: '5px'
      }
    },
    searchResultsWrapper: {
      position: 'absolute',
      top: '125px',
      bottom: 0,
      overflowY: 'auto',
      left: '20px',
      right: 0
    },
    loading: {
      paddingTop: '20%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    }
  };
};

var SearchPopup = (_dec = (0, _withStyles2.default)(styles), _dec2 = (0, _mobxReact.inject)(function (_ref) {
  var _ref$app = _ref.app,
      searchPopup = _ref$app.searchPopup,
      search = _ref$app.search,
      history = _ref.history;
  return { searchPopup: searchPopup, search: search, history: history };
}), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(SearchPopup, _Component);

  function SearchPopup() {
    var _ref2;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, SearchPopup);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref2 = SearchPopup.__proto__ || Object.getPrototypeOf(SearchPopup)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      search: ''
    }, _this.onChangeSearchText = function (text) {
      var search = _this.props.search;

      _this.setState({ search: text });
      // only apply loading spinner if there is some text
      // in case of input clearing we rejecting previous requests so they won't fire loading flag reset
      // that's why we're doing this here
      search.setLoading(!!text);
      search.run(text);
    }, _this.hidePopup = function () {
      var searchPopup = _this.props.searchPopup;

      searchPopup.setIsPopupOpened(false);
      _this.onChangeSearchText('');
    }, _this.onSearchSubmit = function (event) {
      var history = _this.props.history;

      event.preventDefault();
      history.push('/search?text=' + _this.state.search);
      _this.hidePopup();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(SearchPopup, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          searchPopup = _props.searchPopup,
          classes = _props.classes,
          search = _props.search,
          children = _props.children,
          suggestionResultsLimit = _props.suggestionResultsLimit;

      var searches = [].concat((0, _toConsumableArray3.default)(search.searches)).splice(0, suggestionResultsLimit);
      var categories = [].concat((0, _toConsumableArray3.default)(search.categories)).splice(0, suggestionResultsLimit);
      var results = _react2.default.Children.map(children, function (list) {
        return _react2.default.cloneElement(list, {
          searches: searches,
          classes: classes,
          categories: categories,
          products: search.products,
          searchText: _this2.state.search,
          hidePopup: _this2.hidePopup
        });
      });

      var loading = search.loading;
      var contentReady = this.state.search && !loading;

      return _react2.default.createElement(
        'form',
        { onSubmit: this.onSearchSubmit, onReset: function onReset() {
            _this2.onChangeSearchText('');
          } },
        searchPopup.opened && _react2.default.createElement(
          'div',
          { className: classes.searchPopup },
          _react2.default.createElement(
            _Button2.default,
            {
              className: classes.closeButton,
              variant: 'raised',
              onClick: this.hidePopup },
            'Cancel'
          ),
          _react2.default.createElement(
            'div',
            { className: classes.searchForm },
            _react2.default.createElement(_Input2.default, {
              type: 'text',
              className: classes.flexInput,
              value: this.state.search,
              onChange: function onChange(e) {
                _this2.onChangeSearchText(e.target.value);
              }
            }),
            _react2.default.createElement(
              _IconButton2.default,
              {
                variant: 'raised',
                type: 'submit',
                className: classes.searchButton
              },
              _react2.default.createElement(_Search2.default, null)
            ),
            this.state.search && _react2.default.createElement(
              _IconButton2.default,
              { type: 'reset', className: classes.searchReset },
              _react2.default.createElement(_Clear2.default, null)
            )
          ),
          loading && _react2.default.createElement(
            'div',
            { className: classes.loading },
            _react2.default.createElement(_CircularProgress2.default, null)
          ),
          contentReady && _react2.default.createElement(
            'div',
            { className: classes.searchResultsWrapper },
            results
          )
        )
      );
    }
  }]);
  return SearchPopup;
}(_react.Component), _class2.defaultProps = {
  suggestionResultsLimit: 3
}, _class2.propTypes = {
  /**
   * searchPopup holds state of popup
   */
  searchPopup: _propTypes2.default.shape({
    opened: _propTypes2.default.bool.isRequired
  }),
  /**
   * search contains lists of suggestions
   */
  search: _propTypes2.default.shape({
    searches: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
      text: _propTypes2.default.string
    })),
    categories: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
      id: _propTypes2.default.string,
      url: _propTypes2.default.string,
      name: _propTypes2.default.string
    })),
    products: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
      id: _propTypes2.default.string,
      url: _propTypes2.default.string,
      name: _propTypes2.default.string,
      image: _propTypes2.default.string
    }))
  }),

  /**
   * limit for suggestion results list
   */
  suggestionResultsLimit: _propTypes2.default.number,

  /**
   * Suggestion results components
   */
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]).isRequired,

  history: _propTypes2.default.shape({
    push: _propTypes2.default.func.isRequired
  })
}, _temp2)) || _class) || _class) || _class);
exports.default = SearchPopup;


var commonPropTypes = {
  hidePopup: _propTypes2.default.func,
  classes: _propTypes2.default.shape({
    suggestionHeader: _propTypes2.default.string,
    suggestionsList: _propTypes2.default.string
  })

  /**
   * Search text suggestions
   * @param props
   * @constructor
   */
};var SuggestedSearch = exports.SuggestedSearch = function SuggestedSearch(props) {
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      _Typography2.default,
      { component: 'h2', className: props.classes.suggestionHeader },
      'Suggested search'
    ),
    _react2.default.createElement(
      'ul',
      { className: props.classes.suggestionsList },
      props.searches.map(function (item, i) {
        return _react2.default.createElement(
          'li',
          { key: i },
          _react2.default.createElement(
            _Link2.default,
            { to: '/search?text=' + item.text, onClick: props.hidePopup },
            _react2.default.createElement(
              _reactHighlighter2.default,
              { search: props.searchText },
              item.text
            )
          )
        );
      })
    )
  );
};

SuggestedSearch.propTypes = (0, _extends3.default)({}, commonPropTypes, {
  searches: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
    text: _propTypes2.default.string
  })),
  searchText: _propTypes2.default.string

  /**
   * Search categories suggestions
   * @param props
   * @constructor
   */
});var CategorySearches = exports.CategorySearches = function CategorySearches(props) {
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      _Typography2.default,
      { component: 'h2', className: props.classes.suggestionHeader },
      'Category searches'
    ),
    _react2.default.createElement(
      'ul',
      { className: props.classes.suggestionsList },
      props.categories.map(function (item) {
        return _react2.default.createElement(
          'li',
          { key: item.id },
          _react2.default.createElement(
            _Link2.default,
            { to: item.url, onClick: props.hidePopup },
            item.name
          )
        );
      })
    )
  );
};

CategorySearches.propTypes = (0, _extends3.default)({}, commonPropTypes, {
  categories: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.string,
    url: _propTypes2.default.string,
    name: _propTypes2.default.string
  }))

  /**
   * Search products suggestions
   * @param props
   * @constructor
   */
});var ProductSuggestions = exports.ProductSuggestions = function ProductSuggestions(props) {
  return _react2.default.createElement(
    _react2.default.Fragment,
    null,
    _react2.default.createElement(
      _Typography2.default,
      { component: 'h2', className: props.classes.suggestionHeader },
      'Product suggestions'
    ),
    _react2.default.createElement(
      'ul',
      { className: props.classes.productsSuggestions },
      props.products.map(function (item) {
        return _react2.default.createElement(
          'li',
          { key: item.id },
          _react2.default.createElement(
            _Link2.default,
            { to: item.url, onClick: props.hidePopup, className: props.classes.productImage },
            _react2.default.createElement(_Image2.default, {
              fill: true,
              src: item.thumbnail,
              alt: item.name })
          ),
          _react2.default.createElement(
            _Link2.default,
            { to: item.url, onClick: props.hidePopup },
            item.name
          )
        );
      })
    )
  );
};

ProductSuggestions.propTypes = (0, _extends3.default)({}, commonPropTypes, {
  products: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.string,
    url: _propTypes2.default.string,
    name: _propTypes2.default.string,
    thumbnail: _propTypes2.default.string
  }))

  /**
   * Search popup model
   */
});var SearchPopupModel = exports.SearchPopupModel = _mobxStateTree.types.model('SearchPopupModel', {
  opened: _mobxStateTree.types.boolean
}).actions(function (self) {
  return {
    setIsPopupOpened: function setIsPopupOpened(status) {
      self.opened = status;
      return self;
    }
  };
});
//# sourceMappingURL=SearchPopup.js.map