'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp2; /**
                                           * @license
                                           * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                           */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactVisibilitySensor = require('react-visibility-sensor');

var _reactVisibilitySensor2 = _interopRequireDefault(_reactVisibilitySensor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      margin: '15px 0',
      width: '100%'
    },
    loading: {
      display: 'flex',
      justifyContent: 'center'
    }
  };
};

/**
 * The ShowMore component controls pagination for views that display a SearchResultsModelBase (specified via the model prop).  
 * This component uses either the total or numberOfPages fields on SearchResultsModelBase to determine whether or not
 * to trigger show more. The default variant is a button with text/contents can be changed by specifying a child (string or components).
 * Or this component can be configured to use infinite scrolling for triggering another page.
 */
var ShowMore = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFShowMore' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(ShowMore, _Component);

  function ShowMore() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ShowMore);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ShowMore.__proto__ || Object.getPrototypeOf(ShowMore)).call.apply(_ref, [this].concat(args))), _this), _this.onVisibilityChange = function (isVisible) {
      if (isVisible) {
        _this.props.model.showMore();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ShowMore, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          app = _props.app,
          Loading = _props.Loading,
          model = _props.model,
          classes = _props.classes,
          className = _props.className,
          children = _props.children,
          infiniteScroll = _props.infiniteScroll,
          offset = _props.offset,
          others = (0, _objectWithoutProperties3.default)(_props, ['app', 'Loading', 'model', 'classes', 'className', 'children', 'infiniteScroll', 'offset']);


      if (model.loadingMore) {
        return _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(classes.loading, classes.root) },
          _react2.default.createElement(Loading, null)
        );
      } else if (model.hasMoreItems) {
        if (infiniteScroll && !app.amp) {
          return _react2.default.createElement(
            _reactVisibilitySensor2.default,
            {
              offset: { bottom: -offset },
              onChange: this.onVisibilityChange
            },
            _react2.default.createElement('div', { style: { width: 1, height: 1 } })
          );
        }
        return _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({
            variant: 'raised',
            color: 'primary',
            href: app.amp ? app.location.pathname.replace(/\.amp/, '') + '?page=1#item-' + model.pageSize : null,
            className: (0, _classnames2.default)(classes.root, className),
            onClick: model.showMore
          }, others),
          children || "Show More"
        );
      } else {
        return null;
      }
    }
  }]);
  return ShowMore;
}(_react.Component), _class2.propTypes = {
  /**
   * A renderer for the loading icon.  Uses CircularPropgress by default
   */
  loading: _propTypes2.default.func,

  /**
   * An instance of `SearchResultModelBase`
   */
  model: _propTypes2.default.object,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * When infiniteScroll is set to true, this prop describes how near to the bottom of the page in pixels the user must scroll before the next page is fetched.
   */
  offset: _propTypes2.default.number,

  /**
   * Set to true to automatically fetch the next page when the user scrolls to the bottom of the page instead of displaying a "Show More" button.
   */
  infiniteScroll: _propTypes2.default.bool
}, _class2.defaultProps = {
  Loading: function Loading() {
    return _react2.default.createElement(_CircularProgress2.default, null);
  },
  offset: 100
}, _temp2)) || _class) || _class) || _class);
exports.default = ShowMore;
//# sourceMappingURL=ShowMore.js.map