'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageSwitcher = exports.Tiles = exports.BlankRow = exports.Content = exports.Space = exports.Row = exports.Skeleton = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _dec, _class, _class2, _temp, _dec2, _class3, _class4, _temp2; /**
                                                                    * @license
                                                                    * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                                                    */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _ResponsiveTiles = require('./ResponsiveTiles');

var _ResponsiveTiles2 = _interopRequireDefault(_ResponsiveTiles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _withStyleProps = require('./withStyleProps');

var _withStyleProps2 = _interopRequireDefault(_withStyleProps);

var _mobxReact = require('mobx-react');

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    row: {
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'stretch'
    },

    blankRow: {
      height: theme.margins.row + 'px'
    },

    space: {
      backgroundColor: 'white',
      width: theme.margins.container + 'px'
    },

    '@keyframes shimmer': {
      from: { backgroundPosition: '-468px 0' },
      to: { backgroundPosition: '468px 0' }
    },

    shimmer: {
      backgroundColor: theme.palette.background.shade,
      animationDuration: '1s',
      animationFillMode: 'forwards',
      animationIterationCount: 'infinite',
      animationName: 'shimmer',
      animationTimingFunction: 'linear',
      background: 'linear-gradient(to right, #eee 8%, #e6e6e6 18%, #eee 33%)',
      backgroundSize: '800px 104px'
    },

    fullscreen: {
      position: 'absolute',
      left: 0,
      right: 0,
      bottom: 0,
      top: theme.headerHeight
    },

    filledContent: {
      backgroundColor: theme.palette.background.paper
    }
  };
};

/**
 * The root component for a skeleton view
 */
var Skeleton = exports.Skeleton = (0, _withStyles2.default)(styles)(function (_ref) {
  var _classnames;

  var classes = _ref.classes,
      children = _ref.children,
      _ref$fullscreen = _ref.fullscreen,
      fullscreen = _ref$fullscreen === undefined ? false : _ref$fullscreen;
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames3.default)((_classnames = {}, (0, _defineProperty3.default)(_classnames, classes.shimmer, true), (0, _defineProperty3.default)(_classnames, classes.fullscreen, fullscreen), _classnames))
    },
    children
  );
});

/**
 * A row of space and content
 */
var Row = (0, _withStyles2.default)(styles)(function (_ref2) {
  var wrap = _ref2.wrap,
      className = _ref2.className,
      classes = _ref2.classes,
      children = _ref2.children,
      style = (0, _objectWithoutProperties3.default)(_ref2, ['wrap', 'className', 'classes', 'children']);
  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames3.default)(classes.row, className),
      style: (0, _extends3.default)({ flexWrap: wrap && 'wrap' }, style)
    },
    children
  );
});

/**
 * White space between content
 */
exports.Row = Row;
var Space = (0, _withStyles2.default)(styles)(function (_ref3) {
  var classes = _ref3.classes,
      style = (0, _objectWithoutProperties3.default)(_ref3, ['classes']);
  return _react2.default.createElement('div', { className: classes.space, style: style });
});

/**
 * A placeholder for content with a gray background that shimmers
 */
exports.Space = Space;
var Content = (0, _withStyles2.default)(styles)(function (_ref4) {
  var children = _ref4.children,
      className = _ref4.className,
      classes = _ref4.classes,
      style = (0, _objectWithoutProperties3.default)(_ref4, ['children', 'className', 'classes']);

  if (children) {
    return _react2.default.createElement(
      'div',
      { className: (0, _classnames3.default)(className, classes.filledContent), style: (0, _extends3.default)({}, style) },
      children
    );
  } else {
    return _react2.default.createElement('div', { className: className, style: (0, _extends3.default)({}, style) });
  }
});

/**
 * A blank row.  You provide the height
 */
exports.Content = Content;
var BlankRow = (0, _withStyles2.default)(styles)(function (_ref5) {
  var classes = _ref5.classes,
      others = (0, _objectWithoutProperties3.default)(_ref5, ['classes']);
  return _react2.default.createElement(
    Row,
    (0, _extends3.default)({ className: classes.blankRow }, others),
    _react2.default.createElement(Space, { flex: 1 })
  );
});

/**
 * When using ResposiveTiles in your view, use this component to replace
 * it in the load mask.
 */
exports.BlankRow = BlankRow;
var Tiles = exports.Tiles = (_dec = (0, _withStyleProps2.default)(function (_ref6) {
  var theme = _ref6.theme,
      spacing = _ref6.spacing;
  return {
    root: {
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderWidth: '0 ' + spacing / 2 + 'px'
    },
    tile: {
      borderStyle: 'solid',
      borderColor: theme.palette.background.paper,
      borderWidth: '0 ' + spacing / 2 + 'px'
    }
  };
}, { name: 'RSFSkeletonTiles' }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Tiles, _Component);

  function Tiles() {
    (0, _classCallCheck3.default)(this, Tiles);
    return (0, _possibleConstructorReturn3.default)(this, (Tiles.__proto__ || Object.getPrototypeOf(Tiles)).apply(this, arguments));
  }

  (0, _createClass3.default)(Tiles, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          spacing = _props.spacing,
          classes = _props.classes,
          className = _props.className,
          children = _props.children,
          others = (0, _objectWithoutProperties3.default)(_props, ['spacing', 'classes', 'className', 'children']);


      return _react2.default.createElement(
        _ResponsiveTiles2.default,
        (0, _extends3.default)({
          spacing: 0,
          className: (0, _classnames3.default)(classes.root, className)
        }, others),
        _react2.default.Children.map(children, function (child, i) {
          return _react2.default.createElement(
            'div',
            { className: classes.tile, key: i },
            child
          );
        })
      );
    }
  }]);
  return Tiles;
}(_react.Component), _class2.propTypes = {
  /**
   * Should be the same as the spacing set on the ResponsiveTiles element
   * that you're replacing.
   */
  spacing: _propTypes2.default.number
}, _temp)) || _class);


Tiles.defaultProps = {
  spacing: 15
};

var ImageSwitcher = exports.ImageSwitcher = (_dec2 = (0, _withStyles2.default)(function (theme) {
  return {
    image: {
      width: '100%'
    }
  };
}), _dec2(_class3 = (0, _mobxReact.observer)(_class3 = (_temp2 = _class4 = function (_Component2) {
  (0, _inherits3.default)(ImageSwitcher, _Component2);

  function ImageSwitcher() {
    (0, _classCallCheck3.default)(this, ImageSwitcher);
    return (0, _possibleConstructorReturn3.default)(this, (ImageSwitcher.__proto__ || Object.getPrototypeOf(ImageSwitcher)).apply(this, arguments));
  }

  (0, _createClass3.default)(ImageSwitcher, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          classes = _props2.classes,
          thumbnails = _props2.thumbnails,
          product = _props2.product,
          loadingThumbnailProps = _props2.loadingThumbnailProps;


      return _react2.default.createElement(
        _react.Fragment,
        null,
        product && product.thumbnail ? _react2.default.createElement(
          Row,
          null,
          _react2.default.createElement(
            Content,
            { flex: '1' },
            _react2.default.createElement(_Image2.default, (0, _extends3.default)({ src: product.thumbnail, className: classes.image }, loadingThumbnailProps, { fill: true }))
          )
        ) : _react2.default.createElement(Row, { className: classes.image }),
        thumbnails ? _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(BlankRow, null),
          _react2.default.createElement(
            Row,
            { height: '58px' },
            _react2.default.createElement(Space, null),
            _react2.default.createElement(Content, { flex: '1' }),
            _react2.default.createElement(Space, null)
          )
        ) : null
      );
    }
  }]);
  return ImageSwitcher;
}(_react.Component), _class4.propTypes = {
  product: _propTypes2.default.object,
  thumbnails: _propTypes2.default.bool,
  loadingThumbnailProps: _propTypes2.default.object
}, _class4.defaultProps = {
  thumbnails: true,
  loadingThumbnailProps: {}
}, _temp2)) || _class3) || _class3);
//# sourceMappingURL=Skeleton.js.map