'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _ActionButton = require('./ActionButton');

var _ActionButton2 = _interopRequireDefault(_ActionButton);

var _Sort = require('./Sort');

var _Sort2 = _interopRequireDefault(_Sort);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Drawer = require('./Drawer');

var _Drawer2 = _interopRequireDefault(_Drawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A button that when clicked, opens a drawer containing the `Sort` view. The name of the currently
 * selected sortOption is display in the button text.
 */
var SortButton = (_dec = (0, _mobxReact.inject)('app'), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(SortButton, _Component);

  function SortButton(_ref) {
    var app = _ref.app;
    (0, _classCallCheck3.default)(this, SortButton);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SortButton.__proto__ || Object.getPrototypeOf(SortButton)).call(this));

    _this.onClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }

      if (!e.defaultPrevented) {
        _this.toggleOpen(true);
      }
    };

    _this.toggleOpen = function (open) {
      if (open) {
        _this.setState({ mountDrawer: true, open: true });
      } else {
        _this.setState({ open: false });
      }
    };

    _this.onSelect = function () {
      _this.toggleOpen(false);
    };

    _this.state = {
      open: app.location.search.indexOf('openSort') !== -1,
      mountDrawer: false
    };
    return _this;
  }

  (0, _createClass3.default)(SortButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          app = _props.app,
          model = _props.model,
          title = _props.title,
          drawerProps = _props.drawerProps,
          props = (0, _objectWithoutProperties3.default)(_props, ['app', 'model', 'title', 'drawerProps']);
      var _state = this.state,
          open = _state.open,
          mountDrawer = _state.mountDrawer;

      var selectedOption = model.sortOptions.find(function (o) {
        return model.sort === o.code;
      });

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(_ActionButton2.default, (0, _extends3.default)({
          key: 'button',
          href: app.amp ? app.location.pathname.replace(/\.amp/, '') + '?openSort' : null,
          label: title,
          value: selectedOption && selectedOption.name
        }, props, {
          onClick: this.onClick
        })),
        !app.amp && _react2.default.createElement(
          _Drawer2.default,
          {
            ModalProps: {
              keepMounted: true
            },
            key: 'drawer',
            anchor: 'bottom',
            title: title,
            open: open,
            onRequestClose: this.toggleOpen.bind(this, false)
          },
          mountDrawer && _react2.default.createElement(_Sort2.default, (0, _extends3.default)({ model: model, onSelect: this.onSelect }, drawerProps))
        )
      );
    }
  }]);
  return SortButton;
}(_react.Component), _class2.propTypes = {
  /**
   * A instance of SearchResultsModelBase
   */
  model: _propTypes2.default.object,

  /**
   * CSS classes
   */
  classes: _propTypes2.default.object,

  /**
   * Props to pass to the underlying `Sort` component.
   */
  drawerProps: _propTypes2.default.object,

  /**
   * Text for the button label and the drawer header.  Defaults to "Sort".
   */
  title: _propTypes2.default.string
}, _class2.defaultProps = {
  title: 'Sort',
  drawerProps: {}
}, _temp)) || _class) || _class);
exports.default = SortButton;
//# sourceMappingURL=SortButton.js.map