'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _reactHelmet = require('react-helmet');

var _Tabs = require('@material-ui/core/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _Tab = require('@material-ui/core/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _mobxReact = require('mobx-react');

var _classnames5 = require('classnames');

var _classnames6 = _interopRequireDefault(_classnames5);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {},
    panel: {
      margin: theme.margins.container + 'px 0'
    },
    hidden: {
      display: 'none'
    },
    ampSelector: {
      '& [option][selected]': {
        outline: 'none',
        cursor: 'inherit'
      }
    },
    ampPanel: {
      display: 'none',
      '&[selected]': {
        display: 'block'
      }
    },
    ampTab: {
      opacity: 1,
      '& .label': {
        borderBottom: '2px solid transparent',
        opacity: 0.7,
        padding: '15px 12px 14px 12px'
      },
      '& .selected': {
        borderBottom: '2px solid ' + theme.palette.secondary.main,
        opacity: 1
      }
    },
    ampTabLabelContainer: {
      padding: 0
    },
    ampTabIndicator: {
      display: 'none'
    }
  };
};

/**
 * A simple tab panel that is AMP-compatible.  Tab names are pull from the label prop of the child elements.  
 * Any type of element can be a child.
 * 
 * Example:
 * 
 *  <TabPanel>
 *    <div label="Description">
 *      Description here
 *    </div>
 *    <CmsSlot label="Instructions">
 *      { instructionsFromCms }
 *    </CmsSlot>
 *  </TabPanel>
 */
var TabPanel = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFTabPanel' }), _dec2 = (0, _mobxReact.inject)('app', 'ampStateId'), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(TabPanel, _Component);

  function TabPanel(props) {
    (0, _classCallCheck3.default)(this, TabPanel);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TabPanel.__proto__ || Object.getPrototypeOf(TabPanel)).call(this, props));

    _this.onChange = function (event, selected) {
      _this.setState({ selected: selected });
    };

    _this.state = {
      selected: props.selected
    };
    return _this;
  }

  (0, _createClass3.default)(TabPanel, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (typeof nextProps.selected === 'number') {
        this.setState({ selected: nextProps.selected });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var selected = this.state.selected;
      var _props = this.props,
          children = _props.children,
          classes = _props.classes,
          app = _props.app,
          ampStateId = _props.ampStateId,
          ampStateProperty = _props.ampStateProperty,
          scrollable = _props.scrollable;
      var amp = app.amp;


      var panels = [];
      var tabs = [];

      _react2.default.Children.forEach(children, function (child, i) {
        var _classnames3;

        var label = child.props.label;


        if (amp) {
          label = _react2.default.createElement(
            'div',
            {
              className: (0, _classnames6.default)('label', { selected: selected === i }),
              'amp-bind': 'class=>' + ampStateId + '.' + ampStateProperty + ' == "tab' + i + '" ? \'label selected\' : \'label\''
            },
            label
          );
        }

        tabs.push(_react2.default.createElement(_Tab2.default, {
          key: i,
          label: label,
          on: 'tap:AMP.setState({ ' + ampStateId + ': { ' + ampStateProperty + ': \'tab' + i + '\' }})',
          classes: {
            root: (0, _classnames6.default)((0, _defineProperty3.default)({}, classes.ampTab, amp)),
            labelContainer: (0, _classnames6.default)((0, _defineProperty3.default)({}, classes.ampTabLabelContainer, amp))
          }
        }));

        panels.push(_react2.default.createElement(
          'div',
          {
            key: i,
            role: 'tabpanel',
            option: 'tab' + i,
            selected: i === selected,
            className: (0, _classnames6.default)(classes.panel, (_classnames3 = {}, (0, _defineProperty3.default)(_classnames3, classes.hidden, !amp && i !== selected), (0, _defineProperty3.default)(_classnames3, classes.ampPanel, amp), _classnames3))
          },
          _react2.default.cloneElement(child, { label: null })
        ));
      });

      if (amp) {
        panels = _react2.default.createElement(
          'amp-selector',
          {
            role: 'tablist',
            'amp-bind': 'selected=>' + ampStateId + '.' + ampStateProperty,
            'class': classes.ampSelector
          },
          panels
        );
      }

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        amp && _react2.default.createElement(
          _reactHelmet.Helmet,
          null,
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-selector', src: 'https://cdn.ampproject.org/v0/amp-selector-0.1.js' }),
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-bind', src: 'https://cdn.ampproject.org/v0/amp-bind-0.1.js' })
        ),
        _react2.default.createElement(
          _Tabs2.default,
          {
            scrollable: scrollable,
            value: selected,
            onChange: this.onChange,
            classes: {
              indicator: (0, _classnames6.default)((0, _defineProperty3.default)({}, classes.ampTabIndicator, amp))
            }
          },
          tabs
        ),
        panels
      );
    }
  }]);
  return TabPanel;
}(_react.Component), _class2.propTypes = {
  /**
   * Set to false to prevent the tabs from scrolling
   */
  scrollable: _propTypes2.default.bool,
  /**
   * Selected tab index
   */
  selected: _propTypes2.default.number
}, _class2.defaultProps = {
  ampStateId: 'moovAmpState',
  ampStateProperty: 'selectedTab',
  scrollable: true,
  selected: 0
}, _temp)) || _class) || _class);
exports.default = TabPanel;
//# sourceMappingURL=TabPanel.js.map