'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _Image = require('./Image');

var _Image2 = _interopRequireDefault(_Image);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _Tabs = require('@material-ui/core/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _Tab = require('@material-ui/core/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    indicator: {
      height: '3px',
      transition: 'left 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms'
    },
    noSelection: {
      visibility: 'hidden'
    },
    root: {
      '& a': {
        textDecoration: 'none',
        color: 'inherit'
      }
    },
    tab: {
      fontWeight: 300,
      height: '100%',
      minWidth: '20px',
      position: 'relative'
    },
    selectedTab: {
      fontWeight: 500,
      opacity: 1
    },
    scroller: {
      '&::-webkit-scrollbar': {
        display: 'none'
      }
    },
    link: {
      display: 'block',
      height: '100%',
      fontSize: theme.typography.body1.fontSize
    },
    centered: {
      '&::before,&::after': {
        display: 'block',
        content: "''",
        flex: 1
      }
    }
  };
};

/**
 * A set of tabs.  Tabs are built from an array of model instances provided via the `items` prop.
 */
var TabsRow = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFTabsRow' }), _dec2 = (0, _mobxReact.inject)('app'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(TabsRow, _Component);

  function TabsRow(props) {
    (0, _classCallCheck3.default)(this, TabsRow);

    var _this = (0, _possibleConstructorReturn3.default)(this, (TabsRow.__proto__ || Object.getPrototypeOf(TabsRow)).call(this, props));

    _this.handleChange = function (event, newValue) {
      _this.setState({
        selectedIdx: newValue
      }, function () {
        if (_this.props.onTabChange) {
          _this.props.onTabChange(event, newValue);
        }
      });
    };

    _this.tabRenderer = function (item) {
      var classes = _this.props.classes;


      return item.url ? _react2.default.createElement(
        _Link2.default,
        { className: classes.link, to: item.url, prefetch: item.prefetch, onClick: _this.onLinkClick },
        item.text
      ) : item.text;
    };

    _this.onLinkClick = function (e) {
      e.preventDefault();
    };

    _this.state = {
      selectedIdx: props.initialSelectedIdx
    };
    return _this;
  }

  (0, _createClass3.default)(TabsRow, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.initialSelectedIdx !== this.initialSelectedIdx) {
        this.setState({
          selectedIdx: nextProps.initialSelectedIdx
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          app = _props.app,
          _props$tabRenderer = _props.tabRenderer,
          tabRenderer = _props$tabRenderer === undefined ? this.tabRenderer : _props$tabRenderer,
          centered = _props.centered,
          items = _props.items,
          classes = _props.classes,
          imageProps = _props.imageProps,
          scrollable = _props.scrollable,
          initialSelectedIdx = _props.initialSelectedIdx,
          onTabChange = _props.onTabChange,
          elevation = _props.elevation,
          tabsProps = (0, _objectWithoutProperties3.default)(_props, ['app', 'tabRenderer', 'centered', 'items', 'classes', 'imageProps', 'scrollable', 'initialSelectedIdx', 'onTabChange', 'elevation']);
      var selectedIdx = this.state.selectedIdx;


      return _react2.default.createElement(
        _Tabs2.default,
        (0, _extends3.default)({
          value: selectedIdx == null ? false : selectedIdx,
          onChange: this.handleChange,
          indicatorColor: 'secondary',
          scrollable: scrollable,
          className: classes.root,
          classes: {
            root: classes.root,
            indicator: (0, _classnames4.default)(classes.indicator, (0, _defineProperty3.default)({}, classes.noSelection, selectedIdx == null)),
            flexContainer: (0, _classnames4.default)((0, _defineProperty3.default)({}, classes.centered, centered)),
            scroller: classes.scroller
          }
        }, tabsProps),
        items.map(function (item, i) {
          var icon = void 0;
          if (item.imageUrl) {
            icon = _react2.default.createElement(_Image2.default, (0, _extends3.default)({
              src: item.imageUrl,
              alt: item.alt
            }, imageProps));

            if (app.amp && item.url) {
              icon = _react2.default.createElement(
                _Link2.default,
                { to: item.url },
                icon
              );
            }
          }

          return _react2.default.createElement(_Tab2.default, {
            key: i,
            label: tabRenderer(item),
            icon: icon,
            classes: {
              root: classes.tab,
              selected: classes.selectedTab
            }
          });
        })
      );
    }
  }]);
  return TabsRow;
}(_react.Component), _class2.propTypes = {
  /**
   * Index of tab that should be selected by default
   */
  initialSelectedIdx: _propTypes2.default.number,

  /**
   * Overridable classes object to allow customization of component
   */
  classes: _propTypes2.default.objectOf(_propTypes2.default.string),

  /**
   * Array of items that should be rendered
   */
  items: _mobxReact.PropTypes.arrayOrObservableArrayOf(_propTypes2.default.shape({
    imageUrl: _propTypes2.default.string,
    alt: _propTypes2.default.string,
    text: _propTypes2.default.string
  })).isRequired,

  /**
   * Props for displayed images. See <Image /> component for details
   */
  imageProps: _propTypes2.default.object,

  /**
   * Material-UI setting to control horizontal scrolling for tabs
   */
  scrollable: _propTypes2.default.bool,

  /**
   * Callback function for tab change
   */
  onTabChange: _propTypes2.default.func,

  /**
   * Set to true to center the tabs
   */
  centered: _propTypes2.default.bool,

  /**
   * A function to override the default rendering of each tab's label.  The function is passed the MenuItem model 
   * corresponding to the item to be rendered.
   */
  tabRenderer: _propTypes2.default.func
}, _class2.defaultProps = {
  items: [],
  scrollable: true,
  centered: false
}, _temp)) || _class) || _class) || _class);
exports.default = TabsRow;
//# sourceMappingURL=TabsRow.js.map