'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


exports.resetId = resetId;
exports.renderAmpAnalyticsTags = renderAmpAnalyticsTags;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _analytics = require('./analytics');

var _analytics2 = _interopRequireDefault(_analytics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nextId = 0;
var ampAnalyticsTypes = {};

/**
 * @private
 * Used to reset the id for repeatable test results.
 */
function resetId() {
  nextId = 0;
}

/**
 * Fires an analytics event when the user interacts with the child component.  By default this fires when the user
 * clicks on the child component, but this can be overriden using the `trigger` prop.  The value of trigger should
 * be the name of the event prop to bind to. All additional props will be passed as options along with the event.
 * 
 * Example:
 * 
 * <Track event="addedToCart" product={this.props.product}>
 *  <Button>Add to Cart</Button>
 * </Track>
 */
var Track = (_dec = (0, _mobxReact.inject)('app'), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Track, _Component);

  function Track() {
    (0, _classCallCheck3.default)(this, Track);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Track.__proto__ || Object.getPrototypeOf(Track)).call(this));

    _this.id = (nextId++).toString();
    return _this;
  }

  (0, _createClass3.default)(Track, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      if (this.props.app.amp) {
        var _props = this.props,
            event = _props.event,
            trigger = _props.trigger,
            app = _props.app,
            children = _props.children,
            onSuccess = _props.onSuccess,
            data = (0, _objectWithoutProperties3.default)(_props, ['event', 'trigger', 'app', 'children', 'onSuccess']);

        this.createAmpTriggers(data);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.attachEvent();
    }

    /**
     * Fires the analytics event asynchronously using setImmediate so as not to 
     * block the render loop.
     */

  }, {
    key: 'fireEvent',
    value: function fireEvent() {
      var _this2 = this;

      var _props2 = this.props,
          event = _props2.event,
          trigger = _props2.trigger,
          app = _props2.app,
          children = _props2.children,
          onSuccess = _props2.onSuccess,
          ampData = _props2.ampData,
          data = (0, _objectWithoutProperties3.default)(_props2, ['event', 'trigger', 'app', 'children', 'onSuccess', 'ampData']);


      setImmediate((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return _analytics2.default[event](data);

              case 2:
                onSuccess();

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      })));
    }

    /**
     * Intecepts the child's event handler prop corresponding to this.props.trigger
     * and returns the cloned child.
     * @return {React.Element}
     */

  }, {
    key: 'attachEvent',
    value: function attachEvent() {
      var _this3 = this;

      var _props3 = this.props,
          amp = _props3.app.amp,
          trigger = _props3.trigger,
          el = _props3.children;


      if (el) {
        var originalHandler = el.props[trigger];

        var props = (0, _extends4.default)({}, el.props, (0, _defineProperty3.default)({}, trigger, function () {
          if (originalHandler) originalHandler.apply(undefined, arguments);
          _this3.fireEvent();
        }));

        if (amp) {
          props['data-amp-id'] = this.id;
          props['data-vars-moov-test'] = 'foo';
        }

        return _react2.default.cloneElement(el, props);
      } else {
        return null;
      }
    }

    /**
     * Creates AMP event trigger objects based on this.props.event
     */

  }, {
    key: 'createAmpTriggers',
    value: function createAmpTriggers(data) {
      var _props4 = this.props,
          event = _props4.event,
          children = _props4.children,
          ampData = _props4.ampData;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {

        for (var _iterator = (0, _analytics.getTargets)()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var target = _step.value;

          var handler = target[event];

          if (handler) {
            var eventData = void 0;

            // Override send to capture the data that would be send instead of trying to send it
            target.send = function (data) {
              return eventData = data;
            };

            // Call the method corresponding to the event name, this should result in a call to send
            handler.call(target, data);

            if (eventData) {
              if (!eventData.trigger && children) {
                // no need to set a selector if we don't have a child element
                // an example of this is pageview events
                eventData.selector = '[data-amp-id="' + this.id + '"]';
              }

              this.configureAmpEvent(target.getAmpAnalyticsType(), (0, _extends4.default)({
                on: eventData.selector ? 'click' : 'visible'
              }, eventData, {
                request: 'event'
              }, ampData));
            } else {
              console.log('WARNING: No data will be sent for the ' + event + ' event when running in AMP because ' + target.constructor.name + ' didn\'t return any data for this event.');
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }

    /**
     * Adds an AMP analytics event trigger
     * @param {String} type An AMP analytics event type, e.g. googleanalytics
     * @param {Object} trigger The trigger descriptor object
     */

  }, {
    key: 'configureAmpEvent',
    value: function configureAmpEvent(type, trigger) {
      var config = ampAnalyticsTypes[type];

      if (!config) {
        config = ampAnalyticsTypes[type] = {
          triggers: []
        };
      }

      config.triggers.push(trigger);
    }
  }]);
  return Track;
}(_react.Component), _class2.propTypes = {
  /**
   * The name of the method to call on all configured analytics targets.
   * For example, "addedToCart".
   */
  event: _propTypes2.default.string.isRequired,

  /**
   * The name of the handler prop on child component to intercept.  Defaults to "onClick"
   */
  trigger: _propTypes2.default.string,

  /**
   * A function to call once the event has been successfully sent by all analytics targets.
   */
  onSuccess: _propTypes2.default.func,

  /**
   * Additional data to send when tracking events in AMP.
   */
  ampData: _propTypes2.default.object
}, _class2.defaultProps = {
  trigger: 'onClick',
  onSuccess: Function.prototype,
  ampData: {}
}, _temp)) || _class);
exports.default = Track;
function renderAmpAnalyticsTags() {
  var result = [];

  for (var type in ampAnalyticsTypes) {
    result.push('<amp-analytics type="' + type + '">' + ('<script type="application/json">' + JSON.stringify(ampAnalyticsTypes[type]) + '</script>') + '</amp-analytics>');
  }

  ampAnalyticsTypes = {};

  return result.join('\n');
}
//# sourceMappingURL=Track.js.map