'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp2; /**
                                    * @license
                                    * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                    */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Snackbar = require('@material-ui/core/Snackbar');

var _Snackbar2 = _interopRequireDefault(_Snackbar);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Close = require('@material-ui/icons/Close');

var _Close2 = _interopRequireDefault(_Close);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    close: {
      width: theme.spacing.unit * 4,
      height: theme.spacing.unit * 4
    }
  };
};

/**
 * A snackbar that automatically displays when a new version of the service worker is available.
 * By default the component only shows when the app is launched from the user's homescreen on android devices.
 * Additonal props are spread to the underlying material-ui Snackbar component
 */
var UpdateNotification = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFUpdateNotification' }), _dec(_class = (_temp2 = _class2 = function (_Component) {
  (0, _inherits3.default)(UpdateNotification, _Component);

  function UpdateNotification() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, UpdateNotification);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = UpdateNotification.__proto__ || Object.getPrototypeOf(UpdateNotification)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      notifyUpdate: false
    }, _this.handleNotifyClose = function () {
      _this.setState({ notifyUpdate: false });
    }, _this.refresh = function () {
      window.location.reload();
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(UpdateNotification, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          message = _props.message,
          classes = _props.classes,
          reloadButtonText = _props.reloadButtonText,
          others = (0, _objectWithoutProperties3.default)(_props, ['message', 'classes', 'reloadButtonText']);
      var notifyUpdate = this.state.notifyUpdate;


      return _react2.default.createElement(_Snackbar2.default, (0, _extends3.default)({
        open: notifyUpdate,
        autoHideDuration: 6000,
        onClose: this.handleNotifyClose,
        message: message,
        action: [_react2.default.createElement(
          _Button2.default,
          { key: 'undo', color: 'secondary', size: 'small', onClick: this.refresh },
          reloadButtonText
        ), _react2.default.createElement(
          _IconButton2.default,
          {
            key: 'close',
            'aria-label': 'Close',
            color: 'inherit',
            className: classes.close,
            onClick: this.handleNotifyClose
          },
          _react2.default.createElement(_Close2.default, null)
        )]
      }, others));
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // published in registerServiceWorker.js
      document.addEventListener('moov-update-available', function () {
        console.log('new service worker installed');
        _this2.setState({ notifyUpdate: true });
      });
    }
  }]);
  return UpdateNotification;
}(_react.Component), _class2.propTypes = {
  /**
   * The message to display
   */
  message: _propTypes2.default.string,

  /**
   * The text for the reload button.
   */
  reloadButtonText: _propTypes2.default.string
}, _class2.defaultProps = {
  message: 'An new version of this app is available.',
  reloadButtonText: 'RELOAD'
}, _temp2)) || _class);
exports.default = UpdateNotification;
//# sourceMappingURL=UpdateNotification.js.map