'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _ExpandLess = require('@material-ui/icons/ExpandLess');

var _ExpandLess2 = _interopRequireDefault(_ExpandLess);

var _ExpandMore = require('@material-ui/icons/ExpandMore');

var _ExpandMore2 = _interopRequireDefault(_ExpandMore);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    accordion: {
      outline: '1px solid ' + theme.palette.divider
    },
    title: {
      backgroundColor: theme.palette.background.paper,
      padding: '12px 16px',
      borderStyle: 'none',
      outlineWidth: 0
    },
    section: {},
    toggle: {
      position: 'absolute',
      right: '18px',
      top: '13px'
    },
    expand: {
      display: 'block',
      'section[expanded] &': {
        display: 'none'
      }
    },
    collapse: {
      display: 'none',
      'section[expanded] &': {
        display: 'block'
      }
    },
    body: {
      backgroundColor: theme.palette.background.paper,
      padding: theme.margins.container + 'px'
    }
  };
};

/**
 * An AMP-compatible expandable section based on amp-accordion.
 */
var AmpExpandableSection = (_dec = (0, _withStyles2.default)(styles, { name: "MoovAmpExpandableSection" }), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpExpandableSection, _Component);

  function AmpExpandableSection() {
    (0, _classCallCheck3.default)(this, AmpExpandableSection);
    return (0, _possibleConstructorReturn3.default)(this, (AmpExpandableSection.__proto__ || Object.getPrototypeOf(AmpExpandableSection)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmpExpandableSection, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          expanded = _props.expanded,
          _props$children = _props.children,
          children = _props$children === undefined ? [] : _props$children,
          title = _props.title,
          ExpandIcon = _props.ExpandIcon,
          CollapseIcon = _props.CollapseIcon;

      var sectionAttributes = {};

      if (expanded) sectionAttributes.expanded = "";

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          _reactHelmet.Helmet,
          null,
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-accordion', src: 'https://cdn.ampproject.org/v0/amp-accordion-0.1.js' })
        ),
        _react2.default.createElement(
          'amp-accordion',
          { 'disable-session-states': true, 'class': classes.accordion },
          _react2.default.createElement(
            'section',
            (0, _extends3.default)({ className: classes.section }, sectionAttributes),
            _react2.default.createElement(
              _Typography2.default,
              { variant: 'subheading', component: 'h3', className: classes.title },
              title,
              _react2.default.createElement(ExpandIcon, { className: (0, _classnames2.default)(classes.toggle, classes.collapse) }),
              _react2.default.createElement(CollapseIcon, { className: (0, _classnames2.default)(classes.toggle, classes.expand) })
            ),
            _react2.default.createElement(
              'div',
              { className: classes.body },
              children
            )
          )
        )
      );
    }
  }]);
  return AmpExpandableSection;
}(_react.Component), _class2.propTypes = {
  /**
   * The title for the header of the expandable section
   */
  title: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

  /**
   * Set to true to expand the panel
   */
  expanded: _propTypes2.default.bool,

  /**
   * The icon to use for collapsed groups
   */
  ExpandIcon: _propTypes2.default.func,

  /**
   * The icon to use for expanded groups
   */
  CollapseIcon: _propTypes2.default.func
}, _class2.defaultProps = {
  expanded: false,
  ExpandIcon: _ExpandMore2.default,
  CollapseIcon: _ExpandLess2.default
}, _temp)) || _class);
exports.default = AmpExpandableSection;
//# sourceMappingURL=AmpExpandableSection.js.map