'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

var _mobxReact = require('mobx-react');

var _LoadMask = require('../LoadMask');

var _LoadMask2 = _interopRequireDefault(_LoadMask);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    mask: {
      display: 'none',
      '.amp-form-submitting &, .moov-amp-form-mask &': {
        display: 'flex'
      }
    }
  };
};

/**
 * An AMP-compatible form.  When not rendering AMP content, this component renders a simple div.
 * This component will automatically cover itself with a modal loading spinner when submitting.
 */
var AmpForm = (_dec = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app,
      nextId = _ref.nextId,
      ampStateId = _ref.ampStateId;
  return { app: app, nextId: nextId, ampStateId: ampStateId };
}), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFAmpForm' }), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpForm, _Component);

  function AmpForm(_ref2) {
    var id = _ref2.id,
        nextId = _ref2.nextId;
    (0, _classCallCheck3.default)(this, AmpForm);

    var _this = (0, _possibleConstructorReturn3.default)(this, (AmpForm.__proto__ || Object.getPrototypeOf(AmpForm)).call(this));

    _this.id = id || nextId();
    return _this;
  }

  (0, _createClass3.default)(AmpForm, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          on = _props.on,
          ampStateId = _props.ampStateId,
          app = _props.app,
          mask = _props.mask,
          classes = _props.classes,
          method = _props.method,
          target = _props.target,
          id = _props.id,
          children = _props.children,
          action = _props.action,
          nextId = _props.nextId,
          others = (0, _objectWithoutProperties3.default)(_props, ['on', 'ampStateId', 'app', 'mask', 'classes', 'method', 'target', 'id', 'children', 'action', 'nextId']);

      var bind = others['amp-bind'];
      var validation = others['custom-validation-reporting'];

      if (app.amp) {
        // add event handler for valid state to display the mask when submitting
        // we do this because the submit event doesn't work when method=get
        if (method.toLowerCase() === 'get' && (validation == null || validation == 'show-first-on-submit')) {
          on = (on ? on + ',' : '') + ('valid:AMP.setState({ ' + ampStateId + ': { ___moov_submitting: true }})');
          bind = (on ? on + ',' : '') + ('class=>' + ampStateId + '.___moov_submitting ? \'moov-amp-form-mask\' : null');
        }

        return _react2.default.createElement(
          _mobxReact.Provider,
          { ampFormId: this.id },
          _react2.default.createElement(
            'form',
            (0, _extends3.default)({
              id: this.id,
              'data-id': this.id,
              method: method,
              target: target
            }, (0, _defineProperty3.default)({}, method === 'post' ? 'action-xhr' : 'action', action), others, {
              on: on,
              'amp-bind': bind
            }),
            _react2.default.createElement(
              _reactHelmet.Helmet,
              null,
              _react2.default.createElement('script', { async: true, 'custom-element': 'amp-form', src: 'https://cdn.ampproject.org/v0/amp-form-0.1.js' })
            ),
            mask && _react2.default.createElement(_LoadMask2.default, { className: classes.mask }),
            children
          )
        );
      } else {
        return _react2.default.createElement(
          'div',
          others,
          children
        );
      }
    }
  }]);
  return AmpForm;
}(_react.Component), _class2.propTypes = {
  /**
   * The id for the amp-form element.  If left blank a unique id will automatically be generated.
   */
  id: _propTypes2.default.string,

  /**
   * The form's action attribute. Defaults to "_top".
   */
  target: _propTypes2.default.string,

  /**
   * The HTTP method to use.  Defaults to "get".
   */
  method: _propTypes2.default.oneOf(['get', 'post']),

  /**
   * Set to false to not show the mask when submitting.  Defaults to true.
   */
  mask: _propTypes2.default.bool
}, _class2.defaultProps = {
  target: '_top',
  method: 'get',
  mask: true
}, _temp)) || _class) || _class);
exports.default = AmpForm;
//# sourceMappingURL=AmpForm.js.map