'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _class, _class2, _temp; /**
                                          * @license
                                          * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                          */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

var _classnames3 = require('classnames');

var _classnames4 = _interopRequireDefault(_classnames3);

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _mobxReact = require('mobx-react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      height: '300px',
      width: '450px',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch',
      position: 'relative',
      '& > *': {
        paddingBottom: 'none'
      },
      '& *[role=button]': {
        borderRadius: '50%',
        opacity: '0.5',
        outline: 'none',
        backgroundColor: 'rgba(0,0,0,0.3)'
      }
    },

    carouselWrap: {
      flex: 1,
      position: 'relative'
    },

    thumbnails: {
      marginTop: '10px',
      whiteSpace: 'nowrap',
      display: 'flex',
      alignItems: 'stretch',
      maxWidth: '100%',
      overflowX: 'auto'
    },

    thumbnailsWrap: {
      display: 'flex',
      margin: 'auto',
      justifyContent: 'flex-start'
    },

    thumbnail: {
      height: '50px',
      width: '50px',
      position: 'relative',
      margin: '0 2px',
      border: 'none',
      outline: 'none',
      background: 'none',
      opacity: 0.7,
      '& img': {
        objectFit: 'contain'
      }
    },

    thumbnailSelected: {
      opacity: 1
    },

    dot: {},
    dots: {},
    dotSelected: {},

    '@global': {
      'amp-lightbox-gallery div[aria-label="Gallery"]': {
        display: 'none'
      }
    }
  };
};

/**
 * An AMP-compatible image switcher with pinch and zoom.
 */
var AmpImageSwitcher = (_dec = (0, _withStyles2.default)(styles, { name: 'RSFAmpImageSwitcher' }), _dec2 = (0, _mobxReact.inject)('nextId', 'ampStateId'), _dec(_class = _dec2(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpImageSwitcher, _Component);

  function AmpImageSwitcher(_ref) {
    var id = _ref.id,
        nextId = _ref.nextId;
    (0, _classCallCheck3.default)(this, AmpImageSwitcher);

    var _this = (0, _possibleConstructorReturn3.default)(this, (AmpImageSwitcher.__proto__ || Object.getPrototypeOf(AmpImageSwitcher)).call(this));

    id = id || nextId();
    _this.id = id || 'moov-image-switcher-' + id;
    _this.ampStateId = 'moovImageSwitcherState' + id;
    return _this;
  }

  (0, _createClass3.default)(AmpImageSwitcher, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          type = _props.type,
          arrows = _props.arrows,
          indicators = _props.indicators,
          ampStateId = _props.ampStateId,
          ampStateProperty = _props.ampStateProperty,
          images = _props.images,
          thumbnails = _props.thumbnails,
          classes = _props.classes,
          className = _props.className;
      var id = this.id;


      return _react2.default.createElement(
        'div',
        { className: (0, _classnames4.default)(className, classes.root) },
        _react2.default.createElement(
          _reactHelmet.Helmet,
          null,
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-carousel', src: 'https://cdn.ampproject.org/v0/amp-carousel-0.1.js' }),
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-lightbox-gallery', src: 'https://cdn.ampproject.org/v0/amp-lightbox-gallery-0.1.js' })
        ),
        _react2.default.createElement(
          'div',
          { className: classes.carouselWrap },
          _react2.default.createElement(
            'amp-carousel',
            {
              controls: arrows ? true : undefined,
              id: id,
              layout: 'fill',
              type: type,
              'amp-bind': 'slide=>' + ampStateId + '.' + ampStateProperty,
              on: 'slideChange:AMP.setState({ ' + ampStateId + ': { ' + ampStateProperty + ': event.index } })'
            },
            images.map(function (_ref2) {
              var src = _ref2.src,
                  alt = _ref2.alt;
              return _react2.default.createElement('amp-img', {
                key: src,
                lightbox: true,
                src: src,
                layout: 'fill',
                alt: alt
              });
            })
          ),
          indicators && _react2.default.createElement(
            'div',
            { className: classes.dots },
            images.map(function (_ref3, i) {
              var src = _ref3.src;
              return _react2.default.createElement('div', {
                key: src,
                'amp-bind': 'class=>' + ampStateId + '.' + ampStateProperty + ' == ' + i + ' ? \'' + classes.dot + ' ' + classes.dotSelected + '\' : \'' + classes.dot + '\'',
                className: (0, _classnames4.default)(classes.dot, (0, _defineProperty3.default)({}, classes.dotSelected, i === 0))
              });
            })
          )
        ),
        thumbnails && thumbnails.length && _react2.default.createElement(
          'div',
          { className: classes.thumbnails },
          _react2.default.createElement(
            'div',
            { className: classes.thumbnailsWrap },
            thumbnails.map(function (_ref4, i) {
              var src = _ref4.src,
                  alt = _ref4.alt;
              return _react2.default.createElement(
                'button',
                {
                  key: src,
                  type: 'button',
                  on: 'tap:AMP.setState({ ' + ampStateId + ': { ' + ampStateProperty + ': ' + i + ' }})',
                  className: classes.thumbnail
                },
                _react2.default.createElement('amp-img', {
                  src: src,
                  alt: alt,
                  layout: 'fill',
                  'amp-bind': 'class=>' + ampStateId + '.' + ampStateProperty + ' == ' + i + ' ? \'' + classes.thumbnail + ' ' + classes.thumbnailSelected + '\' : \'' + classes.thumbnail + '\'',
                  'class': (0, _classnames4.default)(classes.thumbnail, (0, _defineProperty3.default)({}, classes.thumbnailSelected, i === 0))
                })
              );
            })
          )
        )
      );
    }
  }]);
  return AmpImageSwitcher;
}(_react.Component), _class2.propTypes = {
  /**
   * The amp-carousel type.  Can be "slides" or "carousel".  Defaults to "slides".
   */
  type: _propTypes2.default.oneOf(['slides', 'carousel']),

  /**
   * Set to true to display dots indicated which image in the series is selected.  Defaults to false
   */
  indicators: _propTypes2.default.bool,

  /**
   * The property in the amp state to bind to.  Defaults to "selectedImage"
   */
  ampStateProperty: _propTypes2.default.string,

  /**
   * Set to true to display left and right arrows.  Defaults to false
   */
  arrows: _propTypes2.default.bool
}, _class2.defaultProps = {
  type: 'slides',
  indicators: false,
  ampStateProperty: 'selectedImage',
  controls: false
}, _temp)) || _class) || _class);
exports.default = AmpImageSwitcher;
//# sourceMappingURL=AmpImageSwitcher.js.map