'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.styles = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _dec2, _dec3, _class, _class2, _temp; /**
                                                 * @license
                                                 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                                 */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _withStyles = require('@material-ui/core/styles/withStyles');

var _withStyles2 = _interopRequireDefault(_withStyles);

var _withTheme = require('@material-ui/core/styles/withTheme');

var _withTheme2 = _interopRequireDefault(_withTheme);

var _reactHelmet = require('react-helmet');

var _Link = require('../Link');

var _Link2 = _interopRequireDefault(_Link);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ExpandMore = require('@material-ui/icons/ExpandMore');

var _ExpandMore2 = _interopRequireDefault(_ExpandMore);

var _ExpandLess = require('@material-ui/icons/ExpandLess');

var _ExpandLess2 = _interopRequireDefault(_ExpandLess);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = exports.styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      marginTop: theme.headerHeight,
      height: 'calc(100vh - ' + theme.headerHeight + 'px)',
      borderTop: '1px solid ' + theme.palette.divider,
      backgroundColor: theme.palette.background.paper,
      boxShadow: '10px 2px 10px -5px rgba(0, 0, 0, 0.2)',
      paddingBottom: '64px',
      '& h3': {
        backgroundColor: theme.palette.background.paper
      },
      '& section[expanded] > h3': {
        color: theme.palette.secondary.contrastText,
        backgroundColor: theme.palette.secondary.main,
        borderColor: theme.palette.secondary.main
      },
      '& a': {
        color: theme.typography.body1.color
      },
      '& ~ div[class*="amphtml-sidebar-mask"]': {
        background: 'rgba(0, 0, 0, 0.5)',
        opacity: 1
      }
    },
    item: {
      padding: '12px 16px',
      borderColor: theme.palette.divider,
      borderWidth: '0 0 1px 0',
      borderStyle: 'solid',
      display: 'block',
      textDecoration: 'none'
    },
    group: {
      textTransform: 'uppercase'
    },
    toggle: {
      position: 'absolute',
      right: '18px',
      top: '10px'
    },
    expand: {
      display: 'block',
      'section[expanded] > h3 > &': {
        display: 'none'
      }
    },
    collapse: {
      display: 'none',
      'section[expanded] > h3 > &': {
        display: 'block'
      }
    }
  };
};

/**
 * An AMP-compatible menu based on amp-sidebar.
 */
var AmpMenu = (_dec = (0, _withTheme2.default)(), _dec2 = (0, _withStyles2.default)(styles, { name: 'RSFAmpMenu' }), _dec3 = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { menu: app.menu };
}), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpMenu, _Component);

  function AmpMenu() {
    (0, _classCallCheck3.default)(this, AmpMenu);
    return (0, _possibleConstructorReturn3.default)(this, (AmpMenu.__proto__ || Object.getPrototypeOf(AmpMenu)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmpMenu, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          id = _props.id,
          menu = _props.menu,
          classes = _props.classes,
          drawerWidth = _props.drawerWidth,
          rootHeader = _props.rootHeader,
          rootFooter = _props.rootFooter;

      var root = menu.levels[0];

      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          _reactHelmet.Helmet,
          { key: 'helmet' },
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-sidebar', src: 'https://cdn.ampproject.org/v0/amp-sidebar-0.1.js' }),
          _react2.default.createElement('script', { async: true, 'custom-element': 'amp-accordion', src: 'https://cdn.ampproject.org/v0/amp-accordion-0.1.js' }),
          _react2.default.createElement(
            'style',
            { 'amp-custom': true },
            '\n            #' + id + ' {\n              width: ' + drawerWidth + 'px;\n            }\n          '
          )
        ),
        _react2.default.createElement(
          'amp-sidebar',
          { key: 'sidebar', id: id, 'class': classes.root, layout: 'nodisplay' },
          rootHeader,
          this.renderItem(root),
          rootFooter
        )
      );
    }
  }, {
    key: 'renderItem',
    value: function renderItem(item, key) {
      if (item == null) {
        return null;
      } else if (item.items) {
        return this.renderGroup(item, key);
      } else {
        return this.renderLeaf(item, key);
      }
    }
  }, {
    key: 'renderGroup',
    value: function renderGroup(item, key) {
      var _this2 = this;

      var _props2 = this.props,
          classes = _props2.classes,
          ExpandIcon = _props2.ExpandIcon,
          CollapseIcon = _props2.CollapseIcon,
          theme = _props2.theme;


      ExpandIcon = ExpandIcon || theme.ExpandIcon || _ExpandMore2.default;
      CollapseIcon = CollapseIcon || theme.CollapseIcon || _ExpandLess2.default;

      var section = _react2.default.createElement(
        'section',
        { key: key },
        item.text && _react2.default.createElement(
          _Typography2.default,
          {
            variant: 'body1',
            component: 'h3',
            className: (0, _classnames2.default)(classes.item, classes.group)
          },
          item.text,
          _react2.default.createElement(CollapseIcon, { className: (0, _classnames2.default)(classes.toggle, classes.collapse) }),
          _react2.default.createElement(ExpandIcon, { className: (0, _classnames2.default)(classes.toggle, classes.expand) })
        ),
        _react2.default.createElement(
          'div',
          null,
          item.items.map(function (item, i) {
            return _this2.renderItem(item, i);
          })
        )
      );

      if (item.root) {
        return section;
      } else {
        return _react2.default.createElement(
          'amp-accordion',
          { key: key, 'disable-session-states': true },
          section
        );
      }
    }
  }, {
    key: 'renderLeaf',
    value: function renderLeaf(item, key) {
      return _react2.default.createElement(
        _Link2.default,
        {
          key: key,
          className: this.props.classes.item,
          to: item.url
        },
        item.text
      );
    }
  }]);
  return AmpMenu;
}(_react.Component), _class2.defaultProps = {
  id: 'moov_menu'
}, _temp)) || _class) || _class) || _class);
exports.default = AmpMenu;
//# sourceMappingURL=AmpMenu.js.map