'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp; /**
                                   * @license
                                   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
                                   */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _mobxReact = require('mobx-react');

var _reactHelmet = require('react-helmet');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * A container that initialize amp state to be consumed by child components.  Components that support AMP functionality
 * like QuantitySelector and TapPanel must be inside an AmpState element.
 */
var AmpState = (_dec = (0, _mobxReact.inject)(function (_ref) {
  var app = _ref.app;
  return { amp: app.amp };
}), _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(AmpState, _Component);

  function AmpState() {
    (0, _classCallCheck3.default)(this, AmpState);
    return (0, _possibleConstructorReturn3.default)(this, (AmpState.__proto__ || Object.getPrototypeOf(AmpState)).apply(this, arguments));
  }

  (0, _createClass3.default)(AmpState, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          id = _props.id,
          amp = _props.amp,
          initialState = _props.initialState,
          children = _props.children;


      return _react2.default.createElement(
        _mobxReact.Provider,
        { ampStateId: id },
        amp ? _react2.default.createElement(
          _react.Fragment,
          null,
          _react2.default.createElement(
            _reactHelmet.Helmet,
            null,
            _react2.default.createElement('script', { async: true, 'custom-element': 'amp-bind', src: 'https://cdn.ampproject.org/v0/amp-bind-0.1.js' })
          ),
          _react2.default.createElement(
            'amp-state',
            { id: id },
            _react2.default.createElement('script', {
              type: 'application/json',
              dangerouslySetInnerHTML: { __html: JSON.stringify(initialState.toJSON ? initialState.toJSON() : initialState) }
            })
          ),
          children
        ) : _react2.default.createElement(
          _react.Fragment,
          null,
          children
        )
      );
    }
  }]);
  return AmpState;
}(_react.Component), _class2.propTypes = {
  /**
   * The initial values for the amp-state.  Defaults to `{}`
   */
  initialState: _propTypes.PropTypes.object,

  /**
   * An id for the root amp state object. Defaults to "moovAmpState".
   */
  id: _propTypes.PropTypes.string
}, _class2.defaultProps = {
  initialState: {},
  id: 'moovAmpState'
}, _temp)) || _class);
exports.default = AmpState;
//# sourceMappingURL=AmpState.js.map