'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = withAmp;

var _mobxReact = require('mobx-react');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * An HOC that links the AMP equivalent of the current page by adding the ink rel="amphtml" 
 * tag to the document head. Assign this to all views for which AMP is implemented
 * 
 * Example:
 * 
 *  import React, { Component } from 'react'
 *  import withAmp from 'react-storefront/amp/withAmp'
 * 
 *  @withAmp
 *  export default class Product extends Component {
 *    ...
 *  }
 * 
 * @param {React.Component} WrappedComponent The component to add
 * @return {React.Component}
 */
function withAmp(WrappedComponent) {
  var _dec, _class;

  var WithAmp = (_dec = (0, _mobxReact.inject)('app', 'history'), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
    (0, _inherits3.default)(WithAmp, _Component);

    function WithAmp(props) {
      (0, _classCallCheck3.default)(this, WithAmp);
      return (0, _possibleConstructorReturn3.default)(this, (WithAmp.__proto__ || Object.getPrototypeOf(WithAmp)).call(this, props));
    }

    (0, _createClass3.default)(WithAmp, [{
      key: 'render',
      value: function render() {
        var _props$app$location = this.props.app.location,
            pathname = _props$app$location.pathname,
            search = _props$app$location.search,
            hostname = _props$app$location.hostname;
        var amp = this.props.app.amp;


        return _react2.default.createElement(
          _react.Fragment,
          null,
          !amp && _react2.default.createElement(
            _reactHelmet.Helmet,
            { key: 'amp' },
            _react2.default.createElement('link', { rel: 'amphtml', href: 'https://' + hostname + pathname + '.amp' + search })
          ),
          _react2.default.createElement(WrappedComponent, (0, _extends3.default)({ key: 'component' }, this.props))
        );
      }
    }]);
    return WithAmp;
  }(_react.Component)) || _class) || _class);


  return WithAmp;
} /**
   * @license
   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
   */
//# sourceMappingURL=withAmp.js.map