'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createTheme;

var _styles = require('@material-ui/core/styles');

var _lodash = require('lodash');

var _green = require('@material-ui/core/colors/green');

var _green2 = _interopRequireDefault(_green);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createTheme() {
  var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var config = {};

  (0, _lodash.merge)(config, {
    palette: {
      // The colors for the Add to Cart and Checkout buttons
      addToCart: {
        background: _green2.default[500],
        contrastText: 'white'
      }
    },

    margins: {
      // vertical margin on Container component
      container: 15,

      // horizontal margin on Row component
      row: 15
    },

    zIndex: {
      amp: {
        // the z-index for modals in amp
        modal: 2147483646
      }
    },

    // The height of the app header
    headerHeight: 64,

    // Override the icon for all expanders in collapsed state - this should be a React component class, for example @material-ui/icons/Add
    ExpandIcon: null,

    // Override the icon for all expanders in expanded state - this should be a React component classm for example @material-ui/icons/Remove
    CollapseIcon: null
  }, values);

  var theme = (0, _styles.createMuiTheme)(config);

  if (!theme.maxWidth) {
    theme.maxWidth = theme.breakpoints.values.lg + 'px';
  }

  return theme;
} /**
   * @license
   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
   */
//# sourceMappingURL=createTheme.js.map