"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mobxStateTree = require("mobx-state-tree");

var _SubcategoryModelBase = require("./SubcategoryModelBase");

var _SubcategoryModelBase2 = _interopRequireDefault(_SubcategoryModelBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
var CategoryModelBase = _mobxStateTree.types.model("CategoryModelBase", {
  id: _mobxStateTree.types.identifier(_mobxStateTree.types.string),
  url: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  name: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  description: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  subcategories: _mobxStateTree.types.optional(_mobxStateTree.types.array(_SubcategoryModelBase2.default), [])
}).views(function (self) {
  return {
    shouldApplyPatchOnPop: function shouldApplyPatchOnPop(patch) {
      return patch.page === 'Category';
    }
  };
});

exports.default = CategoryModelBase;
//# sourceMappingURL=CategoryModelBase.js.map