"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mobxStateTree = require("mobx-state-tree");

var OptionModelBase = _mobxStateTree.types.model("OptionModelBase", {
  /**
   * Used to identify the option.  This is the value sent to analytics.
   */
  id: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  /**
   * The string to display to the user
   */
  text: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  /**
   * Set to true to prevent the option from being selected
   */
  disabled: false,
  /**
   * A URL for an image to display
   */
  image: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  /**
   * A CSS color value to display when an image is not available
   */
  color: _mobxStateTree.types.maybe(_mobxStateTree.types.string),
  /**
   * The item price for the option.
   */
  price: _mobxStateTree.types.maybe(_mobxStateTree.types.number)
}); /**
     * @license
     * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
     */
exports.default = OptionModelBase;
//# sourceMappingURL=OptionModelBase.js.map