"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _mobxStateTree = require("mobx-state-tree");

var _OptionModelBase = require("./OptionModelBase");

var _OptionModelBase2 = _interopRequireDefault(_OptionModelBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
var SelectionModelBase = _mobxStateTree.types.model("SelectionModelBase", {
  /**
   * All available options.
   */
  options: _mobxStateTree.types.optional(_mobxStateTree.types.array(_OptionModelBase2.default), []),
  /**
   * The selected option
   */
  selected: _mobxStateTree.types.maybe(_OptionModelBase2.default)
}).actions(function (self) {
  return {
    /**
     * Updates the selected option
     * @param {OptionModelBase} option The option to select
     */
    setSelected: function setSelected(option) {
      if (option) {
        self.selected = (0, _mobxStateTree.clone)(option);
      } else {
        self.selected = null;
      }
    }
  };
});

exports.default = SelectionModelBase;
//# sourceMappingURL=SelectionModelBase.js.map