'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.default = createRequest;

var _getHeaders = require('./getHeaders');

var _getHeaders2 = _interopRequireDefault(_getHeaders);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Creates a request object for route handlers from the moovjs environment.
 * @return {Object}
 */
function createRequest() {
  var _env$path$split = env.path.split(/\?/),
      _env$path$split2 = (0, _slicedToArray3.default)(_env$path$split, 2),
      pathname = _env$path$split2[0],
      search = _env$path$split2[1];

  return {
    sendResponse: global.sendResponse,
    body: global.requestBody,
    headers: env.headers ? JSON.parse(env.headers) : (0, _getHeaders2.default)(),
    pathname: pathname,
    search: search ? '?' + search : '',
    method: env.method,
    port: env.host.split(/:/)[1] || (env.secure ? '443' : '80'),
    hostname: env.host_no_port,
    protocol: env.host_no_port === 'localhost' ? 'http:' : env.secure ? 'https:' : 'http:',
    get path() {
      console.warn('warning: request.path is deprecated and will be removed in a future version of react-storefront');
      return env.path;
    }
  };
} /**
   * @license
   * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
   */
//# sourceMappingURL=createRequest.js.map