'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = proxyUpstream;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
// The default callback used when none is provided.  Simply returns the upstream HTML unaltered.
var perfectProxy = function perfectProxy(_params, _request, response) {
  return response.send();
};

/**
 * A handler that fetches HTML from the same path as the current request on the upstream site. Use
 * this handler to transform HTML from the upstream site or return it unaltered.
 *   
 * The callback you provide is passed the following arguments:
 * 
 * params {Object} Request parameters parsed from the route and query string
 * request {Object} An object representing the request
 * response {Response} An object representing the response.  Call response.send(html) to send the resulting html back to the browser.
 * 
 * To use response from the upstream site unaltered, called response.send() with no arguments.
 * 
 * @param {Function} cb A callback which takes params, request, and response.
 */
function proxyUpstream() {
  var _this = this;

  var cb = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : perfectProxy;

  return {
    type: 'proxyUpstream',
    runOn: {
      server: true,
      client: true
    },
    fn: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(params, request, response) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(process.env.MOOV_RUNTIME === 'client')) {
                  _context.next = 4;
                  break;
                }

                // reload the page if this handler is called during client-side navigation
                window.moov.router.reloadFromServer();
                _context.next = 12;
                break;

              case 4:
                if (!(cb == null)) {
                  _context.next = 6;
                  break;
                }

                throw new Error('You must provide a path to a handler in proxyUpstream().  Please check your routes.');

              case 6:
                _context.next = 8;
                return cb(params, request, response);

              case 8:
                _context.t0 = _context.sent;

                if (_context.t0) {
                  _context.next = 11;
                  break;
                }

                _context.t0 = { proxyUpstream: true };

              case 11:
                return _context.abrupt('return', _context.t0);

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }));

      return function fn(_x2, _x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }()
  };
}
//# sourceMappingURL=proxyUpstream.js.map