'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
/**
 * When doing SSR, returns globalState and localState merged.  When responding to an AJAX
 * request, only returns localState.
 * 
 * Example:
 * 
 *  function productHandler({ id }, state, request) {
 *    const product = {} // get product info from upstream API
 *    const globalState = () => fetchMenuData() // async function that makes an api call to get menu data.  Will only be called during ssr
 *    return withGlobalState(request, globalState, product)
 *  }
 * 
 * @param {Object} request The request object passed into the handler
 * @param {Object/Function} globalState An object containing data that is needed for all landing pages, such as menu items, navigation, etc..., or a function that returns this data.
 * @param {Object} localState The state being returned for the specific URL being handled
 * @return {Object}
 */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(request, globalState, localState) {
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!request.pathname.endsWith('.json')) {
              _context.next = 4;
              break;
            }

            return _context.abrupt('return', localState);

          case 4:
            if (!(typeof globalState === 'function')) {
              _context.next = 8;
              break;
            }

            _context.next = 7;
            return globalState();

          case 7:
            globalState = _context.sent;

          case 8:
            return _context.abrupt('return', (0, _extends3.default)({}, globalState, localState));

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function withGlobalState(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  }

  return withGlobalState;
}();
//# sourceMappingURL=withGlobalState.js.map