"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearTestCache = clearTestCache;
exports.isSafari = isSafari;
/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
var _isSafari = null;

/**
 * Clears cached results.  Only needed for unit testing.
 * @private
 */
function clearTestCache() {
  _isSafari = null;
}

/**
 * Returns true only in Safari
 * @return {Boolean}
 */
function isSafari() {
  if (_isSafari == null) {
    _isSafari = /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
  }
  return _isSafari;
}
//# sourceMappingURL=browser.js.map