'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = dataProps;
/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
/**
 * Returns an object containing the values from props corresponding to keys that start with "data-"
 * @param {Object} props 
 * @return {Object}
 */
function dataProps(props) {
  var result = {};

  for (var name in props) {
    if (name.startsWith('data-')) {
      result[name] = props[name];
    }
  }

  return result;
}
//# sourceMappingURL=dataProps.js.map